<?php
add_action( 'cmb2_admin_init', 'h5vp_quick_mb' );
function h5vp_quick_mb() {

	$prefix = '_h5vp_';

	/**
	 * quick metabox 
	 */
	$h5vp_quick_meta = new_cmb2_box( array(
		'id'            => $prefix . 'metabox2',
		'title'         => __( 'Quick Player' ),
		'object_types'  => array( 'videoplayer_quick', ), // Post type
		// 'show_on_cb' => 'yourprefix_show_if_front_page', // function should return a bool value
		// 'context'    => 'normal',
		// 'priority'   => 'high',
		// 'show_names' => true, // Show field names on the left
		// 'cmb_styles' => false, // false to disable the CMB stylesheet
		// 'closed'     => true, // true to keep the metabox closed by default
	) );


	$h5vp_quick_meta->add_field( array(
		'name' => __( 'Video', 'cmb2' ),
		'desc' => __( 'Select an Mp4 or Ogg video file. Or Paste a external video file link', 'cmb2' ),
		'id'   => $prefix . 'default_video',
		'type' => 'file',
		'repeatable' => true,	
		'text' => array(
		'add_row_text' => 'Add Another Special Row',
		),		
	) );
	$h5vp_quick_meta->add_field( array(
		'name' => __( 'Poster Image', 'cmb2' ),
		'desc' => __( 'Specifies an image to be shown while the video is downloading, or until the user hits the play button', 'cmb2' ),
		'id'   => $prefix . 'video_poster',
		'type' => 'file',
	) );	
	$blog_group_id = $h5vp_quick_meta->add_field( array(
		'id'          => 'quality_group',
		'type'        => 'group',
		'repeatable'  => true,
		'desc' => "Enable video quality switcher By Putting videos of different quality, Leave blank if you don't want the quality switcher in the player.",
		
		'options'     => array(
			'group_title'   => 'Quality {#}',
			'add_button'    => 'Add new Quality',
			'remove_button' => 'Remove Quality',
			'closed'        => true,  // Repeater fields closed by default - neat & compact.
			'sortable'      => true,  // Allow changing the order of repeated groups.
		),
	) );
	$h5vp_quick_meta->add_group_field( $blog_group_id, array(
		'name' => 'Video',
		'desc' => 'Select an Mp4 or Ogg video file Or Paste a external video file link',
		'id'   => 'video_file',
		'type' => 'file',
	) );
	$h5vp_quick_meta->add_group_field( $blog_group_id, array(
		'name' => 'Size',
		'desc' => 'Enter the Video Size, eg: 240 , 360 , 480 , 720, 1080, 2160 .',
		'id'   => 'size',
		'type' => 'text_number',
		'attributes'  => array(
		'placeholder' => '1080',
	)		
	) );

	$captions_group_id = $h5vp_quick_meta->add_field( array(
		'id'          => 'caption_group',
		'type'        => 'group',
		'repeatable'  => true,
		'desc' => "You can Set single or mulitple Subtitle, Leave blank if you don't want to use subtitle.",
		
		'options'     => array(
			'group_title'   => 'Subtitle {#}',
			'add_button'    => 'Add new Subtitle',
			'remove_button' => 'Remove Subtitle',
			'closed'        => true,  // Repeater fields closed by default - neat & compact.
			'sortable'      => true,  // Allow changing the order of repeated groups.
		),
	) );
	$h5vp_quick_meta->add_group_field( $captions_group_id, array(
		'name' => 'Subtitle File',
		'desc' => '.vtt file only, select a .vtt file or Paste .vtt file link.',
		'id'   => 'caption_file',
		'type' => 'file',
	) );
	$h5vp_quick_meta->add_group_field( $captions_group_id, array(
		'name' => 'Size',
		'desc' => 'Eg: English, French etc. This will be used as a identifire in the subtitle switcher when multiple subtitle will be set.',
		'id'   => 'label',
		'type' => 'text',
		'attributes'  => array(
		'placeholder' => 'English',
	)		
	) );		


	
}