<?php 
/*
 * Plugin Name: Html5 Video Player PRO
 * Plugin URI:  https://bplugins.com/html5-video-player-pro/
 * Description: You can easily integrate html5 Video player in your wordress website using this plugin.
 * Version:     1.6
 * Author:      bPlugins
 * Author URI:  http://bplugins.com
 * License:     GPLv3
 */
 
/*Some Set-up*/
define('H5VP_PLUGIN_DIR', WP_PLUGIN_URL . '/' . plugin_basename( dirname(__FILE__) ) . '/' ); 
define('H5VP_VER','1.6' ); 

/* JS*/
if ( ! function_exists( 'h5vp_get_script' ) ) :
function h5vp_get_script(){    
    wp_register_style( 'h5vp-style', plugin_dir_url( __FILE__ ) . 'public/css/h5vp.css', array(),H5VP_VER, 'all' );
	wp_register_script( 'h5vp-js', plugin_dir_url( __FILE__ ) . 'public/js/h5vp.js', array('jquery'), H5VP_VER , false );
    wp_register_script( 'h5vp-hls-js', plugin_dir_url( __FILE__ ) . 'public/js/hls.js', array('jquery'), H5VP_VER , false );
    wp_register_script( 'h5vp-shaka-js', plugin_dir_url( __FILE__ ) . 'public/js/shaka.js', array('jquery'), H5VP_VER , false );



wp_enqueue_style('h5vp-style');
wp_enqueue_script('h5vp-js');


}

endif;
add_action('init','h5vp_get_script' );


/**
 * Enqueue a script in the WordPress admin 
 *
 * @param int $hook Hook suffix for the current admin page.
 */
add_action('admin_enqueue_scripts', 'h5vp_codemirror_enqueue_scripts');
 
function h5vp_codemirror_enqueue_scripts($hook) {
	if ('settings_page_html5vp_settings'==$hook){
	$cm_settings['codeEditor'] = wp_enqueue_code_editor(array('type' => 'text/css'));
	wp_localize_script('jquery', 'cm_settings', $cm_settings);
	wp_enqueue_script('wp-theme-plugin-editor');
	wp_enqueue_style('wp-codemirror');
	wp_enqueue_script('h5vp-codemirror', H5VP_PLUGIN_DIR.'admin/js/codemirror-init.js', array('jquery'), H5VP_VER, true); 
	}
}




/*-------------------------------------------------------------------------------*/
/*   Register Custom Post Types
/*-------------------------------------------------------------------------------*/	   
add_action( 'init', 'h5vp_create_post_type' );
function h5vp_create_post_type() {
	register_post_type( 'videoplayer',
		array(
				'labels' => array(
						'name' => __( 'Html5 Video Player'),
						'singular_name' => __( 'Video Player' ),
						'add_new' => __( 'Add New Player' ),
						'add_new_item' => __( 'Add New Player' ),
						'edit_item' => __( 'Edit Player' ),
						'new_item' => __( 'New Player' ),
						'view_item' => __( 'View Player' ),
						'search_items'       => __( 'Search Player'),
						'not_found' => __( 'Sorry, we couldn\'t find the Player you are looking for.' )
				),
		'public' => false,
		'show_ui' => true, 									
		'publicly_queryable' => true,
		'exclude_from_search' => true,
		'menu_position' => 14,
		'menu_icon' =>H5VP_PLUGIN_DIR .'admin/img/icn.png',
		'has_archive' => false,
		'hierarchical' => false,
		'capability_type' => 'page',
		'rewrite' => array( 'slug' => 'videoplayer' ),
		'supports' => array( 'title' )
		)
	);
	register_post_type( 'videoplayer_quick',
		array(
				'labels' => array(
						'name' => __( 'Quick Player'),
						'singular_name' => __( 'Quick Player' ),
						'add_new' => __( 'New Quick Player' ),
						'add_new_item' => __( 'Add New Quick Player' ),
						'edit_item' => __( 'Edit Player' ),
						'new_item' => __( 'New Quick Player' ),
						'view_item' => __( 'View Player' ),
						'search_items'       => __( 'Search Player'),
						'not_found' => __( 'Sorry, we couldn\'t find the Player you are looking for.' )
				),
		'public' => false,
		'show_ui' => true, 									
		'publicly_queryable' => true,
		'exclude_from_search' => true,
		'menu_position' => 14,
		'show_in_menu' => 'edit.php?post_type=videoplayer',		
		'has_archive' => false,
		'hierarchical' => false,
		'capability_type' => 'page',
		'rewrite' => array( 'slug' => 'videoplayer' ),
		'supports' => array( 'title' )
		)
	);	
}	

// Quick Shortcode
add_action('admin_notices','h5vp_quick_shortcode');
function h5vp_quick_shortcode(){
    $screen = get_current_screen();
    //If not on the screen with ID 'edit-post' abort.
    if( $screen->id !='edit-videoplayer_quick' )
        return;
      ?>
		<div class="notice notice-success">
			<b style="font-size:16px;"><?php echo __('Introducing QUICK ','h5ap'); ?> </b>
			<p style="font-size:12px;margin:0;"><?php echo __('We designed QUICK modules (Quick ShortCode and Quick Player) to save your time! You can easily Create Player with Predefined Configuration with Quick Player. Also You can Use the Quick ShortCode module below to Embed a player with predefined Configuration.','h5ap'); ?></p>   
			<b><?php echo __('Quick ShortCode ','h5ap'); ?></b>
			<p style="font-size:12px;margin:0;"><?php echo __('Use the shortcode format below to embed a player anywhere. Replace the value of file attribute with your video file URL.','h5ap'); ?>
			</p>
			<input class="widefat" onclick="this.select();" value='[video_player file="video_file_url_here"]'>
			<p style="font-size:12px;margin:2px;" ><?php echo __('You can change the options of Quick Player/ShortCode','h5ap'); ?> <a class="button button-primary" href="options-general.php?page=html5vp_settings">Here</a></p>
		</div>	

     <?php
 }	
			
/*-------------------------------------------------------------------------------*/
/*   INC
/*-------------------------------------------------------------------------------*/			
include_once('admin/cmb2/init.php');
include_once('admin/cmb2/example-functions.php');
include_once('admin/cmb2/quick-metabox.php');
//include_once('admin/cmb2/options.php');
include_once('admin/class.settings-api.php');
include_once('admin/fields.php');
include_once('inc/shortCode.php');

/*-------------------------------------------------------------------------------*/
/*   Hide & Disabled View, Quick Edit and Preview Button
/*-------------------------------------------------------------------------------*/
function h5vp_remove_row_actions( $idtions ) {
	global $post;
    if( $post->post_type == 'videoplayer' or $post->post_type == 'videoplayer_quick' ) {
		unset( $idtions['view'] );
		unset( $idtions['inline hide-if-no-js'] );
	}
    return $idtions;
}

if ( is_admin() ) {
add_filter( 'post_row_actions','h5vp_remove_row_actions', 10, 2 );}

/*-------------------------------------------------------------------------------*/
/* HIDE everything in PUBLISH metabox except Move to Trash & PUBLISH button
/*-------------------------------------------------------------------------------*/

function h5vp_hide_publishing_actions(){
        global $post;
        if($post->post_type == 'videoplayer' or  $post->post_type=='videoplayer_quick'){
            echo '
                <style type="text/css">
                    #misc-publishing-actions,
                    #minor-publishing-actions{
                        display:none;
                    }
                </style>
            ';
        }
}
add_action('admin_head-post.php', 'h5vp_hide_publishing_actions');
add_action('admin_head-post-new.php', 'h5vp_hide_publishing_actions');	

/*-------------------------------------------------------------------------------*/
/* change publish button to save.
/*-------------------------------------------------------------------------------*/
 
add_filter( 'gettext', 'h5vp_change_publish_button', 10, 2 );

function h5vp_change_publish_button( $translation, $text ) {
if ( 'videoplayer' == get_post_type() or 'videoplayer_quick' == get_post_type())
if ( $text == 'Publish' )
    return 'Save';

return $translation;
}

/*-------------------------------------------------------------------------------*/
/* Remove post update massage and link 
/*-------------------------------------------------------------------------------*/

function h5vp_updated_messages( $messages ) {
    $messages['videoplayer'][1] = __('Updated ');
    return $messages;
}
add_filter('post_updated_messages','h5vp_updated_messages');

function h5vp_quick_updated_messages( $messages ) {
    $messages['videoplayer_quick'][1] = __('Updated ');
    return $messages;
}
add_filter('post_updated_messages','h5vp_quick_updated_messages');



// ONLY MOVIE CUSTOM TYPE POSTS
add_filter('manage_videoplayer_posts_columns', 'h5vp_columns_head_only_videoplayer', 10);
add_action('manage_videoplayer_posts_custom_column', 'h5vp_columns_content_only_videoplayer', 10, 2);
 
// CREATE TWO FUNCTIONS TO HANDLE THE COLUMN
function h5vp_columns_head_only_videoplayer($defaults) {
	unset($defaults['date']);
    $defaults['directors_name'] = 'ShortCode';
    $defaults['date'] = 'Date';
    return $defaults;
}
function h5vp_columns_content_only_videoplayer($column_name, $post_ID) {
    if ($column_name == 'directors_name') {
        // show content of 'directors_name' column
		echo '<input style="text-align: center; border: none; outline: none; background-color: #1e8cbe; color: #fff; padding: 4px 10px; border-radius: 3px;" onClick="this.select();" value="[video id='. $post_ID . ']" >';
    }
}

// ONLY MOVIE CUSTOM TYPE POSTS
add_filter('manage_videoplayer_quick_posts_columns', 'h5vp_columns_head_videoplayer', 10);
add_action('manage_videoplayer_quick_posts_custom_column', 'h5vp_columns_content_videoplayer', 10, 2);
 
// CREATE TWO FUNCTIONS TO HANDLE THE COLUMN
function h5vp_columns_head_videoplayer($defaults) {
    $defaults['directors_name'] = 'ShortCode';
    return $defaults;
}
function h5vp_columns_content_videoplayer($column_name, $post_ID) {
    if ($column_name == 'directors_name') {
        // show content of 'directors_name' column
		echo '<input  onClick="this.select();" value="[video_player id='. $post_ID . ']" >';
    }
}
/*-------------------------------------------------------------------------------*/
/* TinyMce
/*-------------------------------------------------------------------------------*/
require_once( 'tinymce/h5vp-tinymce.php' );

// Settings Menu

add_action('admin_menu', 'h5vp_add_custom_settings_link_into_cpt_menu');
function h5vp_add_custom_settings_link_into_cpt_menu() {
global $submenu;
// replace this URL with what you want to add
$link = 'options-general.php?page=html5vp_settings';
// switch events with your post type slug and Link Title with desired label
$submenu['edit.php?post_type=videoplayer'][] = array( 'Settings', 'manage_options', $link );
}	
	
	
/*-------------------------------------------------------------------------------*/
// Developer page
/*-------------------------------------------------------------------------------*/
add_action('admin_menu', 'h5vp_support_page');

function h5vp_support_page() {
	add_submenu_page( 'edit.php?post_type=videoplayer', 'Help & Support', 'Help & Support', 'manage_options', 'h5vp-support', 'h5vp_support_page_callback' );
}

function h5vp_support_page_callback() {
	
	echo '<div class="wrap"><div id="icon-tools" class="icon32"></div>';
		echo '<h2>Support</h2>
		<h3>We are committed to provide you best customer service. Please use any of the following channel to contact with us.</h3>
		<h5>Web : <a href="https://bplugins.com/support/">https://bplugins.com/support/</h5></a>
		Email: <a href="mailto:support@bplugins.com">support@bplugins.com</a>
		<h5>Skype: <a href="skype:ah_polash">ah_polash</a></h5> 
		<br />		
		<h2>Video Tutorials</h2>
		<div style="width:85%;">
		<style>.embed-container { position: relative; padding-bottom: 56.25%; height: 0; overflow: hidden; max-width: 100%; } .embed-container iframe, .embed-container object, .embed-container embed { position: absolute; top: 0; left: 0; width: 100%; height: 100%; }</style><div class="embed-container"><iframe src="https://www.youtube.com/embed/dLU67e708fg" frameborder="0" allowfullscreen></iframe></div>
		</div>
		</div>';
}

// Footer Review Request 

add_filter( 'admin_footer_text','h5vp_admin_footer');	 
function h5vp_admin_footer( $text ) {
	if ( 'videoplayer' == get_post_type() ) {
		$url = 'https://wordpress.org/support/plugin/html5-video-player/reviews/?filter=5#new-post';
		$text = sprintf( __( 'If you like <strong>Html5 Video Player</strong> please leave us a <a href="%s" target="_blank">&#9733;&#9733;&#9733;&#9733;&#9733;</a> rating. Your Review is very important to us as it helps us to grow more. ', 'h5vp-domain' ), $url );
	}

	return $text;
}

// Add shortcode area 	

add_action('edit_form_after_title','h5vp_shortcode_area');
function h5vp_shortcode_area(){
global $post;	
if($post->post_type=='videoplayer'){
?>	
<div>
	<label style="cursor: pointer;font-size: 13px; font-style: italic;" for="h5vp_shortcode">Copy this shortcode and paste it into your post, page, or text widget content:</label>
	<span style="display: block; margin: 5px 0; background:#1e8cbe; ">
		<input type="text" id="h5vp_shortcode" style="font-size: 12px; border: none; box-shadow: none;padding: 4px 8px; width:100%; background:transparent; color:white;"  onfocus="this.select();" readonly="readonly"  value="[video id=<?php echo $post->ID; ?>]" /> 
		
	</span>
</div>
 <?php   
}}
// Add shortcode area Quick

add_action('edit_form_after_title','h5vp_shortcode_quick_area');
function h5vp_shortcode_quick_area(){
global $post;	
if($post->post_type=='videoplayer_quick'){
?>	
<div>
	<label style="cursor: pointer;font-size: 13px; font-style: italic;" for="h5vp_shortcode">Copy this shortcode and paste it into your post, page, or text widget content:</label>
	<span style="display: block; margin: 5px 0; background:#1e8cbe; ">
		<input type="text" id="h5vp_shortcode" style="font-size: 12px; border: none; box-shadow: none;padding: 4px 8px; width:100%; background:transparent; color:white;"  onfocus="this.select();" readonly="readonly"  value="[video_player id=<?php echo $post->ID; ?>]" /> 
		
	</span>
</div>
 <?php   
}}