jQuery(document).ready(function(){

	
	jQuery('.vv-vimeo-wrapper .fitvids iframe').each(function(){
		var iframe = jQuery(this);
		var parent = iframe.closest('.vv-vimeo-wrapper');
		var player = new Vimeo.Player(iframe);

		player.on('timeupdate',function(data){
			player.getVideoId().then(function (videoid){
				localStorage.setItem(videoid,data.seconds);
			});
			
		});	
		player.on('loaded',function(id) {
			player.getVideoId().then(function (videoid){
				var secs = localStorage.getItem(videoid);
			    if(secs){
			    	player.setCurrentTime(secs).then(function(seconds) {
				    // seconds = the actual time that the player seeked to
					}).catch(function(error) {
					    switch (error.name) {
					        case 'RangeError':
					            // the time was less than 0 or greater than the video’s duration
					            break;

					        default:
					            // some other error occurred
					            break;
					    }
					});
			    }
			});
		    
		    
		    
		});
		//set primary color for player
		if(typeof vibe_course_module_strings != 'undefined' && vibe_course_module_strings != 'undefined' && vibe_course_module_strings != ''){
			player.setColor(vibe_course_module_strings.theme_color);
		}

		//mark complete
		if(parent.hasClass('auto_mark_complete') && parent.closest('#unit_content').hasClass('unit_content')){
			var onEnded = function(data) {
				var check_mark_complete = jQuery('#mark-complete');
				if(typeof check_mark_complete != 'undefined'){
					var unit_id = check_mark_complete.attr('data-unit');
					check_mark_complete.trigger('click');
					
					jQuery('.course_timeline').find('.unit[data-unit="+$unit_id+"]').addClass('done');
				}
			};
			player.on('ended', onEnded);
		}

		//seek_lock
		if(parent.hasClass('seek_lock') && parent.closest('#unit_content').hasClass('unit_content')){
			var beforetime = 0;
			var currenttime = 0;
			var flag = false;

			player.on('timeupdate',function(data){
				player.getCurrentTime().then(function(seconds) {

					beforetime = parseInt(currenttime);
					currenttime = parseInt(seconds*1000);

					if( currenttime > (beforetime + 500)){
						flag = true;
						if(flag){
							player.setCurrentTime((beforetime/1000)).then(function(seconds) {
								beforetime = currenttime;
								flag = false;
							}).catch(function(error) {
									switch (error.name) {
											case 'RangeError':
													break;
											default:
													break;
									}
							});
						}
						
					}
				});
			});	
		}
	});
});
