<?php
/**
 * API WPLMS PUSH
 *
 * @author 		VibeThemes
 * @category 	Init
 * @package 	wplms-push-notifications/Includes
 * @version     1.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}



class Vibe_Wistia_Api{


	public static $instance;

    public static function init(){

        if ( is_null( self::$instance ) )
            self::$instance = new Vibe_Wistia_Api();
        return self::$instance;
    }


    function __construct(){

        
        
    	add_action('rest_api_init',array($this,'register_routes'));
    }


    function register_routes(){

    	register_rest_route( VIDEOVIBE_API_NAMESPACE, '/wistia/get_albums', array(
            array(
                'methods'             =>  WP_REST_Server::READABLE,
                'callback'            =>  array( $this, 'get_wistia_albums' ),
                'permission_callback'       => array( $this, 'get_wistia_albums_verify' ),
            ),
        ));

        register_rest_route( VIDEOVIBE_API_NAMESPACE, '/wistia/get_albums_paged', array(
            array(
                'methods'             =>  WP_REST_Server::READABLE,
                'callback'            =>  array( $this, 'get_wistia_albums_paged' ),
                'permission_callback'       => array( $this, 'get_wistia_albums_verify' ),
            ),
        ));

        register_rest_route( VIDEOVIBE_API_NAMESPACE, '/wistia/media', array(
            array(
                'methods'             =>  WP_REST_Server::READABLE,
                'callback'            =>  array( $this, 'get_wistia_medias' ),
                'permission_callback'       => array( $this, 'get_wistia_albums_verify' ),
            ),
        ));


        register_rest_route( VIDEOVIBE_API_NAMESPACE, '/wistia/create_album/(?P<user>\d+)', array(
            array(
                'methods'             =>  WP_REST_Server::READABLE,
                'callback'            =>  array( $this, 'create_wistia_album' ),
                'permission_callback'       => array( $this, 'get_wistia_albums_verify' ),
                'args'                      =>  array(
                    'user'                        =>  array(
                        'validate_callback'     =>  function( $param, $request, $key ) {
                                                    return is_numeric( $param );
                                                }
                    ),
                    /*'vibe_wistia_security'  =>  array(

                        'validate_callback' => function($vibe_wistia_security) {
                            return wp_verify_nonce($vibe_wistia_security, 'vibe_wistia_security');
                        }
                    ),*/
                    'vibe_wistia_security' => array(
                        'validate_callback'     =>  function( $param, $request, $key ) {
                                                    return wp_verify_nonce($param, 'vibe_wistia_security');
                                                }
                    ),
                ),
            ),
        ));
	}

    

    function get_wistia_albums_verify($request){
        
        
        return true;
    }


    function get_wistia_albums_paged($request){
        $page = $request->get_param('page');
        $per_page = $request->get_param('per_page');
        $wistiaapi = VibeWistiaApi::init();
        $projects = $wistiaapi->projectListPaged($page,$per_page);
        return new WP_REST_Response( $projects, 200 );
    }

    function get_wistia_medias($request){
        $page = $request->get_param('page');
        $per_page = $request->get_param('per_page');
        $project_id = $request->get_param('project_id');

        $wistiaapi = VibeWistiaApi::init();

        $medias = $wistiaapi->getProjectMedias($project_id,$page,$per_page);
        return new WP_REST_Response( $medias, 200 );
    }

    function get_wistia_albums($request){
        $return = array();
        $wistiaapi = VibeWistiaApi::init();
        $projects = $wistiaapi->projectList();
        if(!empty($projects)){
            $projects = (array)$projects;
            $return = array('projects' => $projects,'status'=>true);
            
        }else{
            $return = array('message' => _x('Could not fetch any projects','','video-vide'),'status'=>false);
        }
        
        return new WP_REST_Response( $return, 200 );
    }

    function create_wistia_album($request){
        $course_id = $request['course'];    

    }


}

Vibe_Wistia_Api::init();