<?php
/**
 * VibeWistiaApi
 * A simple PHP Class for interfacing with the Wistia Data API
 * Starting Point can be seen here http://dev-forum.wistia.com/discussion/6/php-libraries - Thanks Brian Kutyah
 * I Don't need to write anything in my current scope, but this should be added at some point
 * Not sure why I prematurely optimized with a cache array
 * @since 6/26/2012
 */


class VibeWistiaApi
{
	public static $instance;

    public static function init(){

        if ( is_null( self::$instance ) )
            self::$instance = new VibeWistiaApi();
        return self::$instance;
    }


    function __construct(){
    	if(empty($this->token)){
            $this->settings = get_option(VIDEO_VIBE_OPTION);
            $this->token = '';
            if(!empty($this->settings) && !empty($this->settings['wistia_access_token'])){
                $this->token = $this->settings['wistia_access_token'];
            }
        }
    }

    function projectList(){
    	$projects = wp_remote_retrieve_body(wp_remote_get(
    		VIDEOVIBE_WISTIA_ENDPOINT.'projects.json?api_password='.$this->token 
    	) );
    	return json_decode(stripslashes($projects));
    }


    function projectListPaged($page,$per_page){
        if(empty($per_page)){
            $per_page = apply_filters('vibe_wistia_default_projects_per_page',5);
        }
        if(empty($page)){
            $page = apply_filters('vibe_wistia_default_projects_page',1);
        }
        $pagedata = array('page'=> $page,'per_page'=>$per_page);
        $projects = wp_remote_retrieve_body(wp_remote_get(
            VIDEOVIBE_WISTIA_ENDPOINT.'projects.json?api_password='.$this->token.'&'.http_build_query($pagedata)
        ) );
        return json_decode(stripslashes($projects));
    }

    function projectCreate($projectdata){
        if(!function_exists('http_build_query'))
            return false;
    	$project = wp_remote_retrieve_body(wp_remote_post(
    		VIDEOVIBE_WISTIA_ENDPOINT.'projects.json?api_password='.$this->token.'&'.http_build_query($projectdata)
    	)  );
    	return json_decode(stripslashes($project));
    }

    function getProjectMedias($project_id,$page,$per_page){
        if(empty($per_page)){
            $per_page = apply_filters('vibe_wistia_default_medias_per_page',5);
        }
        if(empty($page)){
            $page = apply_filters('vibe_wistia_default_medias_page',1);
        }
        $data = array('page'=> $page,'per_page'=>$per_page,'project_id'=>$project_id);
        $medias = wp_remote_retrieve_body(wp_remote_get(
            VIDEOVIBE_WISTIA_ENDPOINT.'medias.json?api_password='.$this->token.'&'.http_build_query($data)
        ) );

        return json_decode($medias);
    }
    

}