<?php
/**
 * Initialise WPLMS Batches
 *
 * @class       Bp_VideoVibe_Filters
 * @author      wplms-attendanceThemes
 * @category    Admin
 * @package     WPLMS-Batches/includes
 * @version     1.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}
class Bp_VideoVibe_Filters{


	public static $instance;
	
	public static function init(){

        if ( is_null( self::$instance ) )
            self::$instance = new Bp_VideoVibe_Filters();
        return self::$instance;
    }

	private function __construct(){
        add_filter('wplms_course_creation_tabs',array($this,'vv_unit'));

        add_filter('bp_course_api_get_user_course_status_item',array($this,'status_item'),10,2);
        
	}

    function status_item($return ,$request){
        $item_id = $request['id'];  
        $unit_type = get_post_meta($item_id,'vibe_type',true);
        if($unit_type=='vimeo'){
            $videos = get_post_meta($item_id,'vibe_post_video',true);
            $return['meta']['video'] = $videos;
        }

        return $return;
    }

    function vv_unit($tabs){
        $tabs['course_curriculum']['fields'][0]['curriculum_elements'][1]['types'][]= array(
            'id'=>'vimeo',
            'icon'=>'<svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24"><path d="M22.875 10.063c-2.442 5.217-8.337 12.319-12.063 12.319-3.672 0-4.203-7.831-6.208-13.043-.987-2.565-1.624-1.976-3.474-.681l-1.128-1.455c2.698-2.372 5.398-5.127 7.057-5.28 1.868-.179 3.018 1.098 3.448 3.832.568 3.593 1.362 9.17 2.748 9.17 1.08 0 3.741-4.424 3.878-6.006.243-2.316-1.703-2.386-3.392-1.663 2.673-8.754 13.793-7.142 9.134 2.807z"/></svg>',
            'label'=>__('Vimeo','wplms-h5p'),
            'fields'=>array(
                array(
                    'label'=> __('Unit title','wplms-h5p' ),
                    'type'=> 'title',
                    'id' => 'post_title',
                    'from'=>'post',
                    'value_type'=>'single',
                    'style'=>'full',
                    'default'=> __('Unit Name','wplms-h5p' ),
                    'desc'=> __('This is the title of the unit which is displayed on top of every unit','wplms-h5p' )
                    ),
                array(
                    'label'=> __('Unit Tag','wplms-h5p' ),
                    'type'=> 'taxonomy',
                    'taxonomy'=> 'module-tag',
                    'from'=>'taxonomy',
                    'value_type'=>'single',
                    'style'=>'assign_cat',
                    'id' => 'module-tag',
                    'default'=> __('Select a tag','wplms-h5p' ),
                ),
                array(
                    'label'=> __('Add vimeo video','wplms-h5p' ),
                    'type'=> 'vimeo_library',
                    
                    'value_type'=>'single',
                    'desc'=>__('Add vimeo video.','wplms-h5p' ),
                    'style'=>'small_icon',
                    'from'=>'meta',
                    'id' => 'vibe_post_video',
                    'default'=> '',
                ),
                array(
                    'label'=> __('What is the unit about','wplms-h5p' ),
                    'type'=> 'editor',
                    'style'=>'',
                    'value_type'=>'single',
                    'id' => 'post_content',
                    'from'=>'post',
                    'extras' => '',
                    'default'=> __('Enter description about the unit.','wplms-h5p' ),
                ),
                array(
                    'label'=> __('Unit duration','wplms-h5p' ),
                    'type'=> 'duration',
                    'style'=>'course_duration_stick_left',
                    'id' => 'vibe_duration',
                    'from'=> 'meta',
                    'default'=> array('value'=>9999,'parameter'=>86400),
                    'from'=>'meta',
                ),
                array( 
                    'label' => __('Free Unit','wplms-h5p'),
                    'desc'  => __('Set Free unit, viewable to all','wplms-h5p'), 
                    'id'    => 'vibe_free',
                    'type'  => 'switch',
                    'default'   => 'H',
                    'from'=>'meta',
                ),
                array(
                    'label' => __('Attachments','wplms-h5p'),
                    'desc'  => __('Display these attachments below units to be downloaded by students','wplms-h5p'),
                    'id'    => 'vibe_unit_attachments', 
                    'type'  => 'multiattachments', 
                    'from'=>'meta',
                ),
            ),
        );
        return $tabs;
    }
    

	
}

add_action('plugins_loaded',function(){
	
	if(defined('WPLMS_PLUGIN_VERSION')){
		Bp_VideoVibe_Filters::init();
	}
});
