<?php
/*
Plugin Name: Video Vibe
Plugin URI: http://www.vibethemes.com/
Description: This plugins integrates wplms with vimeo and wistia
Version: 4.01
Author URI: http://www.vibethemes.com/
Text Domain: video-vibe
Domain Path: /languages/
*/
if ( !defined( 'ABSPATH' ) ) exit; 
/*  Copyright 2013 VibeThemes  (email: vibethemes@gmail.com) */
if(!defined('VIDEO_VIBE_VERSION')){
    define('VIDEO_VIBE_VERSION','4.01');
}
if(!defined('VIDEOVIBE_API_NAMESPACE')){
    define('VIDEOVIBE_API_NAMESPACE','videovibe/v1');
}
if(!defined('VIDEOVIBE_WISTIA_ENDPOINT')){
    define('VIDEOVIBE_WISTIA_ENDPOINT','https://api.wistia.com/v1/');
}
if( !defined('VIDEO_VIBE_OPTION')){
    define('VIDEO_VIBE_OPTION','video-vibe');
}
include_once 'includes/library/wistia/class.wistia.php';
include_once 'includes/class.config.php';
include_once 'includes/class.updater.php';
include_once 'includes/class.api.php';
include_once 'includes/class.admin.php';
include_once 'includes/class.settings.php';


if(get_option('wplms_4_0')){

    include_once 'vibebp/includes/class.api.php';
    include_once 'vibebp/includes/class.filters.php';
    include_once 'vibebp/includes/class.init.php';

}


add_action('plugins_loaded','video_vibe_translations');
function video_vibe_translations(){
    $locale = apply_filters("plugin_locale", get_locale(), 'video-vibe');
    $lang_dir = dirname( __FILE__ ) . '/languages/';
    $mofile        = sprintf( '%1$s-%2$s.mo', 'video-vibe', $locale );
    $mofile_local  = $lang_dir . $mofile;
    $mofile_global = WP_LANG_DIR . '/plugins/' . $mofile;

    if ( file_exists( $mofile_global ) ) {
        load_textdomain( 'video-vibe', $mofile_global );
    } else {
        load_textdomain( 'video-vibe', $mofile_local );
    }  
}



function VideoVibe_Plugin_updater() {
    $license_key = trim( get_option( 'videovibe_license_key' ) );
    $edd_updater = new Video_Vibe_Plugin_Updater( 'https://wplms.io', __FILE__, array(
            'version'   => '4.01',               
            'license'   => $license_key,        
            'item_name' => 'Video Vibe',    
            'author'    => 'VibeThemes' 
        )
    );
}
add_action( 'admin_init', 'VideoVibe_Plugin_updater', 0 );