<?php
/**
 * Actions WPLMS Appointments
 *
 * @author 		VibeThemes
 * @category 	Init
 * @package 	wplms-appointments/Includes
 * @version     1.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}



class WPLMS_Appointments_Actions{


	public static $instance;

    public static function init(){

        if ( is_null( self::$instance ) )
            self::$instance = new WPLMS_Appointments_Actions();
        return self::$instance;
    }


    function __construct(){
    	add_action('wplms_course_action_point_permalink_settings',array($this,'appointment_permalink'));

        add_action('bp_profile_after_member_header_meta',array($this,'show_in_profile'));

        add_action('wplms_appointments_booking_form',array($this,'booking_form'),10,2);

        add_action('wplms_appointments_booking_form',array($this,'pre_creds'),10,2);

        add_action('wplms_front_end_generate_fields_default',array($this,'appointment_hidden_product'),10,2);
        add_action('wplms_front_end_save_course_pricing',array($this,'save_pricing'),10,2);
        add_filter('wplms_course_front_end_save_pricing',array($this,'stop_postmeta_save'),10,2);

        add_action('wp_ajax_book_booking_product',array($this,'book_booking_product'));
        add_action('wp_ajax_nopriv_book_booking_product',array($this,'book_booking_product'));

        //Send gift by email
         $this->show_timer = 0;
        
        add_action('woocommerce_remove_cart_item',array($this,'remove_active_slot'),10,2);
        add_action('wp_footer',array($this,'show_cart_timer'));
        add_action('woocommerce_check_cart_items',array($this,'timer_expired'));
        add_action('woocommerce_add_order_item_meta',array($this,'add_appointment_meta_to_order_item_meta'),1,2);
        /* WooCommerce Order STatus */
        
        add_action('woocommerce_order_status_completed',array($this,'wplms_appointment_enable_access'));
        //add_action('woocommerce_order_status_cancelled',array($this,'wplms_appointment_disable_access'),10,1);
        //add_action('woocommerce_order_status_refunded',array($this,'wplms_appointment_disable_access'),10,1);

        add_action('wplms_appointment_booked',array($this,'touch_point'),10,3);

        add_action('wplms_appointments_update_appointment',array($this,'wplms_appointments_update_appointment'),10,3);

        add_action('bp_after_messages_compose_content',array($this,'wplms_get_instructor'));
        add_action('messages_message_sent',array($this,'record_schedule_id'),10,1);

        add_action('init',array($this,'authentication_meeting_endpoints'));

        add_filter( 'request', array($this,'filter_request' ));


        //Create end point Siteurl/endMeeting/?meeting_id=xx'
        //init
        //request

        add_action('wp_footer',array($this,'directory_featured_video'));

        //This function will show the appointment id and instrutor name when a new order is made(when student book a schedule)
        add_action('woocommerce_email_before_order_table',array($this,'show_additional_info_woocommerce_order_emails'),10,4);
    }


    function get_course_settings(){
        if(!wp_verify_nonce($_POST['security'],'security') || !is_numeric($_POST['course_id']) || !is_numeric($_POST['instructor_id']))
            die();
        $instructor_id = $_POST['instructor_id'];
        $course_id = $_POST['course_id'];
        $form = get_post_meta($_POST['course_id'],'vibe_wplms_appointment_booking_form',true);
        if(!empty($form)){
            
            $html =  do_shortcode($form);
           
        }

        $price = array('slot'=>array(),'schedule'=>Array());
        global $wpdb;
        $slot_product_id = $wpdb->get_var("SELECT m.post_id FROM {$wpdb->postmeta} as m LEFT JOIN {$wpdb->posts} as p ON p.id = m.post_id WHERE p.post_type='product' AND p.post_author = $instructor_id AND m.meta_key = 'vibe_wplms_appointment_booking_slot_price' AND m.meta_value = $course_id");

        if(!empty($slot_product_id)){
            $product = wc_get_product( $slot_product_id );
            $slot_price = $product->get_price_html();   
            $price['slot'] = array('id'=>$slot_product_id,'price'=>$slot_price);
        }
        

        $schedule_product_id = $wpdb->get_var("SELECT m.post_id FROM {$wpdb->postmeta} as m LEFT JOIN {$wpdb->posts} as p ON p.id = m.post_id WHERE p.post_type='product' AND p.post_author = $instructor_id AND m.meta_key = 'vibe_wplms_appointment_booking_schedule_price' AND m.meta_value = $course_id");

        if(!empty($schedule_product_id)){
            $product = wc_get_product( $schedule_product_id );
            $schedule_price = $product->get_price_html();   
            $price['schedule'] = array('id'=>$schedule_product_id,'price'=>$schedule_price); 
        }else{
            unset($price['schedule']);
        }

        echo json_encode(array(
            'price'=>$price,
            'message'=>$html,
        ));
        die();
    }

    function get_instructor_settings(){
        
        if(!wp_verify_nonce($_POST['security'],'security') || !is_numeric($_POST['instructor_id'])){

            die();
        }

        $form = get_post_meta($_POST['instructor_id'],'appointments_message',true);
        if(!empty($form)){
            
            $html = do_shortcode($form);
           
        }
        $price = array('slot'=>array());
        $settings = get_user_meta($_POST['instructor_id'],'appointment_settings',true);
        if(!is_array($settings)){
            $settings = unserialize($settings);
        }

        $slot_product_id = $settings['instructor_appointments_price'];
        if($slot_product_id > 0){
            if(!empty($slot_product_id)){
                $product = wc_get_product( $slot_product_id );
                $slot_price = $product->get_price_html();   
                $price['slot'] = array('id'=>$slot_product_id,'price'=>$slot_price);
            }    
        }
        
        
        echo json_encode(array(
            'price'=>$price,
            'message'=>$html,
        ));

        die();
    }

    function wplms_get_instructor(){
        if(!empty($_GET['instructor_id'])){
            $user_info = get_userdata(intval($_GET['instructor_id']));
            ?>
            <script>
                jQuery(document).ready(function(){
                    jQuery('#send-to-input').val('<?php echo $user_info->user_login; ?>');
                });
            </script>
            <?php
        }

        if(!empty($_GET['schedule_id'])){
            echo '<input type="hidden" name="schedule_id" value="'.intval($_GET['schedule_id']).'" />';
        }
    }

    function record_schedule_id($message){
        if(!empty($_POST['schedule_id'])){
            bp_messages_add_meta( $message->thread_id, 'schedule_id', intval($_POST['schedule_id']) );
        }
    }


    function pre_creds($type,$id){

        if($type == 'course'){
            ?>
            <script>
                setTimeout(function(){ //allow react script to load
                    var event = new CustomEvent("wplms_appointment_set_args", { "detail": JSON.stringify({item_id:<?php echo $id; ?>})});
                    document.dispatchEvent(event);
                },500);
                
            </script>
            <?php
        }
    }

    function booking_form($type,$id){

        $init = WPLMS_Appointments_Init::init();
        $init->get_global_settings();

        echo '<script src="'.plugins_url('../assets/js/moment.min.js',__FILE__).'"></script><div class="wplms_appointments_booking_form_wrapper hide"><div class="wplms_appointments_booking_form"><div><span class="close_booking_form"></span>
        <div id="booking_content"></div>';


        if($type == 'course'){

            $form = get_post_meta($id,'vibe_wplms_appointment_booking_form',true);
        }

        if($type == 'profile'){
            $profile = WPLMS_Appointments_Profile::init();
            $settings = $profile->get_user_appointment_settings(bp_displayed_user_id());
            
            $form = $settings['appointments_message'];
        }   
        if(!empty($form)){
            echo '<div class="booking_message_form">';
            echo do_shortcode($form);
            echo '</div>';
        }

        

        
        // show slots //
        if( !has_shortcode($form,'form')){
            
            echo '<button class="confirm_booking button">'.__('Confirm booking','wplms-appointments').'</button>';
        }
        echo '</div></div></div>';

                ?>
                <script>

                    function pad2(number){
                        return (number < 10 ? '0' : '') + number;
                    }

                    let $type = '<?php echo $type; ?>';
                    let dateformat = '<?php echo ($init->settings['appointments_date_format'])?$init->settings['appointments_date_format']:'MM-DD-YY'; ?>';
                    let timeformat = '<?php echo ($init->settings['appointments_time_format'])?$init->settings['appointments_time_format']:'HH:mm';?>';
                    let init_booking={};
                    document.addEventListener("wplms_appointment_initiate_booking", function(ele) {
                        //var $ = jQuery;
                        jQuery('.wplms_appointments_booking_form_wrapper').removeClass('hide');
                        init_booking=Object.assign({},ele.detail);

                        

                        var current_event = init_booking.events.filter((item)=>{ return init_booking.appointment_id === item.appointment_id});

                        
                       
                        if($type == 'course'){
                            var course_instructor = JSON.parse(sessionStorage.getItem('instructor_'+current_event[0].author_id+'_'+current_event[0].item_id));

                        }

                        if($type == 'profile'){
                            var course_instructor = JSON.parse(sessionStorage.getItem('instructor_'+current_event[0].author_id));
                            jQuery('.booking_message_form').remove();
                        }
                       
                       

                        var sstart = new Date(current_event[0].start.getTime());
                        var eend = new Date(current_event[0].end.getTime());
                        
                        var settings = {};


                        if(jQuery('.booking_message_form').length === 0 && typeof course_instructor !== 'undefined' && course_instructor !== null){


                            if(course_instructor.hasOwnProperty('courses') && current_event[0].item_id > 0){

                                let index = course_instructor.courses.findIndex(function(course){return parseInt(course.id) === parseInt(current_event[0].item_id) });
                                if(index > -1){


                                    jQuery('#booking_content').after('<div class="booking_message_form">'+course_instructor.courses[index].message+'</div>');   

                                    if(jQuery(course_instructor.courses[index].message).find('form[data-event="submit_booking_form"]').length > 0){
                                        jQuery('.confirm_booking.button').hide();
                                    }
                                }else{
                                   jQuery('#booking_content').after('<div class="booking_message_form"><?php _e('','wplms-appointments');?></div>');
                                }
                            }else{
                                
                                if(course_instructor.hasOwnProperty('message')){
                                    jQuery('#booking_content').after('<div class="booking_message_form">'+course_instructor.message+'</div>');   

                                    if(course_instructor.message.indexOf('data-event="submit_booking_form"') >= 0){
                                        jQuery('.confirm_booking.button').hide();
                                    }
                                }
                            }

                            
                        }
                            
                            
                        let heading = '';

                        if(sstart.getDate() === eend.getDate()){
                            heading = '<strong>'+moment(sstart).format(dateformat)+'</strong><span>'+moment(sstart).format(timeformat)+' - '+moment(eend).format(timeformat)+'</span>';
                        }else{
                            heading ='<span>'+moment(sstart).format(dateformat)+' '+moment(sstart).format(timeformat)+'</span><span>' + moment(eend).format(dateformat)+' '+moment(eend).format(timeformat)+'</span>';
                        }
                        
                       
                        

                        let html = '<h3>'+heading+'</h3>';

                        let price = {};
                        if(course_instructor !== null){
                            html +='<div class="wplms_appointment_instructor"><img src="'+course_instructor.image+'" /><span>'+course_instructor.name+'</span></div>';


                            if(course_instructor.hasOwnProperty('price')){
                                
                                price = course_instructor.price;
                            }

                            if(course_instructor.hasOwnProperty('courses') && current_event[0].item_id > 0){

                                
                                let index = course_instructor.courses.findIndex(function(course,i){return parseInt(course.id) === parseInt(current_event[0].item_id) });
                                
                                if(index >= 0 && course_instructor.courses[index].hasOwnProperty('price')){
                                    html +='<strong>'+course_instructor.courses[index].name+'</strong>';
                                    price = course_instructor.courses[index].price;    
                                    
                                }
                            }
                            if(Object.keys(price).length){
                                let quantity = 1;
                                if(!price.hasOwnProperty('schedule')){
                                    quantity=init_booking.events.length;
                                }
                                html += '<div class="estimated_price">\
                                <strong><?php _e('Price','wplms_appointments'); ?></strong><span class="item_count"></span><span class="price_amount">'+
                                ((init_booking.schedule.type !== 'schedule_booking')?price.slot.price:(price.hasOwnProperty('schedule')?price.schedule.price:quantity+' x '+price.slot.price))+'</span></div>';

                                init_booking['product']={'id':price.slot.id,'quantity':quantity};
                            }
                                
                        }
                            
                        jQuery('#booking_content').html(html);

                        
                        

                        if(init_booking.schedule.type !== 'free_slots')
                        {

                            var blocks ='';
                            if(init_booking.schedule.type !== 'schedule_booking'){
                                 blocks = '<div class="checkbox"><input type="checkbox" id="show_schedule" /><label for="show_schedule"><?php _e('Show Schedule','wplms-appointments'); ?> </label></div>';

                                 if(price.hasOwnProperty('schedule')){
                                    blocks +='<div class="checkbox"><input type="checkbox" id="book_full_schedule" /><label for="book_full_schedule"><?php _e('Book full Schedule','wplms-appointments'); ?> </label></div>';
                                 }
                                 
                            }else{
                                init_booking.appointment_id = init_booking.schedule.appointment_id;

                                if(price.hasOwnProperty('schedule')){
                                    init_booking['product']={'id':price.schedule.id,'quantity':1};
                                }else{
                                    if(price.hasOwnProperty('slot') && price.slot.hasOwnProperty('id')){
                                        init_booking['product']={'id':price.slot.id,'quantity':init_booking.events.length};
                                    }
                                }
                            }

                            if(Array.isArray(init_booking.events)){
                                blocks+='<div class="full_schedule hide">';
                                var ss ='';var ee='';
                                init_booking.events.sort((item,item2)=>{
                                    return item.start.getTime() - item2.start.getTime();

                                });
                                init_booking.events.map((item)=>{
                                    ss = new Date(item.start.getTime());
                                    ee = new Date(item.end.getTime());
                                    let cclass= 'schedule_event';
                                    if(item.start < new Date()){
                                        cclass+=' disabled';
                                    }
                                    blocks+='<div class="'+cclass+' '+((init_booking.appointment_id === item.appointment_id)?'selected':'')+'" data-id="'+item.appointment_id+'">';


                                    blocks += pad2(ss.getHours())+':' + pad2(ss.getMinutes())+' - '+pad2(ee.getHours())+':' + pad2(ee.getMinutes());
                                    //blocks += ss.getHours()+':'+ss.getMinutes()+' - '+ee.getHours()+':'+ee.getMinutes();


                                    if(ss.getDay() === ee.getDay()){
                                        blocks+='<strong>'+ss.toDateString()+'</strong>';
                                    }else{
                                        blocks+='<strong>'+ss.toDateString()+' - '+ee.toDateString()+'</strong>';
                                    }

                                    blocks +='</div>';
                                });
                                blocks+='</div>';
                            }
                            jQuery('#booking_content').append(blocks);
                            jQuery('#show_schedule').on('click',function(){
                                if(jQuery(this).is(':checked')){
                                    jQuery('.full_schedule').removeClass('hide');
                                }else{
                                    jQuery('.full_schedule').addClass('hide');
                                }
                            });
                            jQuery('#book_full_schedule').on('click',function(){
                                 
                                if(jQuery(this).is(':checked')){
                                    jQuery('.schedule_event').addClass('active');
                                    init_booking.appointment_id=init_booking.schedule.appointment_id;
                                    init_booking['additional_appointment_ids']=[];
                                    
                                    if(price.hasOwnProperty('schedule')){

                                        jQuery('.estimated_price > span.price_amount').html(price.schedule.price);
                                        jQuery('.estimated_price > span.item_count').html('');

                                        init_booking['product']={'id':price.schedule.id,'quantity':1};
                                    }else{
                                        if(price.hasOwnProperty('slot')){
                                            jQuery('.estimated_price > span.price_amount').html(price.slot.price);
                                            jQuery('.estimated_price > span.item_count').html(init_booking.events.length);

                                            init_booking['product']={'id':price.slot.id,'quantity':init_booking.events.length};
                                        }
                                    }
                                }else{
                                    init_booking=Object.assign({},ele.detail);
                                    jQuery('.schedule_event').removeClass('active');
                                    if(price.hasOwnProperty('slot')){
                                        jQuery('.estimated_price > span.price_amount').html(price.slot.price);
                                        jQuery('.estimated_price > span.item_count').html('1x');
                                        init_booking['product']={'id':price.slot.id,'quantity':1};
                                    }
                                }
                            });
                            jQuery('.schedule_event').on('click',function(){
                                
                                if(jQuery(this).hasClass('selected') || jQuery(this).hasClass('disabled') || jQuery('#book_full_schedule').is(':checked'))
                                    return;

                                if(!Array.isArray(init_booking['additional_appointment_ids'])){
                                    init_booking['additional_appointment_ids']=[];    
                                }

                                if(jQuery(this).hasClass('active')){

                                    init_booking['additional_appointment_ids'].splice(init_booking['additional_appointment_ids'].indexOf(jQuery(this).attr('data-id')),1);
                                    


                                }else{
                                    if(init_booking['additional_appointment_ids'].indexOf(jQuery(this).attr('data-id')) < 0){
                                        init_booking['additional_appointment_ids'].push(jQuery(this).attr('data-id'));
                                    }
                                }

                                if(price.hasOwnProperty('slot')){
                                    jQuery('.estimated_price > span.item_count').html((init_booking['additional_appointment_ids'].length+1)+'x');
                                    init_booking['product']={'id':price.slot.id,'quantity':init_booking['additional_appointment_ids'].length+1};
                                }

                                jQuery(this).toggleClass('active');

                            });
                        }
                    });

                    jQuery(document).ready(function($){
                        jQuery('.wplms_appointments_booking_form_wrapper').on('click',function(event){
                            if(jQuery(event.target).hasClass('wplms_appointments_booking_form_wrapper')){
                                jQuery(this).addClass('hide');
                            }
                        });
                        
                        jQuery('.confirm_booking').on('click',function(){
                            //console.log(init_booking);
                            var myeevent = new CustomEvent("wplms_appointment_book_booking", { "detail": JSON.stringify({args:init_booking}) });


                            document.dispatchEvent(myeevent);
                        });
                    });

                    document.addEventListener("submit_booking_form", function(elem) {
                        

                        var myeevent = new CustomEvent("wplms_appointment_book_booking", { "detail": JSON.stringify({args:init_booking,form:elem.detail}) });
                        document.dispatchEvent(myeevent);
                    });

                    jQuery('span.close_booking_form').on('click',function(){
                        jQuery('.wplms_appointments_booking_form_wrapper').addClass('hide');
                    });

                </script>
                <style>
                    .bp-user.p3 #item-nav+.container, .bp-user.p4 #item-nav+.container{z-index:9;}
                    .wplms_appointments_booking_form_wrapper{
                        position:fixed;width:100vw;height:100vh;
                        left:0;top:0;
                        display:grid;
                        align-items:center;
                        justify-items:center;
                        background:rgba(0,0,0,0.8);
                        z-index: 9;
                    }
                    .wplms_appointments_booking_form {
                        background: #fff;
                        position:relative;
                        max-width: 100%;
                        min-width: 60vw;
                        max-height:80vh;
                        overflow:hidden;
                        border-radius: 15px;
                        padding: 30px 30px 56px;
                        position:relative;
                        align-items: center;
                        display: inline-block;
                        box-shadow: 0 5px 10px rgba(0,0,0,0.2);
                    }.wplms_appointments_booking_form > div{
                        overflow-y:auto;    max-height: calc(80vh - 120px);
                    }.confirm_booking{
                        position: absolute;
                        width:100%;
                        left: 0;
                        bottom: 0;
                        margin-bottom: -1px;
                        padding: 15px 0;
                    }
                    @media (min-width:1200px){
                        .wplms_appointments_booking_form {
                            min-width:40vw;
                        }
                    }
                    @media (max-width:992px){
                        .wplms_appointments_booking_form {
                            min-width:80vw;
                        }
                    }
                    .wplms_appointments_booking_form span.close_booking_form:after {
                        position: absolute;
                        top: 10px;
                        right: 10px;
                        content: "\f057";
                        font-family: fontawesome;
                        color: red;
                        font-size: 15px;
                    }
                    .full_schedule{
                        display: grid;
                        grid-template-columns: repeat(auto-fit,minmax(80px,1fr));
                        align-items: center;
                        justify-items: center;
                    }
                    #booking_content h3 {
                        font-size: 3rem;
                        font-weight: 600;
                        padding: 0; margin:0;
                    }#booking_content h3 span{
                        display: block;font-size:2rem;
                        border-top: 1px solid rgba(0,0,0,0.1);
                        padding: 10px 0;
                        margin: 10px 0;  opacity: 0.6;
                        font-weight: 400;
                    }#booking_content h3 strong:before{
                        font-family: fontawesome;
                        content: "\f073";
                        margin-right: 15px;
                    }#booking_content h3 span:before{
                        content: "\f017";
                        font-family: fontawesome;
                        margin-right: 10px;
                    }
                    .wplms_appointment_instructor {
                        display: grid;align-items:center;
                        grid-template-columns: 36px 1fr;
                        grid-gap: 5px;margin-bottom:15px;
                    }.wplms_appointment_instructor img{border-radius:50%;}
                    .booking_message_form{
                        padding-top: 20px;
                        margin-top: 20px;
                        border-top: 1px dashed rgba(0,0,0,0.1);
                    }
                    .schedule_event {
                        border: 1px solid rgba(0,0,0,0.1);
                        width: 100%;height:100%;
                        padding: 5px 10px;
                        text-align: center;
                    }
                    .schedule_event.disabled{
                        background: repeating-linear-gradient(45deg, transparent, transparent 5px, rgb(204, 204, 204) 5px, rgb(204, 204, 204) 25px);
                    }
                    .schedule_event.selected,
                    .schedule_event.active{background:rgba(0,0,0,0.1);transform:none;}
                    .schedule_event > strong {
                        display: block;
                    }
                    .instructor_price > .amount {
                        padding: 0 10px;
                        font-size: 16px;
                        font-weight: 600;
                    }
                    .rbc-day-slot .rbc-event-content{font-weight: 600;
                    text-shadow: 0 1px 2px rgba(0,0,0,0.5);}.rbc-events-container > div:hover {
                        transition: all 0.2s;
                        transform: translateY(-2px);
                        box-shadow: 0 1px 5px rgba(0,0,0,0.2);
                    }
                </style>
                <?php
            
                /*
                echo '<div class="wplms_appointments_booking_form_wrapper hide"><div class="wplms_appointments_booking_form"><span class="close"></span>';
                echo '<button class="confirm_booking">'.__('Confirm booking','wplms-appointments').'</button>';
                echo '</div></div>';
                
                 <script>
                    jQuery(document).ready(function($){

                        let init_booking=[];
                        document.addEventListener("wplms_appointment_initiate_booking", function(e) {
                            jQuery('.wplms_appointments_booking_form_wrapper').removeClass('hide');
                            init_booking=e.detail;
                        });

                        $('.confirm_booking').on('click',function(){
                            var myevent = new CustomEvent("wplms_appointment_book_booking", { "detail": JSON.stringify({args:init_booking}) });
                            document.dispatchEvent(myevent);
                        });
                    });
                    document.addEventListener("wplms_appointment_initiate_booking", function(e) {

                        var bookevent = new CustomEvent("wplms_appointment_book_booking", { "detail": 
                            JSON.stringify({args:e.detail})
                        });
                        console.log(e.detail);
                        document.dispatchEvent(bookevent);

                    });
                </script>
                */
            

            ?>
            <script>

                document.addEventListener("wplms_appointment_book_booking", function(e) {

                    
                    //console.log('captured');
                    var details = JSON.parse(e.detail);
                    //console.log(details);
                    jQuery.confirm({
                          text: window.wplms_appointments.translations.confirm_pay_booking,
                          confirm: function() {
                            //Ajax Call to delete news
                            jQuery.ajax({
                                type: "POST",
                                url: ajaxurl,
                                dataType: 'json',
                                data: { action: 'book_booking_product',
                                      security:'<?php echo wp_create_nonce('security'); ?>',
                                      details:JSON.stringify(details)
                                    },
                                cache: false,
                                success: function (json) {
                                   

                                    if(json.hasOwnProperty('status')){

                                        if(json.status){
                                            window.location = json.url;
                                        }else{
                                         alert(json.message);
                                         jQuery('.wplms_appointments_booking_form .close_booking_form').trigger('click');
                                        }
                                    }else{
                                        alert(json.message);
                                        jQuery('.wplms_appointments_booking_form .close_booking_form').trigger('click');
                                    }
                                }
                            });
                          },
                          cancel: function() {
                          },
                          confirmButton: vibe_course_module_strings.confirm,
                          cancelButton: vibe_course_module_strings.cancel
                        });
                    
                });
            </script>
            <?php
        

    }
    function appointment_permalink(){

        if(class_exists('Vibe_CustomTypes_Permalinks')){
            $x = Vibe_CustomTypes_Permalinks::init();
            $permalinks = $x->permalinks;    
        }else{
            $permalinks = get_option( 'vibe_course_permalinks' );
        }
    
        $booking_permalink = $permalinks['appointments_slug'];

        if(empty($permalinks['appointments_slug'])){
            $booking_permalink = 'book';
        }
        ?>
        <tr>
            <th><label><?php _e('Book/Appointments','wplms-appointments'); ?></label></th>
            <td>
                <input name="appointments_slug" type="text" value="<?php echo esc_attr( $booking_permalink ); ?>" class="regular-text code"> <span class="description"><?php _e( 'Course  - Bookings slug', 'wplms-appointments' ); ?></span>
            </td>
        </tr>
        <?php
    }

    function show_in_profile(){

        $enabled = apply_filters('wplms_appointments_show_book_in_profile',user_can(bp_displayed_user_id(),'edit_posts'));
        if(!$enabled){
            return;
        }



        $appointments = WPLMS_Appointments_Init::init();

        if(!empty($appointments->settings['appointments_in_profile'])){
            if(class_exists('Vibe_CustomTypes_Permalinks')){
                $x = Vibe_CustomTypes_Permalinks::init();
                $permalinks = $x->permalinks;    
            }else{
                $permalinks = get_option( 'vibe_course_permalinks' );
            }
        
            $booking_permalink = $permalinks['appointments_slug'];

            if(empty($permalinks['appointments_slug'])){
                $booking_permalink = 'book';
            }
            echo '<a href="'.bp_core_get_user_domain(bp_displayed_user_id()).$booking_permalink.'" class="button book_appointment" style="float:none;padding:8px 16px;">'._x('Book instructor','button below instructor in course','wplms-appointments').'</a>';
        }
    }


    function appointment_hidden_product($field,$course_id = null){

        
        if($field['type'] != 'appointment_hidden_product' || empty($course_id)){
            return;
        }

        global $wpdb;

        $user_id = get_current_user_id();

        $existing_product = $wpdb->get_var("SELECT m.post_id FROM {$wpdb->postmeta} as m LEFT JOIN {$wpdb->posts} as p ON p.id = m.post_id WHERE p.post_type='product' AND p.post_status ='publish' AND p.post_author = $user_id AND m.meta_key = '".$field['id']."' AND m.meta_value = $course_id");
        
        
        echo   '<div class="field_wrapper '.(isset($field['style'])?$field['style']:'').'">';
                echo   '<label>'. $field['label'].(empty($field['desc'])?'':'<a class="tip" title="'.$field['desc'].'"><i class="icon-question"></i></a>').'</label>';
        echo   (!empty($field['text'])?'<strong>'.$field['text'].'</strong>':''); 
                
                 
        if(!empty($existing_product)){
            
            $product = wc_get_product( $existing_product );

           // $field['value'] = $product->get_price();
            $field['value'] = $product->regular_price;


            echo '<div class="price right">'.$product->get_price_html().'</div>';
        }

        echo   '<input type="text" placeholder="'.(isset($field['default'])?$field['default']:'').'" data-id="'.$field['id'].'" data-type="'.$field['type'].'" class="mid_box post_field '.(empty($field['text'])?'form_field':'').'" value="'.$field['value'].'"/>'.(isset($field['extra'])?$field['extra']:'');
        
        echo   '</div>';

    }

    function stop_postmeta_save($return,$setting){
        if($setting->type == 'appointment_hidden_product'){
            return 0;
        }

        return $return;
    }

    function save_pricing($course_id,$settings){
        //print_r($settings);
        
        if(empty($settings) || empty($course_id))
            return;

        foreach($settings as $setting){


            if($setting->type === 'appointment_hidden_product'){

                $setting=(Array)$setting;
                global $wpdb;

                $user_id = get_current_user_id();

                $existing_product = $wpdb->get_var("SELECT m.post_id FROM {$wpdb->postmeta} as m LEFT JOIN {$wpdb->posts} as p ON p.id = m.post_id WHERE p.post_type='product' AND p.post_status = 'publish' AND p.post_author = $user_id AND m.meta_key = '".$setting['id']."' AND m.meta_value = $course_id");


                if(!empty($existing_product)){

                    $product = wc_get_product( $existing_product );
                    $saved_price = $product->get_price();

                    if($setting['value'] != $saved_price){
                        //update the price
                        update_post_meta($existing_product,'_regular_price',$setting['value']);
                        update_post_meta($existing_product,'_price',$setting['value']);

                        $instructor_id = get_post_field('post_author',$existing_product);
                        $db = new WPLMS_APPOINTMENTS_DB;
                        if(strpos($setting['id'], 'slot') !== false){
                            $appointments = $db->get_appointments(array('author_id'=>$instructor_id,'booker_id'=>0,'item_id'=>$course_id,'parent_appointment_id'=>'EXISTS'));
                        }else{
                            $appointments = $db->get_appointments(array('author_id'=>$instructor_id,'booker_id'=>0,'item_id'=>$course_id,'parent_appointment_id'=>0));
                        }

                        //print_r($appointments);
                        if(!empty($appointments)){
                            $metadb = new WPLMS_APPOINTMENTS_META_DB;
                            foreach($appointments as $appointment){
                                $metadb->update_appointment_meta(array('appointment_id'=>$appointment['appointment_id'],'meta_key'=>'appointment_price_'.$instructor_id,'meta_value'=>$setting['value']));
                                $metadb->update_appointment_meta(array('appointment_id'=>$appointment['appointment_id'],'meta_key'=>'appointment_product_id','meta_value'=>$existing_product));
                            }
                        }
                    }

                }else{
                    
                    $title = get_post_field('post_title',$course_id);

                    
                    if(strpos($setting['id'], 'slot') !== false){
                        $title =  sprintf(__('Appointment Slot price for course %s','wplms-appointments'),$title);
                    }else{
                        $title =  sprintf(__('Appointment Schedule price for course %s','wplms-appointments'),$title);
                    }
                    $args = apply_filters('wplms_appointments_save_price',array(
                        'post_title'=> $title,
                        'post_content'=> $title,
                        'post_status'=>'publish',
                        'post_type'=>'product',
                        'post_author'=>get_current_user_id()
                    ));

                    $product_id = wp_insert_post($args);
                    update_post_meta($product_id,$setting['id'],$course_id);

                    if(!empty($product_id)){
                        wp_set_object_terms($product_id, 'simple', 'product_type');
                        wp_set_object_terms( $post_id, array( 'exclude-from-catalog', 'exclude-from-search' ), 'product_visibility' );
                        update_post_meta($product_id,'_virtual','yes');
                        update_post_meta($product_id,'_downloadable','yes');
                        update_post_meta($product_id,'_regular_price',$setting['value']);
                        update_post_meta($product_id,'_price',$setting['value']);

                        $instructor_id = get_post_field('post_author',$product_id);
                        $db = new WPLMS_APPOINTMENTS_DB;
                        if(strpos($setting['id'], 'slot') !== false){
                            $appointments = $db->get_appointments(array('author_id'=>$instructor_id,'booker_id'=>0,'item_id'=>$course_id,'parent_appointment_id'=>'EXISTS'));
                        }else{
                            $appointments = $db->get_appointments(array('author_id'=>$instructor_id,'booker_id'=>0,'item_id'=>$course_id,'parent_appointment_id'=>0));
                        }

                        if(!empty($appointments)){
                            $metadb = new WPLMS_APPOINTMENTS_META_DB;
                            foreach($appointments as $appointment){
                                $metadb->update_appointment_meta(array('appointment_id'=>$appointment['appointment_id'],'meta_key'=>'appointment_price','meta_value'=>$setting['value']));
                                $metadb->update_appointment_meta(array('appointment_id'=>$appointment['appointment_id'],'meta_key'=>'appointment_product_id','meta_value'=>$product_id));
                            }
                        }
                    }
                }
            }
        }
        

        
    }


    function book_booking_product(){

        if (!wp_verify_nonce($_POST['security'],'security') ){

            echo json_encode(array('status'=>0, 'message'=>__('Security check failed !','wplms-appointments')));
            die();
        }

        if(!is_user_logged_in()){

            $register_id = vibe_get_bp_page_id('register');
            if(!empty(vibe_get_option('custom_registration_page'))){
                $register_id = vibe_get_option('custom_registration_page');
            }

            echo json_encode(array('status'=>1,'url'=>get_permalink($register_id), 'message'=>__('Login to continue','wplms-appointments')));
            die();
        }


        global $wpdb;

        $details = json_decode(stripslashes($_POST['details']),true);
        
        $schedule = $details['args']['schedule'];

        $slot_ids = array(intval($details['args']['appointment_id']));
        if(!empty($details['args']['additional_appointment_ids'])){
            $slot_ids = array_merge($slot_ids,$details['args']['additional_appointment_ids']);
        }

        $slot_details = array();

        if(is_array($details['args']['events'])){
            foreach($details['args']['events'] as $event){
                if(in_array($event['appointment_id'],$slot_ids)){
                    $slot_details[$event['appointment_id']]=array('start'=>$event['start'],'end'=>$event['end'],'item_id'=>$event['item_id']);
                }
            }
        }
 
        $product_id=0;
        if(empty($details['args']['product'])){
            //Send schedule or slots for instructor approval
            //notify instructor
            $pending_appointments = wplms_appointments_get_pending_slots(array('instructor_id'=>intval($schedule['author_id'])));


            if(!empty($pending_appointments)){
                foreach($pending_appointments as $slot_id => $appointment_args){
                    if(in_array($slot_id,$slot_ids) && !empty($appointment_args)){
                        foreach($appointment_args as $appointment_arg){

                            if($appointment_arg['booker_id'] == get_current_user_id()){

                                echo json_encode(array('status'=>0,'url'=>'/', 'message'=>sprintf(__('Appointment already requested for Slot [%d]','wplms-appointments'),$slot_id)));
                                die();
                            }
                        }
                    }
                }
            }

            $profile = WPLMS_Appointments_Profile::init();
            $profile->get_user_appointment_settings($instructor_id);
            
            $wait_time = 30*60;
            if(!empty($profile->settings['appointments_approval_wait_time'])){
                $wait_time = (int)$profile->settings['appointments_approval_wait_time']*60;
            }

            $pending_args = array(
                'slot_id'=>$slot_ids,
                'slot_details'=>$slot_details,
                'instructor_id'=>intval($schedule['author_id']),
                'booker_id'=>get_current_user_id(),
                'time'=> time()+$wait_time
            );

            if(!empty($details['form'])){
                $pending_args['form'] = $details['form'];
            }

            
            wplms_appointments_update_pending_slots($pending_args);    

            do_action('wplms_appointment_requsted_by_user',get_current_user_id(),$schedule);

            echo json_encode(array('status'=>0,'url'=>'/', 'message'=>__('Appointment request sent to Instructor','wplms-appointments'),'args'=>$pending_args));
            die();
        }
        

        $product_id = $details['args']['product']['id'];     

        if(empty($product_id)){
            echo json_encode(array('status'=>0, 'message'=>__('Pricing enabled but no price set for slot.','wplms-appointments'),'extra'=>$_POST));
            die();
        }

        if(!function_exists('WC')){
            do_action('wplms_book_booking_product',$details['args']);
            die();
        }
        //add product to cart , add extra cart information
        
        $extra =apply_filters('wplms_appointments_cart_timer',15*60);

        $time = time()+(empty($extra)?900:$extra);

        $allow_add_to_cart = apply_filters('wplms_appointment_slot_add_to_cart',1,$details,$product_id);


        if($allow_add_to_cart){

            $args = array(
                    'appointment_ids' => $slot_ids,
                    'slot_details'=>$slot_details,
                    'instructor'=>array('name'  => bp_core_get_user_displayname(intval($schedule['author_id'])),
        'image' => bp_core_fetch_avatar ( array( 'item_id' => intval($schedule['author_id']), 'type' => 'full','html'=>false ))),
                    'expires'=>$time
                );
            if(!empty($details['args']['form'])){
                $args['form']=$details['args']['form'];
            }
            WC()->cart->add_to_cart( $product_id,count($slot_ids),'','',$args);
            foreach($slot_ids as $slot_id){
                wplms_appointments_record_active_slot(array(
                    'user_id'=>get_current_user_id(),
                    'expiry'=>$time,
                    'appointment_id'=>$slot_id
                ));    
            }
            

            echo json_encode(array('status'=>1, 'message'=>__('Item added to cart','wplms-appointments'),'expires'=>$time*1000,'product_id'=>$product_id,'url'=>wc_get_cart_url()));
        }

        die();
    }

    function timer_expired(){
        
        if(!WC()->cart->is_empty()){
            $caritems = WC()->cart->get_cart();
            foreach($caritems as $cartItemKey=>$item){

                if(!empty($item['appointment_ids'])){
                    

                    if($item['expires'] < time()){
                        WC()->cart->remove_cart_item( $cartItemKey );   
                        
                    }
                        
                }
            }

            //remove from record
            wplms_appointments_get_active_slots();

        }
    }
    

    function show_cart_timer(){
        echo '<script src="'.plugins_url('../assets/js/moment.min.js',__FILE__).'"></script>';
        ?>
        <script>
            jQuery(document).ready(function($){
                const wplms_cart_timer_fixed_timestamp = <?php echo time(); ?>;
                

                function wplms_a_cart_timer(){
                    jQuery('.wplms_appointment_cart_timer').each(function(){

                        if(jQuery(this).text().indexOf(':') < 0){
                            let time = parseInt(jQuery(this).text()) - wplms_cart_timer_fixed_timestamp;
                        
                               var $this = jQuery(this);
                                let inteval = setInterval(function(){
                                    if(time <= 0){
                                        clearInterval(inteval);
                                        //alert('removing cart item ...');
                                        window.location = '<?php echo wc_get_cart_url(); ?>';
                                    }else{
                                        if(time < 0){time=0;}
                                        $this.html(Math.floor(time/60)+':'+Math.floor(time%60));
                                        time = time - 1;
                                    }
                                },1000);
                        }
                        
                    });

                    jQuery('.converted_appointment_datetime').remove();
                    jQuery('.convert_appointment_datetime').each(function(){ 

                        let textval = jQuery(this).text().split('-');
                        let startObj = new Date(parseInt(textval[0])*1000); 
                        let endObj = new Date(parseInt(textval[1])*1000); 

                        let dateformat = '<?php echo ($init->settings['appointments_date_format'])?$init->settings['appointments_date_format']:'MM-DD-YY'; ?>';
                        let timeformat = '<?php echo ($init->settings['appointments_time_format'])?$init->settings['appointments_time_format']:'HH:mm';?>';



                        let html = '<div class="converted_appointment_datetime"><span class="dateObj">\
                        <span class="date_dateObj">'+((startObj.getDate() === endObj.getDate())?moment(startObj).format(dateformat):moment(startObj).format(dateformat)+'-'+moment(endObj).format(dateformat))+'</span>\
                        <span class="time_dateObj">'+moment(startObj).format(timeformat)+' - '+moment(endObj).format(timeformat)+'</span>\
                        </span></div>'; 
                        jQuery(this).after(html);    
                    });
                }
                wplms_a_cart_timer();

                

                jQuery( document.body ).on( 'updated_checkout',wplms_a_cart_timer);
                jQuery( document.body ).on( 'updated_wc_div', wplms_a_cart_timer );
                jQuery( document.body ).on( 'updated_cart_totals', wplms_a_cart_timer );
            });
        </script>
        <style>.wplms_appointment_cart_timer{padding: 0 10px;top:6px; color: #ff6200; position: absolute; right: 0;}.wplms_appointment_cart_timer:before { content: "\f017"; font-family: fontawesome; padding-right: 3px; }strong.appointment_info {   display:grid;grid-gap: 5px;
                padding-right: 75px;grid-template-columns:1fr 60px;
                position: relative;
                margin-right: 10px;
            }
            .convert_appointment_datetime{display:none;}
            .appointment_info > .converted_appointment_datetime{padding:2px 0;}
            .appointment_info > .converted_appointment_datetime:before{content:"\f017";opacity: 0.4;font-family:fontawesome;}
            .instructor_in_cart span{display:block;}
            .instructor_in_cart img {
            border-radius: 50%;
        }</style>
        <?php
    }

    function remove_active_slot( $cart_item_key, $cart ) {

        if(!empty($cart->cart_contents[ $cart_item_key ]['appointment_ids'])){
            $appointment_ids = $cart->cart_contents[ $cart_item_key ]['appointment_ids']; 
            if(!is_Array($appointment_ids)){
                $appointment_ids=array($appointment_ids);
            }
            foreach($appointment_ids as $appointment_id){
                wplms_appointments_remove_active_slot($appointment_id);
            }
        }
    }

    function add_appointment_meta_to_order_item_meta($item_id, $values){

        /*
         'appointment_id' => $_POST['appointment_id'],
                    'type'=>$_POST['type'],
                    'parent_appointment_id'=>$_POST['parent_appointment_id'],
                    'course_id' => $course_id,
                    'expires'=>$time
                    */
       

        //Return if email is empty
        if(empty($values) || empty($values['appointment_ids'])){
            return;
        }

        $appointment_ids = $values['appointment_ids'];
        
        
        wc_add_order_item_meta($item_id,'_appointment_ids',$appointment_ids);

        if(!empty($values['course_id'])){
            wc_add_order_item_meta($item_id,'_course_id',$values['course_id']);    
        }
        
        if(!empty($values['form'])){
            wc_add_order_item_meta($item_id,'_appointment_form',$values['form']);    
        }
        
    }


    
    //schedule function clear if order not complete
    function wplms_appointments_update_appointment($id,$type,$args){
        if($type === 'check_order_completed'){

            $order_id = $id;
            $order = new WC_Order( $order_id );
            if ( !$order->has_status( 'processing' ) && !$order->has_status( 'completed' ) ) {
                $appointments_db = new WPLMS_APPOINTMENTS_DB;
                $appointments_meta_db = new WPLMS_APPOINTMENTSMETA_DB;

                if(empty($args['meta_id'])){
                    $appointments_db->update_appointment(array('booker_id'=>0,'status'=>'open'));
                }else{
                    $appointments_db->update_appointment(array('status'=>'open'));
                    $appointments_meta_db->delete_appointment_meta(array('meta_id'=>$args['meta_id']));
                }
            }
        }
    }

    function wplms_appointment_enable_access($order_id){

        $order = new WC_Order( $order_id );
        $items = $order->get_items();
        
        $user_id=$order->get_user_id();

        foreach($items as $item_id=>$item){
            
            $appointment_ids =wc_get_order_item_meta($item_id,'_appointment_ids',true);
            
            if(!empty($appointment_ids)){
                
               
                //update appointment set booker ID
                $appointments_db = new WPLMS_APPOINTMENTS_DB;
                $appointments_meta_db = new WPLMS_APPOINTMENTS_META_DB;
          

                $appointments = $appointments_db->get_appointments(array('appointment_id'=>$appointment_ids));

                
                //schedule event to clear appointment data
                $info = array();


                foreach($appointments as $appointment){
                    
                    
                    
                        $instructor_id = $appointment['author_id'];

                        $seats = wplms_appointments_get_max_seats(array('instructor_id'=>$instructor_id,
                                'schedule_id'=>(empty($appointment['parent_appointment_id'])?$appointment['appointment_id']:$appointment['parent_appointment_id'] )));
                        
                        if(empty($appointment['booker_id'])){

                            $args = array(
                                'appointment_id'=>$appointment['appointment_id'],
                                'booker_id'=> $user_id
                            );
                            if($seats <= 1){
                                $args['status']='closed';
                            }


                            $appointments_db->update_appointment($args);

                            

                        }else{
                            
                            $metas = $appointments_meta_db->get_appointments_meta(array('appointment_id'=>$appointment['appointment_id'],'meta_key'=>'booker_id'));

                            $args = array();
                            if($seats <= (count($metas)+1)){
                                $args = array(
                                    'appointment_id'=>$appointment['appointment_id'],
                                    'status'=>'closed',
                                );
                                $appointments_db->update_appointment($args);
                            }
                            $appointments_meta_db->add_appointment_meta(array('appointment_id'=>$appointment['appointment_id'],'meta_key'=>'booker_id','meta_value'=>$user_id));
                            

                        }

                        $metas = $appointments_meta_db->get_appointments_meta(array('appointment_id'=>$appointment['appointment_id'],'meta_key'=>'order_details'));

                        $order_details = array();
                        if(!empty($metas)){
                            foreach($metas as $meta){
                                if($meta->meta_key == 'order_details'){
                                    $order_details=$meta->meta_value;
                                    if(is_string($order_details)){
                                        $order_details=unserialise($order_details);
                                    }
                                    break;
                                }
                            }
                        }

                        $order_details[$user_id]=array(
                                'type'=>'woocommerce',
                                'order_id'=>$order_id,
                                'item_id'=>$item_id
                            );
                        
                        if(!empty($item['_appointment_form'])){
                            $booker_meta = $appointments_meta_db->get_appointments_meta(array('appointment_id'=>$appointment['appointment_id'],'meta_key'=>$user_id,'single'=>true));

                            if(empty($booker_meta)){
                                $booker_meta = array();
                            }


                            $booker_meta[]=array(
                                'type'=>'form',
                                'value'=>$item['_appointment_form']
                            );
                            $appointments_meta_db->update_appointment_meta(array('appointment_id'=>$appointment['appointment_id'],'meta_key'=>$user_id,'meta_value'=>$booker_meta));
                        }

                        $appointments_meta_db->update_appointment_meta(array('appointment_id'=>$appointment['appointment_id'],'meta_key'=>'order_details','meta_value'=>$order_details,'single'=>1));

                        wplms_appointments_remove_active_slot($appointment['appointment_id']);
                        
                        do_action('wplms_appointments_booking_confirmed',$user_id, $appointment);
                        
                    
                }
            }
        }

    }

    function wplms_appointment_disable_access(){

        $order = new WC_Order( $order_id );
        $items = $order->get_items();
        $user_id=$order->get_user_id();
       

        foreach($items as $item_id=>$item){
            if(!empty($item['appointment_id'])){
                //update appointment set booker ID
                $appointments_db = new WPLMS_APPOINTMENTS_DB;
            
                $appointments_db->update_appointment(array(
                    'appointment_id'=>(int)$item['appointment_id'],
                    'booker_id'=> 0
                ));
                
                do_action('wplms_appointment_booking_cancelled',$item['appointment_id'],$user_id,$item['course_id']);
            }
        }

    }

    function touch_point($appointment_id,$user_id,$course_id){


        $appointments_db = new WPLMS_APPOINTMENTS_DB;
            
        $appointment = $appointments_db->get_appointment(array(
            'appointment_id'=>(int)$item['appointment_id']
        ));

        $activity_id = bp_course_record_activity(array(
              'action' => sprintf(__('Student booked appointment for course %s','vibe'),get_the_title($course_id)),
              'content' => sprintf(__('Student %s booked appointment for course %s','vibe'),bp_core_get_userlink( $user_id ),get_the_title($course_id)),
              'type' => 'subscribe_course',
              'item_id' => $course_id,
              'primary_link'=>get_permalink($course_id),
              'secondary_item_id'=>$user_id
        ));

        bp_course_record_activity_meta(array(
              'id' => $activity_id,
              'meta_key' => 'wplms_appointments_booking_meta',
              'meta_value' => $appointment
        ));


    }


    function authentication_meeting_endpoints(){
        add_rewrite_endpoint('endmeeting/(?P<schedule_id>/d+)', EP_PAGES);
        add_rewrite_endpoint('recordings/(?P<appointment_id>/d+)', EP_PAGES);    
    }

    function filter_request( $vars){
        
        if(isset($vars)){
            if (isset($vars['page']) && isset($vars['name']) && is_numeric($vars['page']) && $vars['name'] == 'endmeeting'){

                if(is_user_logged_in()){
                    $user_id = get_current_user_id();
                    if(class_exists('Vibe_CustomTypes_Permalinks')){
                        $x = Vibe_CustomTypes_Permalinks::init();
                        $permalinks = $x->permalinks;    
                    }else{
                        $permalinks = get_option( 'vibe_course_permalinks' );
                    }

                    if(!empty($permalinks['appointments_slug'])){
                        $slug = str_replace('/','',$permalinks['appointments_slug']);
                    }else{
                        $slug = BP_APPOINTMENTS_SLUG;
                    }
                    //$url = bp_core_get_user_domain().'/'.$slug.'/?end='.$vars['page'];
                    $url = bp_loggedin_user_domain().'/'.$slug.'/?end='.$vars['page'];

                }else{
                    $url = home_url();
                }
                
                do_action('wplms_appointments_meeting_ended', $vars['page']);

                wp_redirect( $url );
                exit;
                //print_r($url); //--> /bookings/?end=45
                //die;
            }
            if (isset($vars['page']) && isset($vars['name']) && is_numeric($vars['page']) && $vars['name'] == 'recordings' && function_exists('messages_new_message')){
                
                $bookers = wplms_get_appointment_bookers($vars['page']);
                $instructor = wplms_get_appointment_instructor($vars['page']);
                if(!empty($bookers) && !empty($instructor)){
                    foreach($bookers as $booker){
                        $send = messages_new_message( array(
                            'recipients' => $bookers,
                            'sender_id' => $instructor,
                            'subject'    => __('Meeting recording available','wplms-appointments'),
                            'content'    => __('Check profile - appointments - my recordings.','wplms-appointments'),
                        ) );
                        $send = messages_new_message( array(
                            'recipients' => $instructor,
                            'subject'    => __('Meeting recording available','wplms-appointments'),
                            'content'    => __('Check profile - appointments - my recordings.','wplms-appointments'),
                        ) );
                    }
                    
                }
            }
        }
        return $vars;
    }


    function directory_featured_video(){

        ?><script>
            jQuery(document).ready(function($){
                //https://www.youtube.com/watch?v=EngW7tLk6R8
                
                document.addEventListener("wplms_appointment_open_magnific",(et)=>{

                    let videoUrl = et.detail;
                    
                    jQuery('.instructor_video_popup').magnificPopup({
                        disableOn: 700,
                        type: 'iframe',
                        mainClass: 'mfp-fade',
                        removalDelay: 160,
                        preloader: true,

                        fixedContentPos: false,
                        iframe: {
                            src:videoUrl
                        }
  
                    });
                });
            });
        </script>
        <?php
    }


    function show_additional_info_woocommerce_order_emails( $order, $sent_to_admin, $plain_text, $email){

        if ( $email->id == 'new_order' ) {

            foreach ( WC()->cart->get_cart() as $cart_item ) {
            $product = $cart_item['data'];
                if(!empty($product) && !empty($cart_item['appointment_ids'])){
                    echo '<p><strong>The Appointment'.$cart_item['appointment_ids'][0].' is booked with instructor '.$cart_item['instructor']['name'].'</strong></p>';
                }
            }
        }

    }


}

WPLMS_Appointments_Actions::init();
