<?php
/**
 * Settings in Admin
 *
 * @author 		VibeThemes
 * @category 	Admin
 * @package 	wplms-chat/Includes
 * @version     1.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

class WPLMS_Appointments_Admin{


	public static $instance;

    public static function init(){

        if ( is_null( self::$instance ) )
            self::$instance = new WPLMS_Appointments_Admin();
        return self::$instance;
    }


    function __construct(){

		add_action('customize_register', array($this,'wplms_appointments_customize'));
		
		add_action('wp_footer',array($this,'chat_customizer_style'),99);
		add_action('customize_controls_print_scripts', 'vibe_customize_scripts');

    }

    function wplms_appointments_customize($wp_customize){

		$wplms_chat_customizer = array(
			    'sections' => array(
			                    'appointments'=>'Appointments',
			                    ),
			    'controls' => apply_filters('wplms_customizer_config',array(
			        'appointments' => array( 
			                            
		    		)
			    )
			)
		);
		/* =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  */
		/* =  =  =  =  =  =  =  =  =  = = SECTIONS  =  =  =  =  =  =  =  =  =  =  =  */
		/* =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  */
		    $i=164; // Show sections after the WordPress default sections
		    if(isset($wplms_chat_customizer) && is_Array($wplms_chat_customizer)){
		        foreach($wplms_chat_customizer['sections'] as $key=>$value){
		            $wp_customize->add_section( $key, array(
		            'title'          => $value,
		            'priority'       => $i+40,
		        ) );
		            $i = $i+40;
		        }
		    }
		    

		/* =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  */
		/* =  =  =  =  =  =  =  = = SETTINGS & CONTROLS  =  =  =  =  =  =  =  =  =  */
		/* =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  */
		if(isset($wplms_chat_customizer) && is_array($wplms_chat_customizer))
		    foreach($wplms_chat_customizer['controls'] as $section => $settings){ $i=1;
		        foreach($settings as $control => $type){
		            $i=$i+2;
		            /* =  =  =  REGISTER SETTING  =  =  =  = =*/
		            $wp_customize->add_setting( 'wplms_chat_customizer['.$control.']', array(
		                                                'label'         => $type['label'],
		                                                'type'           => 'option',
		                                                'capability'     => 'edit_theme_options',
		                                                'transport'  => 'refresh',
		                                                'default'       => (empty($type['default'])?'':$type['default'])
		                                            ) );
		            
		            switch($type['type']){
		                case 'color':
		                        $wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, $control, array(
		                        'label'   => $type['label'],
		                        'section' => $section,
		                        'settings'   => 'wplms_chat_customizer['.$control.']',
		                        'priority'       => $i,
		                        ) ) );            
		                                
		                    break;   
		                case 'image':
		                        $wp_customize->add_control( new WP_Customize_Image_Control( $wp_customize, $control, array(
		                            'label'   => $type['label'],
		                            'section' => $section,
		                            'settings'   => 'wplms_chat_customizer['.$control.']',
		                            'priority'       => $i
		                        ) ) );
		                    break;
		                case 'select':
		                        $wp_customize->add_control( $control, array(
		                                'label'   => $type['label'],
		                                'section' => $section,
		                                'settings'   => 'wplms_chat_customizer['.$control.']',
		                                'priority'   => $i,
		                                'type'    => 'select',
		                                'choices'    => (empty($type['choices'])?'':$type['choices'])                        
		                                ) );
		                break;
		                
		            }
		        }
		    }
    }

    function chat_customizer_style(){
    	$wplms_chat_customizer=get_option('wplms_chat_customizer');
		echo '<style>';
		$css = '
		';
        $buffer = preg_replace('!/\*[^*]*\*+([^/][^*]*\*+)*/!', '', $css);
        $buffer = str_replace(': ', ':', $buffer);
        $buffer = str_replace(array("\r\n", "\r", "\n", "\t", '  ', '    ', '    '), '', $buffer);
        echo($buffer);
    	echo '</style>';
    }
}
WPLMS_Appointments_Admin::init();
