<?php
/**
 * Scheduler WPLMS appointments
 *
 * @author 		VibeThemes
 * @category 	Init
 * @package 	wplms-appointments/Includes
 * @version     1.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

/*

NOTES

* WP Cron event nomenclature :

wplms_meeting_SCHEDULE_ID 

*/


class WPLMS_Appointments_Scheduler{


	public static $instance;

    public static function init(){

        if ( is_null( self::$instance ) )
            self::$instance = new WPLMS_Appointments_Scheduler();
        return self::$instance;
    }


    function __construct(){

        //Save Schedules - > Set CRON wplms_appointment_schedule_id
        add_filter('wplms_update_availability',array($this,'wplms_add_appointment_schedule'),10,2);

        

        add_action('wplms_appointment_schedule_id',array($this,'set_next_schedule_event'),1);

    }


    function wplms_add_appointment_schedule($return,$args){

        if(empty($args))
            return $return;

        $meta_db = new WPLMS_APPOINTMENTS_META_DB();

        $init = WPLMS_Appointments_Init::init();
        if(empty($init->settings['meeting_time_buffer']))
            return $return;


        foreach($args['schedule'] as $schedule){

            $flag = 1;
            $schedule_slots = [];
            $schedule_id = intval($schedule['appointment_id']);
            foreach($args['events'] as $event){
                if($event['parent_appointment_id'] == $schedule_id){
                    $schedule_slots[]=$event;
                }
            }

            $schedule_queue = array();

            if(!empty($schedule_slots)){

                $nextScheduled_timestamp = wp_next_scheduled('wplms_appointment_schedule_id',array($schedule_id));

                if($timestamp){
                    $flag = 0;
                    foreach($schedule_slots as $schedule_slot){

                        $ttime = wplms_getdate_appointment_timestamp($schedule_slot);
                        if($ttime > time()){
                            $schedule_queue[]= array('timestamp'=>$ttime,'appointment_id'=>$schedule_slot['appointment_id']);
                        }
                    }

                    usort($schedule_queue, function($a,$b){ 
                        return $a['timestamp'] > $b['timestamp'];
                    });
                    
                    $schedule_slot_time = $schedule_queue[0]['timestamp'];
                    

                    if($nextScheduled_timestamp !=  $init->settings['meeting_time_buffer']+$schedule_slot_time){
                        wp_clear_scheduled_hook( 'wplms_appointment_schedule_id',array($schedule_id));
                        $flag = 2;
                    }

                    // else clear the scheduled_event

                }

                if($flag){

                    $schedule_id = $schedule['appointment_id'];
                    
                    $appointment = array();

                    if($flag === 1){
                        foreach($schedule_slots as $schedule_slot){

                            $ttime = wplms_getdate_appointment_timestamp($schedule_slot);
                            if($ttime > time()){

                                $schedule_queue[]= array('timestamp'=>$ttime,'appointment_id'=>$schedule_slot['appointment_id']);
                            }
                        }                    


                        usort($schedule_queue, function($a,$b){ 
                            return $a['timestamp'] > $b['timestamp'];
                        });
                        $schedule_slot_time = $schedule_queue[0]['timestamp'];
                    }


                    $timestamp = $init->settings['meeting_time_buffer']+$schedule_slot_time;
            
                    
                    $this->schedule_timestamp_map[$schedule_id] = $timestamp;
                    if($timestamp > time()){
                        wp_schedule_single_event($timestamp, 'wplms_appointment_schedule_id',array($schedule_id));
                        //meta db

                        
                        $meta_db->update_appointment_meta(
                            array('appointment_id' => $schedule_id,'meta_key'=>'schedule_queue','meta_value'=>$schedule_queue)
                        );
                    }
                    
                }
            }
            
        }
        return $return;
    }



    function set_next_schedule_event($schedule_id){

        

        $init = WPLMS_Appointments_Init::init();
        $init->get_global_settings();
        if(empty($init->settings['meeting_time_buffer']))
            return $return;


        $db = new WPLMS_APPOINTMENTS_DB;

        $meta_db = new WPLMS_APPOINTMENTS_META_DB(); 
        $schedule_queue = $meta_db->get_appointments_meta(array('appointment_id' => $schedule_id,'meta_key'=>'schedule_queue'));


        $schedule_queue = unserialize($schedule_queue[0]['meta_value']);
        
        $current_event = 0;
        foreach($schedule_queue as $i=>$appointment){


            if(($schedule_queue[$i]['timestamp'] - 60*$init->settings['meeting_time_buffer'] ) < time()){
                $current_event = $appointment['appointment_id'];
                unset($schedule_queue[$i]);
            }
        }
        

        do_action('appointment_start',$schedule_id,$schedule_queue[0]['appointment_id']);

        if(!empty($schedule_queue)){
            $i=0;
            $timestamp = $schedule_queue[0]['timestamp'] - $init->settings['meeting_time_buffer']*60;
            while($timestamp < time()){
                $i++;
                $timestamp = $schedule_queue[$i]['timestamp'] - $init->settings['meeting_time_buffer']*60;
            }

            wp_schedule_single_event($timestamp, 'wplms_appointment_schedule_id',array($schedule_id));
        }
    }
}

WPLMS_Appointments_Scheduler::init();
