<?php
/**
 * Shortcodes WPLMS appointments
 *
 * @author 		VibeThemes
 * @category 	Init
 * @package 	wplms-appointments/Includes
 * @version     1.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}


class WPLMS_Appointments_Shortcodes{


	public static $instance;

    public static function init(){

        if ( is_null( self::$instance ) )
            self::$instance = new WPLMS_Appointments_Shortcodes();
        return self::$instance;
    }


    function __construct(){
 
        add_shortcode('wplms_appointment_booking', array($this,'wplms_appointment_booking'));
        add_action( 'wp_enqueue_scripts', array($this,'enqueue_react_scripts'));

    }


        function wplms_appointment_booking( $atts, $content = null ) {
            extract(shortcode_atts(array(
            'schedule_ids'         => '',
            ), $atts));

           
            add_action('wp_footer',function(){
                ?>
                <script>
                setTimeout(function(){ //allow react script to load
                    var event = new CustomEvent("wplms_appointment_set_args", { "detail": 1});
                    document.dispatchEvent(event);
                },500);
                
            </script>
                <?php
            },999);

            return '<div id="wplms_instructor_course_appointments"></div><script>var schedule_ids = ['.$schedule_ids.'];</script><style>.rbc-calendar {min-height: 600px;}</style>'; 
        }


        function enqueue_react_scripts(){

            global $post;

            if( is_a( $post, 'WP_Post' ) && has_shortcode( $post->post_content, 'wplms_appointment_booking') || ($post->ID == vibe_get_option('take_course_page') && (get_post_meta(wplms_appointments_get_course_id_instatus(),'vibe_wplms_appointments',true) == 'S')) 
                ) {

        
                $init = WPLMS_Appointments_Init::init();
                $args = apply_filters('wplms_appointments_course_book_args',array('type'=>'schedule_booking'));
                $init->load_scripts($args);


                wp_enqueue_script('wplms_appointments_mybookings',plugins_url('../assets/js/mybookings.js',__FILE__),array(),WPLMS_APPOINTMENTS_VERSION,true);
                wp_enqueue_style('wplms_appointments_settings',plugins_url('../assets/css/appointment_settings.css',__FILE__),array(),WPLMS_APPOINTMENTS_VERSION);
                wp_enqueue_style('wplms_appointments_settings_calendar',plugins_url('../assets/css/react-big-calendar.css',__FILE__),array(),WPLMS_APPOINTMENTS_VERSION);

            }

           
        }

}

WPLMS_Appointments_Shortcodes::init();
