<?php

class Wplms_Appointments_Tc {


	public static $instance;
    
    public static function init(){
        if ( is_null( self::$instance ) )
            self::$instance = new Wplms_Appointments_Tc;
        return self::$instance;
    }

	private function __construct(){

		add_filter('wplms_touch_points',array($this,'touch_points'));
		
    	add_filter('bp_course_all_mails',array($this,'email_templates'),9999);
    	add_filter( 'bp_course_format_notifications',array($this,'set_format_for_notifications') ,11,5);
    	add_filter('wplms_appointments_appointment_id_html',array($this,'wplms_appointments_appointment_id_html'),10,3);
		$activity = WPLMS_Appointments_Activity::init();



		$this->run_touchpoints();

	}



	function wplms_appointments_appointment_id_html($appointment_html,$appointment,$user_id){
		
        if(!empty($appointment)){
            if(is_array($appointment) && isset($appointment['appointment_id'])){
            	if(!empty($appointment['start_date']) && !empty($appointment['end_date'])){
            		$start_time_readable =  wplms_appointments_convert_utc_local($appointment['start_date'],$appointment['start_time'],$user_id);
            		$end_time_readable =  wplms_appointments_convert_utc_local($appointment['end_date'],$appointment['end_time'],$user_id);

            		return '[Id : '.$appointment['appointment_id'].']['.$start_time_readable.' - '.$end_time_readable.']';
            	}else{
            		$dbappointment = array();
			        $db = new WPLMS_APPOINTMENTS_DB;
			        $dbappointments = $db->get_appointments(Array('appointment_id'=>$appointment['appointment_id']));
			        if(!empty($dbappointments)){
			            $dbappointment = $dbappointments[0];
			        }
			        if(!empty($dbappointment)){
			        	if(!empty($dbappointment['start_date']) && !empty($dbappointment['end_date'])){
			        		$start_time_readable =  wplms_appointments_convert_utc_local($dbappointment['start_date'],$dbappointment['start_time'],$user_id);
	            			$end_time_readable =  wplms_appointments_convert_utc_local($dbappointment['end_date'],$dbappointment['end_time'],$user_id);
	            			return '[Id : '.$dbappointment['appointment_id'].']['.$start_time_readable.' - '.$end_time_readable.']';
			        	}else{
			        		return $appointment['appointment_id'];
			        	}
			        }else{
			        	return $appointment['appointment_id'];
			        }
            		
            	}
            }else{

            	$dbappointment = array();
		        $db = new WPLMS_APPOINTMENTS_DB;
		        $dbappointments = $db->get_appointments(Array('appointment_id'=>$appointment));
		        if(!empty($dbappointments)){
		            $dbappointment = $dbappointments[0];
		        }
		        if(!empty($dbappointment)){
		        	if(!empty($dbappointment['start_date']) && !empty($dbappointment['end_date'])){
		        		$start_time_readable =  wplms_appointments_convert_utc_local($dbappointment['start_date'],$dbappointment['start_time'],$user_id);
            			$end_time_readable =  wplms_appointments_convert_utc_local($dbappointment['end_date'],$dbappointment['end_time'],$user_id);
            			return '[Id : '.$dbappointment['appointment_id'].']['.$start_time_readable.' - '.$end_time_readable.']';
		        	}else{
		        		return $appointment;
		        	}
		        }else{
		        	return $appointment;
		        }
            }
        }
    }

	function get_touch_appointment($appointment,$user_id){
		
		if(!empty($appointment)){
            if(is_array($appointment) && isset($appointment['appointment_id'])){

                return apply_filters('wplms_appointments_appointment_id_html','<a class="activity_appointment_id" data-id="'.$appointment['appointment_id'].'">'.$appointment['appointment_id'].'</a>',$appointment,$user_id);
            }else{
                return apply_filters('wplms_appointments_appointment_id_html','<a class="activity_appointment_id" data-id="'.$appointment.'">'.$appointment.'</a>',$appointment,$user_id);
            }
        }
		return $html;
	}

	function set_format_for_notifications($notification, $action, $item_id, $secondary_item_id, $total_items){
		
		
		switch ($action) {
			case 'student_appointments_booking_confirmed':
				$appointment_html = $this->get_touch_appointment($item_id,$secondary_item_id);
				$notification = sprintf(__('Your appointment %s is confirmed by instructor %s','wplms-appointments'),$appointment_html,bp_core_get_userlink($secondary_item_id));
			break;

			case 'instructor_appointments_booking_confirmed':
				$appointment_html = $this->get_touch_appointment($item_id,$secondary_item_id);
				$notification = sprintf(__('Appointment %s confirmed for Student %s','wplms-appointments'),$appointment_html,bp_core_get_userlink($secondary_item_id));
			break;
			case 'student_appointments_booking_rejected':
				$appointment_html = $this->get_touch_appointment($item_id,$secondary_item_id);
				$notification = sprintf(__('Your booking %s rejected by Instructor %s','wplms-appointments'),$appointment_html,bp_core_get_userlink($secondary_item_id));
			break;
			case 'instructor_appointments_booking_rejected':
				$appointment_html = $this->get_touch_appointment($item_id,$secondary_item_id);
				$notification = sprintf(__('Appointment %s rejected for Student %s','wplms-appointments'),$appointment_html,bp_core_get_userlink($secondary_item_id));
			break;
			case 'instructor_appointments_appointment_updated':
				$appointment_html = $this->get_touch_appointment($item_id,$secondary_item_id);
				$notification = sprintf(__('You updated appointment %s','wplms-appointments'),$appointment_html);
			break;
			case 'admin_appointments_appointment_updated':
				$appointment_html = $this->get_touch_appointment($item_id,$secondary_item_id);
				$notification = sprintf(__('Appointment %s updated by %s','wplms-appointments'),$appointment_html,bp_core_get_userlink($secondary_item_id));
			break;
			case 'student_appointment_requsted_by_user':
				$appointment_html = $this->get_touch_appointment($item_id,$secondary_item_id);
				$notification = sprintf(__('You requested appointment %s for instructor %s','wplms-appointments'),$appointment_html,bp_core_get_userlink($secondary_item_id));
			break;
			case 'instructor_appointment_requsted_by_user':
				$appointment_html = $this->get_touch_appointment($item_id,$secondary_item_id);
				$notification = sprintf(__('Appointment %s requested by Student %s','wplms-appointments'),$appointment_html,bp_core_get_userlink($secondary_item_id));
			break;
			case 'student_appointments_appointment_rescheduled':
				$appointment_html = $this->get_touch_appointment($item_id,$secondary_item_id);
				$notification = sprintf(__('Your appointment %s for instructor %s rescheduled','wplms-appointments'),$appointment_html,bp_core_get_userlink($secondary_item_id));
			break;
			case 'instructor_appointments_appointment_rescheduled':
				$appointment_html = $this->get_touch_appointment($item_id,$secondary_item_id);
				$notification = sprintf(__('Appointment %s rescheduled for Student %s','wplms-appointments'),$appointment_html,bp_core_get_userlink($secondary_item_id));
			break;
			case 'student_appointments_appointment_cancelled':
				$appointment_html = $this->get_touch_appointment($item_id,$secondary_item_id);
				$notification = sprintf(__('Your booking %s cancelled by %s','wplms-appointments'),$appointment_html,bp_core_get_userlink($secondary_item_id));
			break;
			case 'instructor_appointments_appointment_cancelled':
				$appointment_html = $this->get_touch_appointment($item_id,$secondary_item_id);
				$notification = sprintf(__('Appointment %s cancelled for Student %s','wplms-appointments'),$appointment_html,bp_core_get_userlink($secondary_item_id));
			break;
			case 'student_appointment_requested_cancellation':
				$appointment_html = $this->get_touch_appointment($item_id,$secondary_item_id);
				$notification = sprintf(__('You requested cancellation for appointment %s with instructor %s','wplms-appointments'),$appointment_html,bp_core_get_userlink($secondary_item_id));
			break;
			case 'instructor_appointment_requested_cancellation':
				$appointment_html = $this->get_touch_appointment($item_id,$secondary_item_id);
				$notification = sprintf(__('Appointment %s cancellation requested by Student %s','wplms-appointments'),$appointment_html,bp_core_get_userlink($secondary_item_id));
			break;


			case 'student_appointment_requested_reschedule':
				$appointment_html = $this->get_touch_appointment($item_id,$secondary_item_id);
				$notification = sprintf(__('You requested reschedule for appointment %s with instructor %s','wplms-appointments'),$appointment_html,bp_core_get_userlink($secondary_item_id));
			break;
			case 'instructor_appointment_requested_reschedule':
				$appointment_html = $this->get_touch_appointment($item_id,$secondary_item_id);
				$notification = sprintf(__('Appointment %s reschedule requested by Student %s','wplms-appointments'),$appointment_html,bp_core_get_userlink($secondary_item_id));
			break;

			case 'student_cancel_schedule_meeting':
				$appointment_html = $this->get_touch_appointment($item_id,$secondary_item_id);
				$notification = sprintf(__('Meeting %s cancelled by Instructor %s','wplms-appointments'),$appointment_html,bp_core_get_userlink($secondary_item_id));
			break;
			case 'instructor_cancel_schedule_meeting':
				$appointment_html = $this->get_touch_appointment($item_id,$secondary_item_id);
				$notification = sprintf(__('Meeting %s cancelled','wplms-appointments'),$appointment_html,bp_core_get_userlink($secondary_item_id));
			break;

			case 'student_appointment_start':
				$appointment_html = $this->get_touch_appointment($item_id,$secondary_item_id);

				$db = new WPLMS_APPOINTMENTS_DB;
				$appointments = $db->get_appointments(array('appointment_id'=>$item_id));
				
				//$diff = round($appointments[0]['start_date']/1000)+60*$appointments[0]['start_time'] - time();

				$notification = sprintf(__('Appointment %s is about to start','wplms-appointments'),$appointment_html);
			break;
			case 'instructor_appointment_start':
				$appointment_html = $this->get_touch_appointment($item_id,$secondary_item_id);

				$db = new WPLMS_APPOINTMENTS_DB;
				$appointments = $db->get_appointments(array('appointment_id'=>$item_id));
				
				//$diff = round($appointments[0]['start_date']/1000)+60*$appointments[0]['start_time'] - time();

				$notification = sprintf(__('Appointment %s with %s is about to start ','wplms-appointments'),$appointment_html,bp_core_get_userlink($appointments[0]['author_id']));
			break;

			
		}
		return $notification;
	}

	function run_touchpoints(){
		if(empty($this->lms_settings))
			$this->lms_settings = get_option('lms_settings');
		if(isset($this->lms_settings) && isset($this->lms_settings['touch']) && is_array($this->lms_settings['touch'])){

			foreach($this->lms_settings['touch'] as $key => $value){
				$hook = $this->get_touch_points()[$key]['wplms_appointment_hook'];
				if(!empty($hook)){
					
					if(!empty($value['student']['message'])){
						$student_fx = 'student_message_'.$key;
						if(function_exists($student_fx)){
							add_action($hook,$student_fx,10,$this->get_touch_points()[$key]['params']);
						}else{
							add_action($hook,array($this,$student_fx),10,$this->get_touch_points()[$key]['params']);	
						}
					}

					if(!empty($value['student']['notification'])){
						$student_fx = 'student_notification_'.$key;
						if(function_exists($student_fx)){
							add_action($hook,$student_fx,9,$this->get_touch_points()[$key]['params']);
						}else{
							add_action($hook,array($this,$student_fx),9,$this->get_touch_points()[$key]['params']);	
						}	
					}

					if(!empty($value['student']['email'])){
						$student_fx = 'student_email_'.$key;
						if(function_exists($student_fx)){
							add_action($hook,$student_fx,10,$this->get_touch_points()[$key]['params']);
						}else{
							add_action($hook,array($this,$student_fx),10,$this->get_touch_points()[$key]['params']);	
						}
					}

					if(!empty($value['instructor']['message'])){
						$instructor_fx = 'instructor_message_'.$key;
						if(function_exists($instructor_fx)){
							add_action($hook,$instructor_fx,15,$this->get_touch_points()[$key]['params']);
						}else{
							add_action($hook,array($this,$instructor_fx),15,$this->get_touch_points()[$key]['params']);	
						}
					}

					if(!empty($value['instructor']['notification'])){
						$instructor_fx = 'instructor_notification_'.$key;
						if(function_exists($instructor_fx)){
							add_action($hook,$instructor_fx,15,$this->get_touch_points()[$key]['params']);
						}else{
							add_action($hook,array($this,$instructor_fx),15,$this->get_touch_points()[$key]['params']);	
						}
					}

					if(!empty($value['instructor']['email'])){
						$instructor_fx = 'instructor_email_'.$key;
						if(function_exists($instructor_fx)){
							add_action($hook,$instructor_fx,15,$this->get_touch_points()[$key]['params']);
						}else{
							add_action($hook,array($this,$instructor_fx),15,$this->get_touch_points()[$key]['params']);	
						}
					}

					if(!empty($value['admin']['message'])){
						$admin_fx = 'admin_message_'.$key;

						if(function_exists($admin_fx)){
							add_action($hook,$admin_fx,25,$this->get_touch_points()[$key]['params']);
						}else{
							add_action($hook,array($this,$admin_fx),25,$this->get_touch_points()[$key]['params']);	
						}
					}

					if(!empty($value['admin']['notification'])){
						$admin_fx = 'admin_notification_'.$key;
						if(function_exists($admin_fx)){

							add_action($hook,$admin_fx,25,$this->get_touch_points()[$key]['params']);
						}else{
							add_action($hook,array($this,$admin_fx),25,$this->get_touch_points()[$key]['params']);	
						}
					}

					if(!empty($value['admin']['email'])){
						$admin_fx = 'admin_email_'.$key;
						if(function_exists($admin_fx)){
							add_action($hook,$admin_fx,25,$this->get_touch_points()[$key]['params']);
						}else{
							add_action($hook,array($this,$admin_fx),25,$this->get_touch_points()[$key]['params']);	
						}
					}
				}
				
			}
		}
	}

	function get_admins(){
		$admin_ids=array();
		if(empty($this->admin_ids)){
			$this->admin_ids = array();
		 	$user_query = new WP_User_Query( array( 'role' => 'Administrator' ,'fields' => array('ID','user_email')) );
			foreach( $user_query->results as $user){
				$admin_ids[] = array('ID' => $user->ID,'email'=> $user->user_email);
			}
			$this->admin_ids = $admin_ids;
		}

		return $this->admin_ids;
	}

	function touch_points($args){
		foreach ($this->get_touch_points() as $key => $touchpoint) {
			$args[$key] = $touchpoint;
		}
    	return $args;
    }

    function get_touch_points(){
    	$args['appointments_booking_confirmed'] = array(
			'label' => __('Appointment Booking confirmed','wplms-appointment'),
			'name' =>'appointments_booking_confirmed',
			'value' => array(
				'student' => admin_url('edit.php?taxonomy=bp-email-type&term=student_appointments_booking_confirmed&post_type=bp-email'),
				'instructor' => admin_url('edit.php?taxonomy=bp-email-type&term=instructor_appointments_booking_confirmed&post_type=bp-email'),
			),
			'type' => 'touchpoint',
			'hook' => '',
			'wplms_appointment_hook'=>'wplms_appointments_booking_confirmed',
			'params'=>2,
		);

    	$args['appointments_booking_rejected'] = array(
			'label' => __('Appointment Booking rejected','wplms-appointment'),
			'name' =>'appointments_booking_rejected',
			'value' => array(
				'student' => admin_url('edit.php?taxonomy=bp-email-type&term=student_appointments_booking_rejected&post_type=bp-email'),
				'instructor' => admin_url('edit.php?taxonomy=bp-email-type&term=instructor_appointments_booking_rejected&post_type=bp-email'),
			),
			'type' => 'touchpoint',
			'hook' => '',
			'wplms_appointment_hook'=>'wplms_appointments_booking_rejected',
			'params'=>2,
		);

		$args['appointments_appointment_updated'] = array(
			'label' => __('Appointment updated','wplms-appointment'),
			'name' =>'appointments_appointment_updated',
			'value' => array(
				'instructor' => admin_url('edit.php?taxonomy=bp-email-type&term=instructor_appointments_appointment_updated&post_type=bp-email'),
				'admin' => admin_url('edit.php?taxonomy=bp-email-type&term=admin_appointments_appointment_updated&post_type=bp-email'),
			),
			'type' => 'touchpoint_admin',
			'hook' => '',
			'wplms_appointment_hook'=>'wplms_appointments_appointment_updated',
			'params'=>2,
		);

		$args['appointment_requsted_by_user'] = array(
			'label' => __('Appointment Requested','wplms-appointment'),
			'name' =>'appointment_requsted_by_user',
			'value' => array(
				'student' => admin_url('edit.php?taxonomy=bp-email-type&term=student_appointment_requsted_by_user&post_type=bp-email'),
				'instructor' => admin_url('edit.php?taxonomy=bp-email-type&term=instructor_appointment_requsted_by_user&post_type=bp-email'),
			),
			'type' => 'touchpoint',
			'hook' => '',
			'wplms_appointment_hook'=>'wplms_appointment_requsted_by_user',
			'params'=>2,
		);


		$args['appointments_appointment_rescheduled'] = array(
			'label' => __('Appointment Booking rescheduled','wplms-appointment'),
			'name' =>'appointments_appointment_rescheduled',
			'value' => array(
				'student' => admin_url('edit.php?taxonomy=bp-email-type&term=student_appointments_appointment_rescheduled&post_type=bp-email'),
				'instructor' => admin_url('edit.php?taxonomy=bp-email-type&term=instructor_appointments_appointment_rescheduled&post_type=bp-email'),
			),
			'type' => 'touchpoint',
			'hook' => '',
			'wplms_appointment_hook'=>'wplms_appointments_appointment_rescheduled',
			'params'=>1,
		);



		$args['appointments_appointment_cancelled'] = array(
			'label' => __('Appointment Booking cancelled','wplms-appointment'),
			'name' =>'appointments_appointment_cancelled',
			'value' => array(
				'student' => admin_url('edit.php?taxonomy=bp-email-type&term=student_appointments_appointment_cancelled&post_type=bp-email'),
				'instructor' => admin_url('edit.php?taxonomy=bp-email-type&term=instructor_appointments_appointment_cancelled&post_type=bp-email'),
			),
			'type' => 'touchpoint',
			'hook' => '',
			'wplms_appointment_hook'=>'wplms_appointments_appointment_cancelled',
			'params'=>3,
		);


		$args['appointment_requested_cancellation'] = array(
			'label' => __('Appointment cancellation Requested','wplms-appointment'),
			'name' =>'appointment_requested_cancellation',
			'value' => array(
				'student' => admin_url('edit.php?taxonomy=bp-email-type&term=student_appointment_requested_cancellation&post_type=bp-email'),
				'instructor' => admin_url('edit.php?taxonomy=bp-email-type&term=instructor_appointment_requested_cancellation&post_type=bp-email'),
			),
			'type' => 'touchpoint',
			'hook' => '',
			'wplms_appointment_hook'=>'wplms_appointment_requested_cancellation',
			'params'=>1,
		);


		$args['appointment_requested_reschedule'] = array(
			'label' => __('Appointment reschedule Requested','wplms-appointment'),
			'name' =>'appointment_requested_reschedule',
			'value' => array(
				'student' => admin_url('edit.php?taxonomy=bp-email-type&term=student_appointment_requested_reschedule&post_type=bp-email'),
				'instructor' => admin_url('edit.php?taxonomy=bp-email-type&term=instructor_appointment_requested_reschedule&post_type=bp-email'),
			),
			'type' => 'touchpoint',
			'hook' => '',
			'wplms_appointment_hook'=>'wplms_appointment_requested_reschedule',
			'params'=>1,
		);

		

		$args['cancel_schedule_meeting'] = array(
			'label' => __('Cancel Schedule Meeting','wplms-appointment'),
			'name' =>'cancel_schedule_meeting',
			'value' => array(
				'instructor' => admin_url('edit.php?taxonomy=bp-email-type&term=instructor_cancel_schedule_meeting&post_type=bp-email'),
				'student' => admin_url('edit.php?taxonomy=bp-email-type&term=student_cancel_schedule_meeting&post_type=bp-email'),
			),
			'type' => 'touchpoint',
			'hook' => '',
			'wplms_appointment_hook'=>'wplms_appointments_cancel_schedule_meeting',
			'params'=>2,
		);


		$args['appointment_start'] = array(
			'label' => __('Appointment Start','wplms-appointment'),
			'name' =>'appointment_start',
			'value' => array(
				'instructor' => admin_url('edit.php?taxonomy=bp-email-type&term=instructor_appointment_start&post_type=bp-email'),
				'student' => admin_url('edit.php?taxonomy=bp-email-type&term=student_appointment_start&post_type=bp-email'),
			),
			'type' => 'touchpoint',
			'hook' => '',
			'wplms_appointment_hook'=>'appointment_start',
			'params'=>2,
		);


    	return apply_filters('wplms_appointments_touch_points_array',$args);
    }

    function email_templates($email){

    	

    	$email['student_appointments_booking_confirmed'] = array(
	            'description'=> __('Student : Appointment Booking confirmed ','wplms-appointments'),
	            'subject' =>  sprintf(__('Your booking confirmed by %s','wplms-appointments'),'{{instructor.name}}'),
	            'message' =>  sprintf(__('Your booking request for appointment %s %s confirmed by Instructor %s','wplms-appointments'),'{{appointment.id}}','{{{course.link}}}','{{{instructor.userlink}}}')
	        );

    	$email['instructor_appointments_booking_confirmed'] = array(
	            'description'=> __('Instructor : Appointment Booking confirmed','wplms-appointments'),
	            'subject' =>  sprintf(__('Appointment confirmed for Student %s','wplms-appointments'),'{{student.name}}'),
	            'message' =>  sprintf(__('Appointment booking %s %s confirmed for %s','wplms-appointments'),'{{appointment.id}}','{{{course.link}}}','{{{student.userlink}}}')
	        );



    	$email['student_appointments_appointment_cancelled'] = array(
	            'description'=> __('Student : Appointment Booking cancelled ','wplms-appointments'),
	            'subject' =>  sprintf(__('Your booking cancelled by %s','wplms-appointments'),'{{instructor.name}}'),
	            'message' =>  sprintf(__('Your booking request for appointment %s %s cancelled by Instructor %s','wplms-appointments'),'{{appointment.id}}','{{{course.link}}}','{{{instructor.userlink}}}')
	        );

    	$email['instructor_appointments_appointment_cancelled'] = array(
	            'description'=> __('Instructor : Appointment Booking cancelled','wplms-appointments'),
	            'subject' =>  sprintf(__('Appointment cancelled for Student %s','wplms-appointments'),'{{student.name}}'),
	            'message' =>  sprintf(__('Appointment booking %s %s cancelled for %s','wplms-appointments'),'{{appointment.id}}','{{{course.link}}}','{{{student.userlink}}}')
	        );


    	$email['student_appointments_booking_rejected'] = array(
	            'description'=> __('Student : Appointment Booking rejected ','wplms-appointments'),
	            'subject' =>  sprintf(__('Your booking rejected by Instructor %s','wplms-appointments'),'{{instructor.name}}'),
	            'message' =>  sprintf(__('Your booking %s %s rejected by Instructor %s ','wplms-appointments'),'{{appointment.id}}','{{{course.link}}}','{{{instructor.userlink}}}')
	        );

    	$email['instructor_appointments_booking_rejected'] = array(
	            'description'=> __('Instructor : Appointment Booking rejected','wplms-appointments'),
	            'subject' =>  sprintf(__('Appointment rejected for Student %s','wplms-appointments'),'{{student.name}}'),
	            'message' =>  sprintf(__('Appointment booking %s %s rejected for %s','wplms-appointments'),'{{appointment.id}}','{{{course.link}}}','{{{student.userlink}}}')
	        );


    	$email['instructor_appointments_appointment_updated'] = array(
	            'description'=> __('Instructor : Appointment updated','wplms-appointments'),
	            'subject' =>  __('Appointment updated','wplms-appointments'),
	            'message' =>  sprintf(__('Appointment %s updated ','wplms-appointments'),'{{{appointment.id}}}')
	        );

    	$email['admin_appointments_appointment_updated'] = array(
	            'description'=> __('Admin : Appointment updated','wplms-appointments'),
	            'subject' =>  __('Appointment updated','wplms-appointments'),
	            'message' =>  sprintf(__('Appointment %s updated by %s','wplms-appointments'),'{{{appointment.id}}}','{{{instructor.userlink}}}')
	        );

    	
    	
    	$email['student_appointment_requsted_by_user'] = array(
	            'description'=> __('Student : Appointment Booking requested ','wplms-appointments'),
	            'subject' =>  sprintf(__('You requested appointment for instructor %s','wplms-appointments'),'{{instructor.name}}'),
	            'message' =>  sprintf(__('You requested appointment %s %s for instructor %s','wplms-appointments'),'{{appointment.id}}','{{{course.link}}}','{{{instructor.userlink}}}')
	        );

    	$email['instructor_appointment_requsted_by_user'] = array(
	            'description'=> __('Instructor : Appointment Booking requested','wplms-appointments'),
	            'subject' =>  sprintf(__('Appointment requested by Student %s','wplms-appointments'),'{{student.name}}'),
	            'message' =>  sprintf(__('Appointment %s %s requested by Student %s','wplms-appointments'),'{{appointment.id}}','{{{course.link}}}','{{{student.userlink}}}')
	        );

    	

		$email['student_appointments_appointment_rescheduled'] = array(
	            'description'=> __('Student : Appointment Booking rescheduled ','wplms-appointments'),
	            'subject' =>  sprintf(__('Your appointment for instructor %s rescheduled','wplms-appointments'),'{{{instructor.name}}}'),
	            'message' =>  sprintf(__('Your appointment with instructor %s rescheduled from %s %s to %s','wplms-appointments'),'{{instructor.userlink}}','{{appointment.id}}','{{{course.link}}}','{{new_appointment.id}}')
	        );

    	$email['instructor_appointments_appointment_rescheduled'] = array(
	            'description'=> __('Instructor : Appointment Booking rescheduled','wplms-appointments'),
	            'subject' =>  sprintf(__('Appointment rescheduled for Student %s','wplms-appointments'),'{{student.name}}'),
	            'message' =>  sprintf(__('Appointment %s %s rescheduled for Student %s to %s','wplms-appointments'),'{{appointment.id}}','{{{course.link}}}','{{{student.userlink}}}','{{new_appointment.id}}')
	        );
    	
		
		$email['student_appointment_requested_cancellation'] = array(
	            'description'=> __('Student : Appointment cancellation requested by student','wplms-appointments'),
	            'subject' =>  sprintf(__('You requested cancellation for appointment with instructor %s','wplms-appointments'),'{{instructor.name}}'),
	            'message' =>  sprintf(__('You requested cancellation for appointment %s %s with instructor %s','wplms-appointments'),'{{appointment.id}}','{{{course.link}}}','{{{instructor.userlink}}}')
	        );

    	$email['instructor_appointment_requested_cancellation'] = array(
	            'description'=> __('Instructor : Appointment cancellation requested by student','wplms-appointments'),
	            'subject' =>  sprintf(__('Appointment cancellation requested by Student %s','wplms-appointments'),'{{student.name}}'),
	            'message' =>  sprintf(__('Student %s requested cancellation for appointment %s %s','wplms-appointments'),'{{{student.userlink}}}','{{appointment.id}}','{{{course.link}}}')
	        );

    	$email['student_appointment_requested_reschedule'] = array(
	            'description'=> __('Student : Appointment reschedule requested by student','wplms-appointments'),
	            'subject' =>  sprintf(__('You requested reschedule for appointment with instructor %s','wplms-appointments'),'{{instructor.name}}'),
	            'message' =>  sprintf(__('You requested reschedule for appointment %s %s with instructor %s','wplms-appointments'),'{{appointment.id}}','{{{course.link}}}','{{{instructor.userlink}}}')
	        );

    	$email['instructor_appointment_requested_reschedule'] = array(
	            'description'=> __('Instructor : Appointment reschedule requested by student','wplms-appointments'),
	            'subject' =>  sprintf(__('Appointment reschedule requested by Student %s','wplms-appointments'),'{{student.name}}'),
	            'message' =>  sprintf(__('Student %s requested reschedule for appointment %s %s','wplms-appointments'),'{{{student.userlink}}}','{{appointment.id}}','{{{course.link}}}')
	        );

    	$email['student_cancel_schedule_meeting'] = array(
	            'description'=> __('Student : Meeting Cancelled by Instructor','wplms-appointments'),
	            'subject' =>  __('Scheduled Meeting Cancelled','wplms-appointments'),
	            'message' =>  sprintf(__('Meeting %s Cancelled by %s','wplms-appointments'),'{{{appointment.id}}}','{{{instructor.userlink}}}')
	        );


    	$email['instructor_cancel_schedule_meeting'] = array(
	            'description'=> __('Instructor : Meeting Cancelled','wplms-appointments'),
	            'subject' =>  __('Scheduled Meeting Cancelled','wplms-appointments'),
	            'message' =>  sprintf(__('Meeting %s Cancelled ','wplms-appointments'),'{{appointment.id}}')
	        );

    	$email['instructor_appointment_start'] = array(
	            'description'=> __('Instructor : Appointment about to Start','wplms-appointments'),
	            'subject' =>  __('Appointment is about to start','wplms-appointments'),
	            'message' =>  sprintf(__('Your Appointment %s is about to start','wplms-appointments'),'{{appointment.id}}','{{appointment.time}}')
	        );


    	$email['student_appointment_start'] = array(
	            'description'=> __('Student : Appointment about to start','wplms-appointments'),
	            'subject' =>  __('Appointment is about to Start','wplms-appointments'),
	            'message' =>  sprintf(__('Your Appointment %s with %s %s is about to start','wplms-appointments'),'{{appointment.id}}','{{{appointment.instructor_link}}}','{{{appointment.item_link}}}')
	        );


    	return $email;
    }

    //booking confirmed
    function student_message_appointments_booking_confirmed($booker_id,$args){
    	
    	$appointment_id = $this->get_touch_appointment($args,$booker_id);
    	$item_html = ((!empty($args['item_id']) && get_post_type($args['item_id'])=='course')?'<a href="'.get_permalink($args['item_id']).'">'.get_the_title($args['item_id']).'</a>':'');
		$message = sprintf(__('Your appointment %s %s is confirmed by instructor %s','wplms-appointments'),$appointment_id,$item_html,bp_core_get_userlink($args['author_id']));
	    if(bp_is_active('messages') && function_exists('bp_course_messages_new_message'))
	      bp_course_messages_new_message( array('sender_id' => $args['author_id'], 'subject' => __('Student : Booking confirmed','wplms-appointments'), 'content' => $message,   'recipients' => $booker_id ) );
    }

    function student_notification_appointments_booking_confirmed($booker_id,$args){
    
    	bp_course_add_notification( array(
			'user_id'          => $booker_id,
			'item_id'          => $args['appointment_id'],
			'secondary_item_id' => $args['author_id'],
			'component_action' => 'student_appointments_booking_confirmed'
		));
    }

    function student_email_appointments_booking_confirmed($booker_id,$args){
    	
    	$enable = get_user_meta($booker_id,'student_appointments_booking_confirmed',true);
		if($enable !== 'no'){
			$user = get_user_by( 'id', $booker_id);
			$to = $user->user_email;
			
	        $appointment_id = (empty($args['parent_appointment_id'])?$args['appointment_id']:$args['parent_appointment_id']);
	        $appointment_html = $this->get_touch_appointment($args,$booker_id);
	        $item_html = ((!empty($args['item_id']) && get_post_type($args['item_id'])=='course')?'<a href="'.get_permalink($args['item_id']).'">'.get_the_title($args['item_id']).'</a>':'');
			bp_course_wp_mail($to,'','',array('action'=>'student_appointments_booking_confirmed','item_id'=>$appointment_id ,
				'tokens'=>array(
					'appointment.id'=>$appointment_html,
					'instructor.name'=>bp_core_get_user_displayname($args['author_id']),
					'instructor.userlink'=>bp_core_get_userlink($args['author_id']),
					'course.link'=>$item_html
				)));
		}
    }


    function instructor_message_appointments_booking_confirmed($booker_id,$args){
    	$item_html = ((!empty($args['item_id']) && get_post_type($args['item_id'])=='course')?'<a href="'.get_permalink($args['item_id']).'">'.get_the_title($args['item_id']).'</a>':'');

	    
	    $appointment_id = $this->get_touch_appointment($args,$booker_id);
		$message = sprintf(__('Appointment booking %s %s confirmed for %s','wplms-appointments'),$appointment_id,$item_html,bp_core_get_userlink($booker_id));
	    if(bp_is_active('messages') && function_exists('bp_course_messages_new_message'))
	      bp_course_messages_new_message( array('sender_id' => $args['author_id'], 'subject' => __('Instructor : Booking confirmed','wplms-appointments'), 'content' => $message,   'recipients' =>$args['author_id']) );
    }

    function instructor_notification_appointments_booking_confirmed($booker_id,$args){
    	
	    bp_course_add_notification( array(
			'user_id'          => $args['author_id'],
			'item_id'          => $args['appointment_id'],
			'secondary_item_id' => $booker_id,
			'component_action' => 'instructor_appointments_booking_confirmed'
		));
    }

    function instructor_email_appointments_booking_confirmed($booker_id,$args){
    	$enable = get_user_meta($args['author_id'],'instructor_appointments_booking_confirmed',true);
		if($enable !== 'no'){
			$user = get_user_by( 'id',$args['author_id']);
			$to = $user->user_email;

	        $appointment_id = (empty($args['parent_appointment_id'])?$args['appointment_id']:$args['parent_appointment_id']);
	        $appointment_html = $this->get_touch_appointment($args,$booker_id);
	        $item_html = ((!empty($args['item_id']) && get_post_type($args['item_id'])=='course')?'<a href="'.get_permalink($args['item_id']).'">'.get_the_title($args['item_id']).'</a>':'');
			bp_course_wp_mail($to,'','',array('action'=>'instructor_appointments_booking_confirmed','item_id'=>$appointment_id ,
				'tokens'=>array(
					'appointment.id'=>$appointment_html ,
					'student.name'=>bp_core_get_user_displayname($booker_id),
					'student.userlink'=>bp_core_get_userlink($booker_id),
					'course.link'=>$item_html
				)));
		}
    }


    //booking cancelled
    function student_message_appointments_booking_rejected($booker_id,$args){

    	$appointment = array();
        $db = new WPLMS_APPOINTMENTS_DB;
        $appointments = $db->get_appointments(Array('appointment_id'=>$args['appointment_id']));
        if(!empty($appointments)){
            $appointment = $appointments[0];
        }
        $appointment_html = $this->get_touch_appointment($appointment,$booker_id);
    	$item_html = ((!empty($appointment['item_id']) && get_post_type($appointment['item_id'])=='course')?'<a href="'.get_permalink($appointment['item_id']).'">'.get_the_title($appointment['item_id']).'</a>':'');

		$message = sprintf(__('Your booking %s %s rejected by Instructor %s','wplms-appointments'),$appointment_html,$item_html,bp_core_get_userlink($args['instructor_id']));
	    if(bp_is_active('messages') && function_exists('bp_course_messages_new_message'))
	      bp_course_messages_new_message( array('sender_id' => $args['instructor_id'], 'subject' => __('Student : Booking cancelled','wplms-appointments'), 'content' => $message,   'recipients' => $booker_id ) );
    }

    function student_notification_appointments_booking_rejected($booker_id,$args){
    	bp_course_add_notification( array(
			'user_id'          => $booker_id,
			'item_id'          => $args['appointment_id'],
			'secondary_item_id' => $args['instructor_id'],
			'component_action' => 'student_appointments_booking_rejected'
		));
    }

    function student_email_appointments_booking_rejected($booker_id,$args){
    	
	    $enable = get_user_meta($booker_id,'student_appointments_booking_rejected',true);
		if($enable !== 'no'){
			$user = get_user_by( 'id', $booker_id);
			$to = $user->user_email;
			
	        $appointment_id = (empty($args['parent_appointment_id'])?$args['appointment_id']:$args['parent_appointment_id']);
	        $appointment = array();
	        $db = new WPLMS_APPOINTMENTS_DB;
	        $appointments = $db->get_appointments(Array('appointment_id'=>$args['appointment_id']));
	        if(!empty($appointments)){
	            $appointment = $appointments[0];
	        }
	        $appointment_html = $this->get_touch_appointment($appointment,$booker_id);
	    	$item_html = ((!empty($appointment['item_id']) && get_post_type($appointment['item_id'])=='course')?'<a href="'.get_permalink($appointment['item_id']).'">'.get_the_title($appointment['item_id']).'</a>':'');

			bp_course_wp_mail($to,'','',array('action'=>'student_appointments_booking_rejected',
				'item_id'=>$appointment_id ,
				'tokens'=>array(
					'appointment.id'=>$appointment_html ,
					'instructor.name'=>bp_core_get_user_displayname($args['instructor_id']),
					'instructor.userlink'=>bp_core_get_userlink($args['instructor_id']),
					'course.link'=>$item_html
			)));
		}
    }


    function instructor_message_appointments_booking_rejected($booker_id,$args){

	    $appointment_id = (empty($args['parent_appointment_id'])?$args['appointment_id']:$args['parent_appointment_id']);
        $appointment = array();
        $db = new WPLMS_APPOINTMENTS_DB;
        $appointments = $db->get_appointments(Array('appointment_id'=>$args['appointment_id']));
        if(!empty($appointments)){
            $appointment = $appointments[0];
        }

    	$item_html = ((!empty($appointment['item_id']) && get_post_type($appointment['item_id'])=='course')?'<a href="'.get_permalink($appointment['item_id']).'">'.get_the_title($appointment['item_id']).'</a>':'');

	    $appointment_id = (empty($args['parent_appointment_id'])?$args['appointment_id']:$args['parent_appointment_id']);
	    $appointment_html = $this->get_touch_appointment($appointment,$booker_id);
		$message = sprintf(__('Appointment booking %s %s rejected for %s','wplms-appointments'),$appointment_html,$item_html,bp_core_get_userlink($booker_id));
	    if(bp_is_active('messages') && function_exists('bp_course_messages_new_message'))
	      bp_course_messages_new_message( array('sender_id' => $args['instructor_id'], 'subject' => __('Instructor : Booking rejected','wplms-appointments'), 'content' => $message,   'recipients' =>$args['instructor_id']) );

    }

    function instructor_notification_appointments_booking_rejected($booker_id,$args){
    	bp_course_add_notification( array(
			'user_id'          => $args['instructor_id'],
			'item_id'          => $args['appointment_id'],
			'secondary_item_id' => $booker_id,
			'component_action' => 'instructor_appointments_booking_rejected'
		));
    }

    function instructor_email_appointments_booking_rejected($booker_id,$args){

    	$enable = get_user_meta($args['instructor_id'],'instructor_appointments_booking_rejected',true);
		if($enable !== 'no'){
			$user = get_user_by( 'id',$args['instructor_id']);
			$to = $user->user_email;

	        $appointment_id = (empty($args['parent_appointment_id'])?$args['appointment_id']:$args['parent_appointment_id']);
	        $appointment = array();
	        $db = new WPLMS_APPOINTMENTS_DB;
	        $appointments = $db->get_appointments(Array('appointment_id'=>$args['appointment_id']));
	        if(!empty($appointments)){
	            $appointment = $appointments[0];
	        }
	        $appointment_html = $this->get_touch_appointment($appointment,$booker_id);
	    	$item_html = ((!empty($appointment['item_id']) && get_post_type($appointment['item_id'])=='course')?'<a href="'.get_permalink($appointment['item_id']).'">'.get_the_title($appointment['item_id']).'</a>':'');
			bp_course_wp_mail($to,'','',array('action'=>'instructor_appointments_booking_rejected','item_id'=>$appointment_id ,
				'tokens'=>array(
					'appointment.id'=>$appointment_html ,
					'student.name'=>bp_core_get_user_displayname($booker_id),
					'student.userlink'=>bp_core_get_userlink($booker_id),
					'course.link'=>$item_html
				)));
		}
    }


    //booking updated
    function admin_message_appointments_appointment_updated($schedule,$details){
    	$admins = $this->get_admins();
    	
    	$message = sprintf(__('Appointment %s updated by %s','wplms-appointments'),$appointment_html,bp_core_get_userlink($schedule['author_id']));

    	if(!empty($admins)){
    		foreach ($admins as $key => $admin) {
    			$appointment_html = $this->get_touch_appointment($schedule,$admin->ID);
		    	if(bp_is_active('messages') && function_exists('bp_course_messages_new_message'))
		      		bp_course_messages_new_message( array('sender_id' => $schedule['author_id'], 'subject' => __('Admin : Appointment updated','wplms-appointments'), 'content' => $message,   'recipients' => $admin->ID ) );
	    	}
	    }
    }
    	

    function admin_notification_appointments_appointment_updated($schedule,$details){
    	$admins = $this->get_admins();
    	
    	if(!empty($admins)){
    		foreach ($admins as $key => $admin) {
    	
		    	bp_course_add_notification( array(
					'user_id'          => $admin->ID,
					'item_id'          => $schedule['appointment_id'],
					'secondary_item_id' => $schedule['author_id'],
					'component_action' => 'admin_appointments_appointment_updated'
				));
	    	}
	    }
    }

    function admin_email_appointments_appointment_updated($schedule,$details){
		$admins = $this->get_admins();
		$to = array();
		$appointment_id =  $schedule['appointment_id'];
    	foreach ($admins as $key => $admin) {

    		
    		if(!empty($admin->email)){
		        $appointment_html = $this->get_touch_appointment($schedule,$admin->ID);
				bp_course_wp_mail($admin->email,'','',array('action'=>'instructor_appointments_booking_confirmed','item_id'=>$appointment_id ,
					'tokens'=>array(
						'appointment.id'=>$appointment_html,
						'instructor.userlink'=>bp_core_get_userlink($schedule['author_id'])
				)));
		    }
    	}
    	
    }


    function instructor_message_appointments_appointment_updated($schedule,$details){
    	$appointment_html = $this->get_touch_appointment($schedule,$schedule['author_id']);
    	$message = sprintf(__('Appointment %s updated','wplms-appointments'),$appointment_html);
    	
    	
    	if(bp_is_active('messages') && function_exists('bp_course_messages_new_message'))
      		bp_course_messages_new_message( array('sender_id' => $schedule['author_id'], 'subject' => __('Instructor : Appointment updated','wplms-appointments'), 'content' => $message,   'recipients' => $schedule['author_id'] ) );
	 }  

    function instructor_notification_appointments_appointment_updated($schedule,$details){
    	bp_course_add_notification( array(
			'user_id'          => $schedule['author_id'],
			'item_id'          => $schedule['appointment_id'],
			'secondary_item_id' => $schedule['item_id'],
			'component_action' => 'instructor_appointments_appointment_updated'
		));
    }

    function instructor_email_appointments_appointment_updated($schedule,$details){
    	$appointment_html = $this->get_touch_appointment($schedule,$schedule['author_id']);
	    $enable = get_user_meta($schedule['author_id'],'instructor_appointments_appointment_updated',true);
		if($enable !== 'no'){
			$user = get_user_by( 'id',$schedule['author_id']);
			$to = $user->user_email;

	        $appointment_id =  $schedule['appointment_id'];
	       
			bp_course_wp_mail($to,'','',array('action'=>'instructor_appointments_appointment_updated','item_id'=>$appointment_id ,
				'tokens'=>array(
					'appointment.id'=>$appointment_html ,
					
				)));
		}
    }



    //booking requested
    function student_message_appointment_requsted_by_user($booker_id,$schedule){
    	
	    if(!empty($schedule['parent_appointment_id'])){
            $appointment_id = $schedule['parent_appointment_id'];
        }else{
            $appointment_id = $schedule['appointment_id'];
        }
	   	   
	    $appointment = array();
        $db = new WPLMS_APPOINTMENTS_DB;
        $appointments = $db->get_appointments(Array('appointment_id'=>$appointment_id));
        if(!empty($appointments)){
            $appointment = $appointments[0];
        }
        $appointment_html = $this->get_touch_appointment($appointment,$booker_id);
    	$item_html = ((!empty($appointment['item_id']) && get_post_type($appointment['item_id'])=='course')?'<a href="'.get_permalink($appointment['item_id']).'">'.get_the_title($appointment['item_id']).'</a>':'');

		$message = sprintf(__('You requested appointment %s %s for instructor %s','wplms-appointments'),$appointment_html,$item_html,bp_core_get_userlink($schedule['author_id']));
	    if(bp_is_active('messages') && function_exists('bp_course_messages_new_message'))
	      bp_course_messages_new_message( array('sender_id' => $schedule['author_id'], 'subject' => __('Student : Booking Requested','wplms-appointments'), 'content' => $message,   'recipients' =>$booker_id) );
    }

    function student_notification_appointment_requsted_by_user($booker_id,$schedule){
        $appointment_id = $schedule['appointment_id'];
    	bp_course_add_notification( array(
			'user_id'          => $booker_id,
			'item_id'          => $appointment_id,
			'secondary_item_id' => $schedule['author_id'],
			'component_action' => 'student_appointment_requsted_by_user'
		));
    }

    function student_email_appointment_requsted_by_user($booker_id,$schedule){
	    $enable = get_user_meta($booker_id,'student_appointment_requsted_by_user',true);
		if($enable !== 'no'){
			$user = get_user_by( 'id', $booker_id);
			$to = $user->user_email;
			
	        $appointment_id = (empty($schedule['parent_appointment_id'])?$schedule['appointment_id']:$schedule['parent_appointment_id']);
	        $appointment = array();
	        $db = new WPLMS_APPOINTMENTS_DB;
	        $appointments = $db->get_appointments(Array('appointment_id'=>$appointment_id));
	        if(!empty($appointments)){
	            $appointment = $appointments[0];
	        }
	        $appointment_html = $this->get_touch_appointment($appointment,$booker_id);
	    	$item_html = ((!empty($appointment['item_id']) && get_post_type($appointment['item_id'])=='course')?'<a href="'.get_permalink($appointment['item_id']).'">'.get_the_title($appointment['item_id']).'</a>':'');

			bp_course_wp_mail($to,'','',array('action'=>'student_appointment_requsted_by_user',
				'item_id'=>$appointment_id ,
				'tokens'=>array(
					'appointment.id'=>$appointment_html,
					'instructor.name'=>bp_core_get_user_displayname($schedule['author_id']),
					'instructor.userlink'=>bp_core_get_userlink($schedule['author_id']),
					'course.link'=>$item_html
			)));
		}
    	
    }


    function instructor_message_appointment_requsted_by_user($booker_id,$schedule){
    	
    	if(!empty($schedule['parent_appointment_id'])){
            $appointment_id = $schedule['parent_appointment_id'];
        }else{
            $appointment_id = $schedule['appointment_id'];
        }
        $appointment = array();
        $db = new WPLMS_APPOINTMENTS_DB;
        $appointments = $db->get_appointments(Array('appointment_id'=>$appointment_id));
        if(!empty($appointments)){
            $appointment = $appointments[0];
        }
        $appointment_html = $this->get_touch_appointment($appointment,$booker_id);
    	$item_html = ((!empty($appointment['item_id']) && get_post_type($appointment['item_id'])=='course')?'<a href="'.get_permalink($appointment['item_id']).'">'.get_the_title($appointment['item_id']).'</a>':'');

		$message = sprintf(__('Appointment %s %s requested by Student %s','wplms-appointments'),$appointment_html,$item_html,bp_core_get_userlink($booker_id));
	    if(bp_is_active('messages') && function_exists('bp_course_messages_new_message'))
	      bp_course_messages_new_message( array('sender_id' => $booker_id, 'subject' => __('Instructor : Booking requested','wplms-appointments'), 'content' => $message,   'recipients' =>$schedule['author_id']) );
    }

    function instructor_notification_appointment_requsted_by_user($booker_id,$schedule){
    	
	   
	    bp_course_add_notification( array(
			'user_id'          => $schedule['author_id'],
			'item_id'          => $args['appointment_id'],
			'secondary_item_id' => $booker_id,
			'component_action' => 'instructor_appointment_requsted_by_user'
		));
    }

    function instructor_email_appointment_requsted_by_user($booker_id,$schedule){
    	
	    $enable = get_user_meta($schedule['author_id'],'instructor_appointment_requsted_by_user',true);
		if($enable !== 'no'){
			$user = get_user_by( 'id',$schedule['author_id']);
			$to = $user->user_email;

	        $appointment_id = (empty($schedule['parent_appointment_id'])?$schedule['appointment_id']:$schedule['parent_appointment_id']);
	        $appointment = array();
	        $db = new WPLMS_APPOINTMENTS_DB;
	        $appointments = $db->get_appointments(Array('appointment_id'=>$schedule['appointment_id']));
	        if(!empty($appointments)){
	            $appointment = $appointments[0];
	        }
	        $appointment_html = $this->get_touch_appointment($appointment,$booker_id);
	    	$item_html = ((!empty($appointment['item_id']) && get_post_type($appointment['item_id'])=='course')?'<a href="'.get_permalink($appointment['item_id']).'">'.get_the_title($appointment['item_id']).'</a>':'');
			bp_course_wp_mail($to,'','',array('action'=>'instructor_appointment_requsted_by_user','item_id'=>$appointment_id ,
				'tokens'=>array(
					'appointment.id'=>$appointment_html ,
					'student.name'=>bp_core_get_user_displayname($booker_id),
					'student.userlink'=>bp_core_get_userlink($booker_id),
					'course.link'=>$item_html
			)));
		}
    }


    //booking appointments_appointment_rescheduled
    function student_message_appointments_appointment_rescheduled($args){
    	
        $appointment_id = (empty($args['parent_appointment_id'])?$args['appointment_id']:$args['parent_appointment_id']);
	   	   
	    $appointment = array();
        $db = new WPLMS_APPOINTMENTS_DB;
        $appointments = $db->get_appointments(Array('appointment_id'=>$appointment_id));
        if(!empty($appointments)){
            $appointment = $appointments[0];
        }
        $appointment_html = $this->get_touch_appointment($appointment,$args['booker_id']);
    	$item_html = ((!empty($appointment['item_id']) && get_post_type($appointment['item_id'])=='course')?'<a href="'.get_permalink($appointment['item_id']).'">'.get_the_title($appointment['item_id']).'</a>':'');

		$message = sprintf(__('Your appointment with instructor %s rescheduled from %s %s to %s','wplms-appointments'),bp_core_get_userlink($args['author_id']),$appointment_html,$item_html,$args['new_appointment_id']);
	    if(bp_is_active('messages') && function_exists('bp_course_messages_new_message'))
	      bp_course_messages_new_message( array('sender_id' => $args['author_id'], 'subject' => __('Student : Booking Rescheduled','wplms-appointments'), 'content' => $message,   'recipients' =>$args['booker_id']) );
    }

    function student_notification_appointments_appointment_rescheduled($args){
    	$appointment = array();
        $db = new WPLMS_APPOINTMENTS_DB;
        $appointments = $db->get_appointments(Array('appointment_id'=>$appointment_id));
        if(!empty($appointments)){
            $appointment = $appointments[0];
        }
    	bp_course_add_notification( array(
			'user_id'          => $args['booker_id'],
			'item_id'          => $appointment['appointment_id'],
			'secondary_item_id' => $args['author_id'],
			'component_action' => 'student_appointments_appointment_rescheduled'
		));
    }

    function student_email_appointments_appointment_rescheduled($args){
    	
	    $enable = get_user_meta($args['booker_id'],'student_appointments_appointment_rescheduled',true);
		if($enable !== 'no'){
			$user = get_user_by( 'id', $args['booker_id']);
			$to = $user->user_email;
			
	        $appointment_id =(empty($args['parent_appointment_id'])?$args['appointment_id']:$args['parent_appointment_id']);
	        $appointment = array();
	        $db = new WPLMS_APPOINTMENTS_DB;
	        $appointments = $db->get_appointments(Array('appointment_id'=>$appointment_id));
	        if(!empty($appointments)){
	            $appointment = $appointments[0];
	        }
	        $appointment_html = $this->get_touch_appointment($appointment,$args['booker_id']);

	    	$item_html = ((!empty($appointment['item_id']) && get_post_type($appointment['item_id'])=='course')?'<a href="'.get_permalink($appointment['item_id']).'">'.get_the_title($appointment['item_id']).'</a>':'');

			bp_course_wp_mail($to,'','',array('action'=>'student_appointments_appointment_rescheduled',
				'item_id'=>$appointment_id ,
				'tokens'=>array(
					'appointment.id'=>$appointment_html ,
					'instructor.name'=>bp_core_get_user_displayname($args['author_id']),
					'instructor.userlink'=>bp_core_get_userlink($args['author_id']),
					'course.link'=>$item_html,
					'new_appointment.id'=>$args['new_appointment_id']
			)));
		}
    }


    function instructor_message_appointments_appointment_rescheduled($args){
    	
    	$appointment_id = (empty($args['parent_appointment_id'])?$args['appointment_id']:$args['parent_appointment_id']);
        $appointment = array();
        $db = new WPLMS_APPOINTMENTS_DB;
        $appointments = $db->get_appointments(Array('appointment_id'=>$appointment_id));
        if(!empty($appointments)){
            $appointment = $appointments[0];
        }
        $appointment_html = $this->get_touch_appointment($appointment,$args['author_id']);
    	$item_html = ((!empty($appointment['item_id']) && get_post_type($appointment['item_id'])=='course')?'<a href="'.get_permalink($appointment['item_id']).'">'.get_the_title($appointment['item_id']).'</a>':'');

	    
		$message = sprintf(__('Appointment %s %s rescheduled for Student %s to %s','wplms-appointments'),$appointment_html,$item_html,bp_core_get_userlink($args['booker_id']),$args['new_appointment_id']);
	    if(bp_is_active('messages') && function_exists('bp_course_messages_new_message'))
	      bp_course_messages_new_message( array('sender_id' => $args['booker_id'], 'subject' => __('Instructor : Booking Rescheduled','wplms-appointments'), 'content' => $message,   'recipients' =>$args['author_id']) );
    }

    function instructor_notification_appointments_appointment_rescheduled($args){
    
	    bp_course_add_notification( array(
			'user_id'          => $args['author_id'],
			'item_id'          => $args['appointment_id'],
			'secondary_item_id' => $args['booker_id'],
			'component_action' => 'instructor_appointments_appointment_rescheduled'
		));
    }

    function instructor_email_appointments_appointment_rescheduled($args){
    	
	    $enable = get_user_meta($args['author_id'],'instructor_appointments_appointment_rescheduled',true);
		if($enable !== 'no'){
			$user = get_user_by( 'id',$args['author_id']);
			$to = $user->user_email;

	        $appointment_id = (empty($args['parent_appointment_id'])?$args['appointment_id']:$args['parent_appointment_id']);
	        $appointment = array();
	        $db = new WPLMS_APPOINTMENTS_DB;
	        $appointments = $db->get_appointments(Array('appointment_id'=>$args['appointment_id']));
	        if(!empty($appointments)){
	            $appointment = $appointments[0];
	        }
	        $appointment_html = $this->get_touch_appointment($appointment,$args['author_id']);
	    	$item_html = ((!empty($appointment['item_id']) && get_post_type($appointment['item_id'])=='course')?'<a href="'.get_permalink($appointment['item_id']).'">'.get_the_title($appointment['item_id']).'</a>':'');
			bp_course_wp_mail($to,'','',array('action'=>'instructor_appointments_appointment_rescheduled','item_id'=>$appointment_id ,
				'tokens'=>array(
					'appointment.id'=>$appointment_html ,
					'student.name'=>bp_core_get_user_displayname($args['booker_id']),
					'student.userlink'=>bp_core_get_userlink($args['booker_id']),
					'course.link'=>$item_html,
					'new_appointment.id'=>$args['new_appointment_id']
			)));
		}
    }

    //booking appointments_appointment_cancelled
    function student_message_appointments_appointment_cancelled($args,$metas,$order_details){
    	
    	$appointment = array();
        $db = new WPLMS_APPOINTMENTS_DB;
        $appointments = $db->get_appointments(Array('appointment_id'=>$args['appointment_id']));
        if(!empty($appointments)){
            $appointment = $appointments[0];
        }
        $appointment_html = $this->get_touch_appointment($appointment,$args['booker_id']);
    	$item_html = ((!empty($appointment['item_id']) && get_post_type($appointment['item_id'])=='course')?'<a href="'.get_permalink($appointment['item_id']).'">'.get_the_title($appointment['item_id']).'</a>':'');

		$message = sprintf(__('Your booking request for appointment %s %s cancelled by Instructor %s','wplms-appointments'),$appointment_html,$item_html,bp_core_get_userlink($args['author_id']));
	    if(bp_is_active('messages') && function_exists('bp_course_messages_new_message'))
	      bp_course_messages_new_message( array('sender_id' => $args['author_id'], 'subject' => __('Student : Booking cancelled','wplms-appointments'), 'content' => $message,   'recipients' => $args['booker_id'] ) );
    }

    function student_notification_appointments_appointment_cancelled($args,$metas,$order_details){
    	$appointment = array();
        $db = new WPLMS_APPOINTMENTS_DB;
        $appointments = $db->get_appointments(Array('appointment_id'=>$args['appointment_id']));
        if(!empty($appointments)){
            $appointment = $appointments[0];
        }
    	bp_course_add_notification( array(
			'user_id'          => $args['booker_id'],
			'item_id'          => $appointment['appointment_id'],
			'secondary_item_id' => $args['author_id'],
			'component_action' => 'student_appointments_appointment_cancelled'
		));
    }

    function student_email_appointments_appointment_cancelled($args,$metas,$order_details){
    	
	    $enable = get_user_meta($args['booker_id'],'student_appointments_appointment_cancelled',true);
		if($enable !== 'no'){
			$user = get_user_by( 'id', $args['booker_id']);
			$to = $user->user_email;
			
	        
	        $appointment = array();
	        $db = new WPLMS_APPOINTMENTS_DB;
	        $appointments = $db->get_appointments(Array('appointment_id'=>$args['appointment_id']));
	        if(!empty($appointments)){
	            $appointment = $appointments[0];
	        }
	        $appointment_html = $this->get_touch_appointment($appointment,$args['booker_id']);
	        $appointment_id = (empty($appointment['parent_appointment_id'])?$appointment['appointment_id']:$appointment['parent_appointment_id']);
	    	$item_html = ((!empty($appointment['item_id']) && get_post_type($appointment['item_id'])=='course')?'<a href="'.get_permalink($appointment['item_id']).'">'.get_the_title($appointment['item_id']).'</a>':'');

			bp_course_wp_mail($to,'','',array('action'=>'student_appointments_appointment_cancelled',
				'item_id'=>$appointment_id ,
				'tokens'=>array(
					'appointment.id'=>$appointment_html,
					'instructor.name'=>bp_core_get_user_displayname($args['author_id']),
					'instructor.userlink'=>bp_core_get_userlink($args['author_id']),
					'course.link'=>$item_html
			)));
		}
    }


    function instructor_message_appointments_appointment_cancelled($args,$metas,$order_details){
    	
    	$appointment = array();
        $db = new WPLMS_APPOINTMENTS_DB;
        $appointments = $db->get_appointments(Array('appointment_id'=>$args['appointment_id']));
        if(!empty($appointments)){
            $appointment = $appointments[0];
        }
        $appointment_html = $this->get_touch_appointment($appointment,$args['author_id']);
    	$item_html = ((!empty($appointment['item_id']) && get_post_type($appointment['item_id'])=='course')?'<a href="'.get_permalink($appointment['item_id']).'">'.get_the_title($appointment['item_id']).'</a>':'');

		$message = sprintf(__('Appointment booking %s %s cancelled for %s','wplms-appointments'),$appointment_html,$item_html,bp_core_get_userlink($args['booker_id']));
	    if(bp_is_active('messages') && function_exists('bp_course_messages_new_message'))
	      bp_course_messages_new_message( array('sender_id' =>$args['booker_id'] , 'subject' => __('Instructor : Booking Cancelled','wplms-appointments'), 'content' => $message,   'recipients' =>$args['author_id']  ) );

    }

    function instructor_notification_appointments_appointment_cancelled($args,$metas,$order_details){

    	$appointment = array();
        $db = new WPLMS_APPOINTMENTS_DB;
        $appointments = $db->get_appointments(Array('appointment_id'=>$args['appointment_id']));
        if(!empty($appointments)){
            $appointment = $appointments[0];
        }
    	bp_course_add_notification( array(
			'user_id'          => $args['author_id'],
			'item_id'          => $appointment['appointment_id'],
			'secondary_item_id' => $args['booker_id'],
			'component_action' => 'instructor_appointments_appointment_cancelled'
		));
    }

    function instructor_email_appointments_appointment_cancelled($args,$metas,$order_details){
    	
	    $enable = get_user_meta($args['author_id'],'instructor_appointments_appointment_cancelled',true);
		if($enable !== 'no'){
			$user = get_user_by( 'id', $args['author_id']);
			$to = $user->user_email;
			
	        
	        $appointment = array();
	        $db = new WPLMS_APPOINTMENTS_DB;
	        $appointments = $db->get_appointments(Array('appointment_id'=>$args['appointment_id']));
	        if(!empty($appointments)){
	            $appointment = $appointments[0];
	        }
	        $appointment_html = $this->get_touch_appointment($appointment,$args['author_id']);
	        $appointment_id = (empty($appointment['parent_appointment_id'])?$appointment['appointment_id']:$appointment['parent_appointment_id']);
	    	$item_html = ((!empty($appointment['item_id']) && get_post_type($appointment['item_id'])=='course')?'<a href="'.get_permalink($appointment['item_id']).'">'.get_the_title($appointment['item_id']).'</a>':'');

			bp_course_wp_mail($to,'','',array('action'=>'instructor_appointments_appointment_cancelled',
				'item_id'=>$appointment_id ,
				'tokens'=>array(
					'appointment.id'=>$appointment_html ,
					'student.name'=>bp_core_get_user_displayname($args['booker_id']),
					'student.userlink'=>bp_core_get_userlink($args['booker_id']),
					'course.link'=>$item_html
			)));
		}
    	
    }

	//appointment_requested_cancellation
    function student_message_appointment_requested_cancellation($args){
    	

    	$appointment = array();
        $db = new WPLMS_APPOINTMENTS_DB;
        $appointments = $db->get_appointments(Array('appointment_id'=>$args['appointment_id']));
        if(!empty($appointments)){
            $appointment = $appointments[0];
        }
        $appointment_html = $this->get_touch_appointment($appointment,$args['booker_id']);
    	$item_html = ((!empty($appointment['item_id']) && get_post_type($appointment['item_id'])=='course')?'<a href="'.get_permalink($appointment['item_id']).'">'.get_the_title($appointment['item_id']).'</a>':'');

		$message = sprintf(__('You requested cancellation for appointment %s %s with instructor %s','wplms-appointments'),$appointment_html,$item_html,bp_core_get_userlink($args['author_id']));
	    if(bp_is_active('messages') && function_exists('bp_course_messages_new_message'))
	      bp_course_messages_new_message( array('sender_id' => $args['author_id'], 'subject' => __('Student : Booking Cancellation Requested','wplms-appointments'), 'content' => $message,   'recipients' => $args['booker_id'] ) );
    }

    function student_notification_appointment_requested_cancellation($args){
    	
	    $appointment = array();
        $db = new WPLMS_APPOINTMENTS_DB;
        $appointments = $db->get_appointments(Array('appointment_id'=>$args['appointment_id']));
        if(!empty($appointments)){
            $appointment = $appointments[0];
        }
    	bp_course_add_notification( array(
			'user_id'          => $args['booker_id'],
			'item_id'          => $appointment['appointment_id'],
			'secondary_item_id' => $args['author_id'],
			'component_action' => 'student_appointment_requested_cancellation'
		));
    }

    function student_email_appointment_requested_cancellation($args){
    	
	    $enable = get_user_meta($args['booker_id'],'student_appointment_requested_cancellation',true);
		if($enable !== 'no'){
			$user = get_user_by( 'id', $args['booker_id']);
			$to = $user->user_email;
			
	        
	        $appointment = array();
	        $db = new WPLMS_APPOINTMENTS_DB;
	        $appointments = $db->get_appointments(Array('appointment_id'=>$args['appointment_id']));
	        if(!empty($appointments)){
	            $appointment = $appointments[0];
	        }
	        $appointment_html = $this->get_touch_appointment($appointment,$args['booker_id']);
	        $appointment_id = (empty($appointment['parent_appointment_id'])?$appointment['appointment_id']:$appointment['parent_appointment_id']);
	    	$item_html = ((!empty($appointment['item_id']) && get_post_type($appointment['item_id'])=='course')?'<a href="'.get_permalink($appointment['item_id']).'">'.get_the_title($appointment['item_id']).'</a>':'');

			bp_course_wp_mail($to,'','',array('action'=>'student_appointment_requested_cancellation',
				'item_id'=>$appointment_id ,
				'tokens'=>array(
					'appointment.id'=>$appointment_html,
					'instructor.name'=>bp_core_get_user_displayname($args['author_id']),
					'instructor.userlink'=>bp_core_get_userlink($args['author_id']),
					'course.link'=>$item_html
			)));
		}
    }


    function instructor_message_appointment_requested_cancellation($args){
    	
	    $appointment = array();
        $db = new WPLMS_APPOINTMENTS_DB;
        $appointments = $db->get_appointments(Array('appointment_id'=>$args['appointment_id']));
        if(!empty($appointments)){
            $appointment = $appointments[0];
        }
        $appointment_html = $this->get_touch_appointment($appointment,$args['author_id'] );
    	$item_html = ((!empty($appointment['item_id']) && get_post_type($appointment['item_id'])=='course')?'<a href="'.get_permalink($appointment['item_id']).'">'.get_the_title($appointment['item_id']).'</a>':'');

		$message = sprintf(__('Student %s requested cancellation for appointment %s %s','wplms-appointments'),bp_core_get_userlink($args['booker_id']),$appointment_html,$item_html);
	    if(bp_is_active('messages') && function_exists('bp_course_messages_new_message'))
	      bp_course_messages_new_message( array('sender_id' =>$args['booker_id'] , 'subject' => __('Instructor : Booking Cancellation Requested','wplms-appointments'), 'content' => $message,   'recipients' =>$args['author_id']  ) );
    }

    function instructor_notification_appointment_requested_cancellation($args){
    	
	    $appointment = array();
        $db = new WPLMS_APPOINTMENTS_DB;
        $appointments = $db->get_appointments(Array('appointment_id'=>$args['appointment_id']));
        if(!empty($appointments)){
            $appointment = $appointments[0];
        }
    	bp_course_add_notification( array(
			'user_id'          => $args['author_id'],
			'item_id'          => $appointment['appointment_id'],
			'secondary_item_id' => $args['booker_id'],
			'component_action' => 'instructor_appointment_requested_cancellation'
		));
    }

    function instructor_email_appointment_requested_cancellation($args){
    	
	    $enable = get_user_meta($args['author_id'],'instructor_appointment_requested_cancellation',true);
		if($enable !== 'no'){
			$user = get_user_by( 'id', $args['author_id']);
			$to = $user->user_email;
			
	        
	        $appointment = array();
	        $db = new WPLMS_APPOINTMENTS_DB;
	        $appointments = $db->get_appointments(Array('appointment_id'=>$args['appointment_id']));
	        if(!empty($appointments)){
	            $appointment = $appointments[0];
	        }
	        $appointment_html = $this->get_touch_appointment($appointment,$args['author_id']);
	        $appointment_id = (empty($appointment['parent_appointment_id'])?$appointment['appointment_id']:$appointment['parent_appointment_id']);
	    	$item_html = ((!empty($appointment['item_id']) && get_post_type($appointment['item_id'])=='course')?'<a href="'.get_permalink($appointment['item_id']).'">'.get_the_title($appointment['item_id']).'</a>':'');

			bp_course_wp_mail($to,'','',array('action'=>'instructor_appointment_requested_cancellation',
				'item_id'=>$appointment_id ,
				'tokens'=>array(
					'appointment.id'=>$appointment_html ,
					'student.name'=>bp_core_get_user_displayname($args['booker_id']),
					'student.userlink'=>bp_core_get_userlink($args['booker_id']),
					'course.link'=>$item_html
			)));
		}

    }


    //appointment_requested_reschedule
    function student_message_appointment_requested_reschedule($args){
    	
        $appointment = array();
        $db = new WPLMS_APPOINTMENTS_DB;
        $appointments = $db->get_appointments(Array('appointment_id'=>$args['appointment_id']));
        if(!empty($appointments)){
            $appointment = $appointments[0];
        }
        $appointment_html = $this->get_touch_appointment($appointment,$args['booker_id']);
    	$item_html = ((!empty($appointment['item_id']) && get_post_type($appointment['item_id'])=='course')?'<a href="'.get_permalink($appointment['item_id']).'">'.get_the_title($appointment['item_id']).'</a>':'');

		$message = sprintf(__('You requested reschedule for appointment %s %s with instructor %s','wplms-appointments'),$appointment_html,$item_html,bp_core_get_userlink($args['author_id']));
	    if(bp_is_active('messages') && function_exists('bp_course_messages_new_message'))
	      bp_course_messages_new_message( array('sender_id' => $args['author_id'], 'subject' => __('Student : Booking Reschedule Requested','wplms-appointments'), 'content' => $message,   'recipients' => $args['booker_id'] ) );

    }

    function student_notification_appointment_requested_reschedule($args){
    	
        $appointment = array();
        $db = new WPLMS_APPOINTMENTS_DB;
        $appointments = $db->get_appointments(array('appointment_id'=>$args['appointment_id']));
        if(!empty($appointments)){
            $appointment = $appointments[0];
        }
    	bp_course_add_notification( array(
			'user_id'          => $args['booker_id'],
			'item_id'          => $appointment['appointment_id'],
			'secondary_item_id' => $args['author_id'],
			'component_action' => 'student_appointment_requested_reschedule'
		));
    }

    function student_email_appointment_requested_reschedule($args){
    	
        $enable = get_user_meta($args['booker_id'],'student_appointment_requested_reschedule',true);
		if($enable !== 'no'){
			$user = get_user_by( 'id', $args['booker_id']);
			$to = $user->user_email;
			
	        
	        $appointment = array();
	        $db = new WPLMS_APPOINTMENTS_DB;
	        $appointments = $db->get_appointments(Array('appointment_id'=>$args['appointment_id']));
	        if(!empty($appointments)){
	            $appointment = $appointments[0];
	        }
	        $appointment_html = $this->get_touch_appointment($appointment,$args['booker_id']);
	        $appointment_id = (empty($appointment['parent_appointment_id'])?$appointment['appointment_id']:$appointment['parent_appointment_id']);
	    	$item_html = ((!empty($appointment['item_id']) && get_post_type($appointment['item_id'])=='course')?'<a href="'.get_permalink($appointment['item_id']).'">'.get_the_title($appointment['item_id']).'</a>':'');

			bp_course_wp_mail($to,'','',array('action'=>'student_appointment_requested_reschedule',
				'item_id'=>$appointment_id ,
				'tokens'=>array(
					'appointment.id'=>$appointment_html,
					'instructor.name'=>bp_core_get_user_displayname($args['author_id']),
					'instructor.userlink'=>bp_core_get_userlink($args['author_id']),
					'course.link'=>$item_html
			)));
		}       
    }


    function instructor_message_appointment_requested_reschedule($args){
    	
        $appointment = array();
        $db = new WPLMS_APPOINTMENTS_DB;
        $appointments = $db->get_appointments(Array('appointment_id'=>$args['appointment_id']));
        if(!empty($appointments)){
            $appointment = $appointments[0];
        }
        $appointment_html = $this->get_touch_appointment($appointment,$args['author_id']);
    	$item_html = ((!empty($appointment['item_id']) && get_post_type($appointment['item_id'])=='course')?'<a href="'.get_permalink($appointment['item_id']).'">'.get_the_title($appointment['item_id']).'</a>':'');

		$message = sprintf(__('Student %s requested reschedule for appointment %s %s','wplms-appointments'),bp_core_get_userlink($args['booker_id']),$appointment_html,$item_html);
	    if(bp_is_active('messages') && function_exists('bp_course_messages_new_message'))
	      bp_course_messages_new_message( array('sender_id' =>$args['booker_id'] , 'subject' => __('Instructor : Booking Reschedule Requested','wplms-appointments'), 'content' => $message,   'recipients' =>$args['author_id']  ) );
    }

    function instructor_notification_appointment_requested_reschedule($args){
    	
        $appointment = array();
        $db = new WPLMS_APPOINTMENTS_DB;
        $appointments = $db->get_appointments(Array('appointment_id'=>$args['appointment_id']));
        if(!empty($appointments)){
            $appointment = $appointments[0];
        }
    	bp_course_add_notification( array(
			'user_id'          => $args['author_id'],
			'item_id'          => $appointment['appointment_id'],
			'secondary_item_id' => $args['booker_id'],
			'component_action' => 'instructor_appointment_requested_reschedule'
		));
    }

    function instructor_email_appointment_requested_reschedule($args){
    	
        $enable = get_user_meta($args['author_id'],'instructor_appointment_requested_reschedule',true);
		if($enable !== 'no'){
			$user = get_user_by( 'id', $args['author_id']);
			$to = $user->user_email;
			
	        
	        $appointment = array();
	        $db = new WPLMS_APPOINTMENTS_DB;
	        $appointments = $db->get_appointments(Array('appointment_id'=>$args['appointment_id']));
	        if(!empty($appointments)){
	            $appointment = $appointments[0];
	        }
	        $appointment_html = $this->get_touch_appointment($appointment,$args['author_id']);
	        $appointment_id = (empty($appointment['parent_appointment_id'])?$appointment['appointment_id']:$appointment['parent_appointment_id']);
	    	$item_html = ((!empty($appointment['item_id']) && get_post_type($appointment['item_id'])=='course')?'<a href="'.get_permalink($appointment['item_id']).'">'.get_the_title($appointment['item_id']).'</a>':'');

			bp_course_wp_mail($to,'','',array('action'=>'instructor_appointment_requested_reschedule',
				'item_id'=>$appointment_id ,
				'tokens'=>array(
					'appointment.id'=>$appointment_html ,
					'student.name'=>bp_core_get_user_displayname($args['booker_id']),
					'student.userlink'=>bp_core_get_userlink($args['booker_id']),
					'course.link'=>$item_html
			)));
		}
    }


    //Meeting Schedule cancelled

    function student_message_cancel_schedule_meeting($args){

    	$appointment = array();
        $db = new WPLMS_APPOINTMENTS_DB;
        $appointments = $db->get_appointments(Array('appointment_id'=>$args['appointment_id']));
        if(!empty($appointments)){
            $appointment = $appointments[0];
        }
        $appointment_html = $this->get_touch_appointment($appointment,$args['booker_id']);
    	$item_html = ((!empty($appointment['item_id']) && get_post_type($appointment['item_id'])=='course')?'<a href="'.get_permalink($appointment['item_id']).'">'.get_the_title($appointment['item_id']).'</a>':'');

		$message = sprintf(__('This meeting %s %s  is Cancelled by instructor %s','wplms-appointments'),$appointment_html,$item_html,bp_core_get_userlink($args['author_id']));
	    if(bp_is_active('messages') && function_exists('bp_course_messages_new_message'))
	      bp_course_messages_new_message( array('sender_id' => $args['author_id'], 'subject' => __('Student : Scheduled Meeting Cancellation','wplms-appointments'), 'content' => $message,   'recipients' => $args['booker_id'] ) );
    }


    function student_notification_cancel_schedule_meeting($args){
    	
        $appointment = array();
        $db = new WPLMS_APPOINTMENTS_DB;
        $appointments = $db->get_appointments(array('appointment_id'=>$args['appointment_id']));
        if(!empty($appointments)){
            $appointment = $appointments[0];
        }
    	bp_course_add_notification( array(
			'user_id'          => $args['booker_id'],
			'item_id'          => $appointment['appointment_id'],
			'secondary_item_id' => $args['author_id'],
			'component_action' => 'student_cancel_schedule_meeting'
		));
    }


    function student_email_cancel_schedule_meeting($args){

		$enable = get_user_meta($args['booker_id'],'student_cancel_schedule_meeting',true);
		if($enable !== 'no'){
			$user = get_user_by( 'id', $args['booker_id']);
			$to = $user->user_email;

			$appointment = array();
			$db = new WPLMS_APPOINTMENTS_DB;
			$appointments = $db->get_appointments(Array('appointment_id'=>$args['appointment_id']));
			if(!empty($appointments)){
				$appointment = $appointments[0];
			}
			$appointment_html = $this->get_touch_appointment($appointment,$args['booker_id']);
			$appointment_id = (empty($appointment['parent_appointment_id'])?$appointment['appointment_id']:$appointment['parent_appointment_id']);
			$item_html = ((!empty($appointment['item_id']) && get_post_type($appointment['item_id'])=='course')?'<a href="'.get_permalink($appointment['item_id']).'">'.get_the_title($appointment['item_id']).'</a>':'');

			bp_course_wp_mail($to,'','',array('action'=>'student_cancel_schedule_meeting',
			'item_id'=>$appointment_id ,
			'tokens'=>array(
			'appointment.id'=>$appointment_html,
			'instructor.name'=>bp_core_get_user_displayname($args['author_id']),
			'instructor.userlink'=>bp_core_get_userlink($args['author_id']),
			'course.link'=>$item_html
			)));
		}

    }



    function instructor_message_cancel_schedule_meeting($args){

    	$appointment = array();
        $db = new WPLMS_APPOINTMENTS_DB;
        $appointments = $db->get_appointments(Array('appointment_id'=>$args['appointment_id']));
        if(!empty($appointments)){
            $appointment = $appointments[0];
        }
        $appointment_html = $this->get_touch_appointment($appointment,$args['author_id'] );
    	$item_html = ((!empty($appointment['item_id']) && get_post_type($appointment['item_id'])=='course')?'<a href="'.get_permalink($appointment['item_id']).'">'.get_the_title($appointment['item_id']).'</a>':'');

		$message = sprintf(__('Instructor %s cancelled the meeting %s %s','wplms-appointments'),bp_core_get_userlink($args['booker_id']),$appointment_html,$item_html);
	    if(bp_is_active('messages') && function_exists('bp_course_messages_new_message'))
	      bp_course_messages_new_message( array('sender_id' =>$args['booker_id'] , 'subject' => __('Instructor : Scheduled Meeting Cancellation','wplms-appointments'), 'content' => $message,   'recipients' =>$args['author_id']  ) );

    }

    function instructor_notification_cancel_schedule_meeting($args){

    	$appointment = array();
        $db = new WPLMS_APPOINTMENTS_DB;
        $appointments = $db->get_appointments(Array('appointment_id'=>$appointment_id));
        if(!empty($appointments)){
            $appointment = $appointments[0];
        }
    	bp_course_add_notification( array(
			'user_id'          => $args['booker_id'],
			'item_id'          => $appointment['appointment_id'],
			'secondary_item_id' => $args['author_id'],
			'component_action' => 'instructor_cancel_schedule_meeting'
		));

    }

    function instructor_email_cancel_schedule_meeting($args){

		$enable = get_user_meta($args['author_id'],'instructor_cancel_schedule_meeting',true);
		if($enable !== 'no'){
			$user = get_user_by( 'id', $args['author_id']);
			$to = $user->user_email;

			$appointment = array();
			$db = new WPLMS_APPOINTMENTS_DB;
			$appointments = $db->get_appointments(Array('appointment_id'=>$args['appointment_id']));
			if(!empty($appointments)){
				$appointment = $appointments[0];
			}
			$appointment_html = $this->get_touch_appointment($appointment,$args['author_id']);
			$appointment_id = (empty($appointment['parent_appointment_id'])?$appointment['appointment_id']:$appointment['parent_appointment_id']);
			$item_html = ((!empty($appointment['item_id']) && get_post_type($appointment['item_id'])=='course')?'<a href="'.get_permalink($appointment['item_id']).'">'.get_the_title($appointment['item_id']).'</a>':'');

			bp_course_wp_mail($to,'','',array('action'=>'instructor_cancel_schedule_meeting',
			'item_id'=>$appointment_id ,
			'tokens'=>array(
			'appointment.id'=>$appointment_html ,
			'student.name'=>bp_core_get_user_displayname($args['booker_id']),
			'student.userlink'=>bp_core_get_userlink($args['booker_id']),
			'course.link'=>$item_html
			)));
		}


    }

    /* Appointment About to Start */

    function student_message_appointment_start($schedule_id,$appointment_id){

    	$db = new WPLMS_APPOINTMENTS_DB;
    	$appointments = $db->get_appointments(array('appointment_id'=>$appointment_id));
    	$appointment = $appointments[0];

    	if(!empty($appointments)){
            $appointment = $appointments[0];
        }
        $appointment_html = $this->get_touch_appointment($appointment,$args['author_id']);
    	$item_html = ((!empty($appointment['item_id']) && get_post_type($appointment['item_id'])=='course')?'<a href="'.get_permalink($appointment['item_id']).'">'.get_the_title($appointment['item_id']).'</a>':'');

		$message = sprintf(__('The Appointment %s is going to start for student %s','wplms-appointments'),bp_core_get_userlink($args['booker_id']),$appointment_html,$item_html);
	    if(bp_is_active('messages') && function_exists('bp_course_messages_new_message'))
	      bp_course_messages_new_message( array('sender_id' =>$args['booker_id'] , 'subject' => __('Student : Appointment is About to start','wplms-appointments'), 'content' => $message,   'recipients' =>$args['author_id']  ) );


    }


    function student_notification_appointment_start($args){

    	$appointment = array();
        $db = new WPLMS_APPOINTMENTS_DB;
        $appointments = $db->get_appointments(Array('appointment_id'=>$appointment_id));
        if(!empty($appointments)){
            $appointment = $appointments[0];
        }
    	bp_course_add_notification( array(
			'user_id'          => $args['booker_id'],
			'item_id'          => $appointment['appointment_id'],
			'secondary_item_id' => $args['author_id'],
			'component_action' => 'student_appointment_start'
		));


    }


    function student_email_appointment_start($schedule_id,$appointment_id){

    	$db = new WPLMS_APPOINTMENTS_DB;
    	$appointments = $db->get_appointments(array('appointment_id'=>$appointment_id));
    	$appointment = $appointments[0];


    	$bookers = wplms_get_appointment_bookers($appointment_id);
    	if(!empty($bookers)){
    		foreach($bookers as $booker){
    			$user = get_user_by( 'id', $booker);

				$to = $user->user_email;

				$appointment_html = $this->get_touch_appointment($appointment,$appointment['author_id']);

				$item_html = ((!empty($appointment['item_id']) && get_post_type($appointment['item_id'])=='course')?'<a href="'.get_permalink($appointment['item_id']).'">'.get_the_title($appointment['item_id']).'</a>':'');

				//$diff = round($appointment['start_date']/1000) + $appointment['start_time']*60 - time();

				bp_course_wp_mail($to,'','',array('action'=>'student_appointment_start',
					'item_id'=>$appointment_id ,
					'tokens'=>array(
						'appointment.id'=>$appointment_html ,
						'appointment.instructor_link'=>bp_core_get_userlink($appointment['author_id']),
						'appointment.item_link'=>$item_html
				)));
    		}
    	}
    }



    function instructor_message_appointment_start($schedule_id,$appointment_id){

    	$db = new WPLMS_APPOINTMENTS_DB;
    	$appointments = $db->get_appointments(array('appointment_id'=>$appointment_id));
    	$appointment = $appointments[0];

    	if(!empty($appointments)){
            $appointment = $appointments[0];
        }
        $appointment_html = $this->get_touch_appointment($appointment,$args['author_id']);
    	$item_html = ((!empty($appointment['item_id']) && get_post_type($appointment['item_id'])=='course')?'<a href="'.get_permalink($appointment['item_id']).'">'.get_the_title($appointment['item_id']).'</a>':'');

		$message = sprintf(__('The Appointment %s is going to start for student %s','wplms-appointments'),bp_core_get_userlink($args['booker_id']),$appointment_html,$item_html);
	    if(bp_is_active('messages') && function_exists('bp_course_messages_new_message'))
	      bp_course_messages_new_message( array('sender_id' =>$args['booker_id'] , 'subject' => __('Instructor : Appointment is About to start','wplms-appointments'), 'content' => $message,   'recipients' =>$args['author_id']  ) );

    }
    
    function instructor_notification_appointment_start($args){

    	$appointment = array();
        $db = new WPLMS_APPOINTMENTS_DB;
        $appointments = $db->get_appointments(Array('appointment_id'=>$appointment_id));
        if(!empty($appointments)){
            $appointment = $appointments[0];
        }
    	bp_course_add_notification( array(
			'user_id'          => $args['booker_id'],
			'item_id'          => $appointment['appointment_id'],
			'secondary_item_id' => $args['author_id'],
			'component_action' => 'instructor_appointment_start'
		));


    }

    
    function instructor_email_appointment_start($schedule_id,$appointment_id){
    	
    	$db = new WPLMS_APPOINTMENTS_DB;
    	$appointments = $db->get_appointments(array('appointment_id'=>$appointment_id));
    	$appointment = $appointments[0];


    	$bookers = wplms_get_appointment_bookers($appointment_id);
    	if(!empty($bookers)){
    		foreach($bookers as $booker){
    			$user = get_user_by( 'id', $booker);

				$to = $user->user_email;

				$appointment_html = $this->get_touch_appointment($appointment,$appointment['author_id']);

				$item_html = ((!empty($appointment['item_id']) && get_post_type($appointment['item_id'])=='course')?'<a href="'.get_permalink($appointment['item_id']).'">'.get_the_title($appointment['item_id']).'</a>':'');

				//$diff = round($appointment['start_date']/1000) + $appointment['start_time']*60 - time();

				bp_course_wp_mail($to,'','',array('action'=>'instructor_appointment_start',
					'item_id'=>$appointment_id ,
					'tokens'=>array(
						'appointment.id'=>$appointment_html ,
						'appointment.instructor_link'=>bp_core_get_userlink($appointment['author_id']),
						'appointment.item_link'=>$item_html
				)));
    		}
    	}
    	
    }
}

add_action('bp_init',function(){

	$wplms_tc = Wplms_Appointments_Tc::init();
});