<?php
/**
 * WPLMS Chat functions
 *
 * @author 		VibeThemes
 * @category 	Functions
 * @package 	wplms_chat/Includes
 * @version     1.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}


class WPLMS_Appointments_Functions{


	public static $instance;

    public static function init(){

        if ( is_null( self::$instance ) )
            self::$instance = new WPLMS_Appointments_Functions();
        return self::$instance;
    }


    function __construct(){
    }


    function get_slots(){

    	if(empty($this->slots)){
    		$slots = get_option('wplms_appointments_active_slots');

    		
			if(!empty($slots)){
				$updated = 0;
				if(!is_array($slots)){
	    			$slots = unserialize($slots);	
	    		}
				foreach($slots as $k=>$slot){
					if(!isset($slot['expiry']) || $slot['expiry'] < time()){
						unset($slots[$k]);
						$updated=1;
					}
				}

				if($updated){
					update_option('wplms_appointments_active_slots',$slots);
				}
			}
			$this->slots=$slots;
    	}
    	

		return $this->slots;
    }


	function get_pending_slots($args){

		
		extract($args);

		if(!empty($booker_id) && !is_numeric($booker_id)){
			$booker_id = 0;
		}

		

		
		if(!empty($instructor_id)){

			if(empty($this->pending_appointments)){

				if(!is_numeric($instructor_id)){
					
					if(!is_array($instructor_id)){
						$instructor_id = json_decode($instructor_id);	
					}
					
					if(is_Array($instructor_id)){
						$instructor_id=$instructor_id[0];
					}
				}
				$pending_appointments = get_user_meta($instructor_id,'pending_appointments',true);	

				
			}else{
				return $this->pending_appointments;
			}
		} 

		if(!empty($booker_id)){

			if(empty($this->pending_bookings)){
				
				$pending_appointments = get_user_meta($booker_id,'pending_bookings',true);		

				$this->pending_bookings = $pending_appointments;
			}else{
				return $this->pending_bookings;
			}
		}
		
		
		if(!empty($pending_appointments)){
			
			$unchanged  =  1;
			foreach($pending_appointments as $appointment_id => $details){

				if(!empty($details)){
					if(is_array($details) && empty($details['time'])){
						
						foreach($details as $k=>$detail){
							if($detail['time'] < time()){
								$unchanged = 0;
								unset($pending_appointments[$appointment_id][$k]);
							}
						}	
					}else{
						if($details['time'] < time()){
							$unchanged=0;
							unset($pending_appointments[$appointment_id]);
						}
					}
				}
				
				
			}
			if(empty($unchanged)){
				if(!empty($instructor_id)){
					update_user_meta($instructor_id,'pending_appointments',$pending_appointments);
				}else if(!empty($booker_id)){
					update_user_meta($booker_id,'pending_bookings',$pending_appointments);
				}
			}
			if(!empty($instructor_id)){
				$this->pending_appointments = $pending_appointments;
			}else{
				$this->pending_bookings = $pending_appointments;
			}
			
		}else{
			return array();
		}

		return $pending_appointments;
	}

}

function wplms_appointment_get_profile_setting($user_id,$setting){
	$profile = WPLMS_Appointments_Profile::init();
	$settings = $profile->get_user_appointment_settings($user_id);
	return empty($settings[$setting])?0:$settings[$setting];
}


function wplms_get_approval_time($instructor_id){

	$profile = WPLMS_Appointments_Profile::init();
	$instructor_settings = $profile->get_user_appointment_settings($instructor_id);


	$init = WPLMS_Appointments_Init::init();
	$settings = $profile->get_global_settings();

	return empty($settings['appointments_booking_payment_processing_timer'])?86400:$settings['appointments_booking_payment_processing_timer'];
}

function wplms_appointments_get_max_seats($args){

	
	$init = WPLMS_Appointments_Init::init();
	$enable_seats = $init->get_global_settings();
	if(!empty($enable_seats['appointments_schedule_seats'])){

		$db = new WPLMS_APPOINTMENTS_META_DB;

		if(!empty($args['slot_id'])){
			$meta = $db->get_appointments_meta(array('appointment_id'=>$args['slot_id'],'meta_key'=>'max_seats'));
			if(!empty($meta)){
				return $meta[0]['meta_value'];
			}
		}
		
		if(!empty($args['schedule_id'])){
			$meta = $db->get_appointments_meta(array('appointment_id'=>$args['schedule_id'],'meta_key'=>'max_seats'));
			if(!empty($meta)){
				return $meta[0]['meta_value'];
			}
		}

		if(!empty($args['instructor_id'])){
			$seats = wplms_appointment_get_profile_setting($args['instructor_id'],'appointments_schedule_seats');
			if(!empty($seats)){
				return $seats;
			}	
		}
	}

	return 1;
	
}

function wplms_appointments_get_unread_count($user_id){

	if(!bp_is_active('messages'))
		return 0;

	$bp = buddypress();
	global $wpdb;
	$unread_count = $wpdb->get_results( $wpdb->prepare( "SELECT SUM(recipients.unread_count) as unread, meta.meta_value as appointments_id FROM {$bp->messages->table_name_recipients} as recipients INNER JOIN  {$bp->messages->table_name_meta } as meta ON recipients.thread_id = meta.message_id WHERE recipients.user_id = %d AND recipients.is_deleted = 0 AND recipients.sender_only = 0 AND meta.meta_key = 'wplms_appointment_id' ", $user_id ),ARRAY_A );

	return $unread_count;
}

function wplms_appointments_confirm_booking($user_id,$slot_id,$exras=0){
	
	$db = new WPLMS_APPOINTMENTS_DB;
	$meta_db = new WPLMS_APPOINTMENTS_META_DB;
	$appointments = $db->get_appointments(Array('appointment_id'=>$slot_id));
	if(empty($appointments)){
		return false;
	}

	if(empty($appointments[0]['booker_id'])){
		$db->update_appointment(array('appointment_id'=>$slot_id,'booker_id'=>$user_id));
	}else{
		
		//$meta_db->update_appointment_meta(Array('appointment_id'=>$slot_id,'meta_key'=>'booker_id','meta_value'=>$user_id,'single'=>1));

		$meta_db->add_appointment_meta(Array('appointment_id'=>$slot_id,'meta_key'=>'booker_id','meta_value'=>$user_id,'single'=>1));
	}
	if(!empty($extras)){
		$meta_db->update_appointment_meta(Array('appointment_id'=>$slot_id,'meta_key'=>$user_id,'meta_value'=>$extras,'single'=>1));
	}

	do_action('wplms_appointments_booking_confirmed',$user_id,$appointments[0]);
	return true;
}

function wplms_appointments_cancel_booking($user_id,$slot_id){

}


function wplms_appointments_instructor_price_range($instructor_id,$minmax=''){

	global $wpdb;

	if($minmax == 'min'){
		$return =$wpdb->get_var("SELECT min(meta_value) FROM {WPLMS_APPOINTMENTS_META_DB::get_table_name} WHERE meta_key = 'appointment_price_".$instructor_id."'");
	}else if($minmax == 'max'){
		$return =$wpdb->get_var("SELECT max(meta_value) FROM {WPLMS_APPOINTMENTS_META_DB::get_table_name} WHERE meta_key = 'appointment_price_".$instructor_id."'");
	}else{
		$return =$wpdb->get_results("SELECT min(meta_value) as min, max(meta_value) as max FROM {WPLMS_APPOINTMENTS_META_DB::get_table_name} WHERE meta_key = 'appointment_price_".$instructor_id."'",ARRAY_A);
	}
	
	if(empty($return)){
		$return = 0;
	}

	return $return;
}


function wplms_get_appointment_bookers($appointment_id){

	$db = new WPLMS_APPOINTMENTS_DB;
    $meta_db = new WPLMS_APPOINTMENTS_META_DB;
    $appointments = $db->get_appointments(array('appointment_id'=>$appointment_id));
 	$bookers = $meta_db->get_appointments_meta(Array('appointment_id'=>$appointment_id,'meta_key'=>'booker_id'));

 	$booker_ids = array();

 	if(!empty($appointments[0]['booker_id'])){
 		$booker_ids[]=$appointments[0]['booker_id'];
 	}
 	if(!empty($bookers)){
 		foreach($bookers as $booker){
 			if(!in_Array($booker['meta_value'],$booker_ids)){
 				$booker_ids[]=$booker['meta_value'];
 			}
 		}
 	}
 	return $booker_ids;
}
function wplms_get_appointment_instructor($appointment_id){
	$db = new WPLMS_APPOINTMENTS_DB;
	$appointments = $db->get_appointments(array('appointment_id'=>$appointment_id));
	return $appointments[0]['author_id'];
}


function wplms_appointments_get_active_slots(){

	$functions = WPLMS_Appointments_Functions::init();
	

	return $functions->get_slots();
}

function wplms_appointments_remove_active_slot($slot_id){
	$slots = wplms_appointments_get_active_slots();
	$key = array_search($slot_id, array_column($slots, 'appointment_id'));
	if($key !== false){
		unset($slots[$key]);
	}
	update_option('wplms_appointments_active_slots',$slots);
}
function wplms_appointments_record_active_slot($slot){
	$slots = wplms_appointments_get_active_slots();
	/*$args= array(
		'user_id'=>get_current_user_id(),
		'expiry'=>time(),
		'appointment_id'=>0
	);*/
	$slots[]=$slot;
	update_option('wplms_appointments_active_slots',$slots);
}



function wplms_appointments_get_pending_slots($args){

	if(empty($args)){
		return array();
	}
	$functions = WPLMS_Appointments_Functions::init();
	return $functions->get_pending_slots($args);
}


function wplms_appointments_update_pending_slots($args){

	extract($args);


	if(!empty($instructor_id)){
		$pending_appointments_instructor = wplms_appointments_get_pending_slots(array('instructor_id'=>$instructor_id));	
	}
	
	if(!empty($booker_id)){
		$pending_appointments_booker = wplms_appointments_get_pending_slots(array('booker_id'=>$booker_id));	
	}
	
	
	if(empty($pending_appointments_instructor)){
        $pending_appointments_instructor = array();
    }


    if(empty($pending_appointments_booker)){
        $pending_appointments_booker = array();
    }

    if(is_array($slot_id)){
    	$slot_ids = $slot_id;
    }else{
    	$slot_ids = array($slot_id);
    }

    unset($args['slot_id']);
    if(empty($args['time'])){
    	$args['time']=time();
    }
    
    if(!empty($slot_ids)){
        foreach($slot_ids as $s_id){
        	if(is_Array($s_id)){
        		
        		foreach($s_id as $sid){

        			$pending_appointments_instructor[$sid][]=$args;

        			$pending_appointments_booker[$sid]=$args;
        		}
        	}else{
        		
        		if(empty($pending_appointments_instructor[$s_id])){
        			$pending_appointments_instructor[$s_id]=array($args);	
        		}else{
        			$pending_appointments_instructor[$s_id][]=$args;
        		}
        		
        		$pending_appointments_booker[$s_id]=$args;
        	}
        }
    }
    if(!empty($pending_appointments_instructor)){
	    update_user_meta($instructor_id,'pending_appointments',$pending_appointments_instructor);
	}
    if(!empty($pending_appointments_booker)){
    	update_user_meta($booker_id,'pending_bookings',$pending_appointments_booker);	
    }
}

function wplms_appointments_convert_utc_local($utc_date,$utc_time,$user_id=null){

	$user_offset = get_user_meta($user_id,'gmt_offset',true);
	$date_format = get_option('date_format');
	$time_format = get_option('time_format');

	if(empty($user_offset)){
		$offset = get_option('gmt_offset')*3600;
	}else{
		$offset = $user_offset*3600;
	}
	$current_timestamp = strtotime(date('d-m-Y',($utc_date/1000 + 2*$offset))) + ($utc_time*60 + $offset);

	return date($date_format.' '.$time_format,$current_timestamp);


}


function wplms_getdate_appointment_timestamp($appointment){

    $dateObj = explode('T',$appointment['start']);
    $date = $dateObj[0].' '.substr($dateObj[1], 0,5);

    return strtotime($date);
}



function wplms_appointments_get_course_id_instatus(){
  if(!empty($_POST['course_id'])){
    return $_POST['course_id'];
  }

  if(!empty($_COOKIE['course_id'])){
    return $_COOKIE['course_id'];
  }
}


if(!function_exists('tofriendlytime')){
  function tofriendlytime($seconds,$force = null) {
  $measures = array(
    array('label'=>__('year','vibe'),'multi'=>__('years','vibe'), 
          'value'=>12*30*24*60*60),
    array('label'=>__('month','vibe'),'multi'=>__('months','vibe'), 
          'value'=>30*24*60*60),
    array('label'=>__('week','vibe'),'multi'=>__('weeks','vibe'), 
          'value'=>7*24*60*60),
    array('label'=>__('day','vibe'),'multi'=>__('days','vibe'), 
          'value'=>24*60*60),
    array('label'=>__('hour','vibe'),'multi'=>__('hours','vibe'), 
          'value'=>60*60),
    array('label'=>__('minute','vibe'),'multi'=>__('minutes','vibe'), 
          'value'=>60),
    array('label'=>__('second','vibe'),'multi'=>__('seconds','vibe'), 
          'value'=>1),
    );

    if($seconds <= 0)
      return __('EXPIRED','vibe');
  
    foreach($measures as $key => $measure){
      if(!empty($force)){
          if($measure['value'] <= $force){
            $count = floor($seconds/$force);
            break;
          }
      }else{
          if($measure['value'] < $seconds && empty($force)){
            $count = floor($seconds/$measure['value']);
            break;
          }
      }
    }

    if(empty($force))
      $time_labels = $count.' '.(($count > 1)?$measure['multi']:$measure['label']);
    else
      $time_labels = (($count > 1)?$count:'').' '.(($count > 1)?$measure['multi']:$measure['label']);

    if($measure['value'] > 1){ // Ensure we're not on last element
      $small_measure = $measures[$key+1];  
      $small_count = floor(($seconds%$measure['value'])/$small_measure['value']);
      if($small_count)
        $time_labels .= ', '.$small_count.' '.(($small_count > 1)?$small_measure['multi']:$small_measure['label']);
    }
    
  return $time_labels;
  } 
}