<?php
/*
Plugin Name: WPLMS Appointments
Plugin URI: https://wplms.io
Description: WPLMS Appointments
Author: VibeThemes
Version: 1.6.1
Author URI: https://www.wplms.io
Text Domain: wplms-appointments
Domain Path: /languages/
*/

if ( ! defined( 'ABSPATH' ) ) exit;


include_once 'includes/class.config.php';
include_once 'includes/class.updater.php';

include_once 'includes/class.admin.php';
include_once 'includes/class.settings.php';

include_once 'includes/db.php';
include_once 'includes/class.appointments-db.php';
include_once 'includes/class.appointments-meta-db.php';

include_once 'includes/functions.php';
include_once 'includes/class.init.php';

include_once 'includes/class.profile.php';

include_once 'includes/actions.php';
include_once 'includes/filters.php';
include_once 'includes/class.bbb-api.php';
include_once 'includes/activity.php';
include_once 'includes/class.touchpoints.php';
include_once 'includes/class.scheduler.php';
include_once 'includes/class.meetings.php';
include_once 'includes/class.api.php';
include_once 'includes/class.shortcodes.php';

if( !defined('WPLMS_APPOINTMENTS_VERSION')){
    define('WPLMS_APPOINTMENTS_VERSION','1.6.1');
}

if( !defined('BP_APPOINTMENTS_SLUG')){
    define('BP_APPOINTMENTS_SLUG',_x('appointments','appointments slug','wplms-appointments'));
}

if( !defined('BP_APPOINTMENTS_COMPLETED_SLUG')){
    define('BP_APPOINTMENTS_COMPLETED_SLUG',_x('complete','appointments slug','wplms-appointments'));
}

if( !defined('BP_APPOINTMENTS_SETTINGS_SLUG')){
    define('BP_APPOINTMENTS_SETTINGS_SLUG',_x('settings','appointments settings slug','wplms-appointments'));
}



add_action('plugins_loaded','wplms_appointments_translations');
function wplms_appointments_translations(){
    $locale = apply_filters("plugin_locale", get_locale(), 'wplms-appointments');
    $lang_dir = dirname( __FILE__ ) . '/languages/';
    $mofile        = sprintf( '%1$s-%2$s.mo', 'wplms-appointments', $locale );
    $mofile_local  = $lang_dir . $mofile;
    $mofile_global = WP_LANG_DIR . '/plugins/' . $mofile;

    if ( file_exists( $mofile_global ) ) {
        load_textdomain( 'wplms-appointments', $mofile_global );
    } else {
        load_textdomain( 'wplms-appointments', $mofile_local );
    }  
}



function WPLMS_Appointments_Plugin_updater() {
    $license_key = trim( get_option( 'wplms_appointments_license_key' ) );
    $edd_updater = new WPLMS_Appointments_Plugin_Updater( 'https://wplms.io', __FILE__, array(
            'version'   => '1.6.1',               
            'license'   => $license_key,        
            'item_name' => 'WPLMS Appointments',    
            'author'    => 'VibeThemes' 
        )
    );
}
add_action( 'admin_init', 'WPLMS_Appointments_Plugin_updater', 0 );
