jQuery(document).ready(function($){
	if(typeof window.idcard_builder.idcard_json != 'undefined' && window.idcard_builder.idcard_json.length){
		window.idcard_builder.idcard_json = JSON.parse(window.idcard_builder.idcard_json);
		$('#idcard').after('<a class="button" id="remove_generated_card"><i class="dashicons dashicons-no"></i></a>');
	}

	$('#remove_generated_card').on('click',function(){

		if($(this).hasClass('disabled')){
			return;
		}

		$(this).addClass('disabled');
		$('#idcard').addClass('disabled');

		$.ajax({
          	type: "POST",
          	url: ajaxurl,
          	data: { action: 'remove_idcard_builder',
                  security:window.idcard_builder.security,
                  id:window.idcard_builder.id
                },
          	cache: false,
          	success: function (html) {
				$('#idcard').removeClass('disabled');
				$('#remove_generated_card').remove();
          	}
        });
	});

	$('#idcard').on('click',function(){

		if($(this).hasClass('disabled')){
			return;
		}

		var idcard_builder_html = '<div class="idcard_builder_wrapper">\
			<div class="idcard_builder">\
				<span class="close dashicons dashicons-no""></span>\
				<div class="idcard_builder_controls">\
					<ul>';
		idcard_builder.controls.map(function(control){
			if(control.type == 'number'){
				idcard_builder_html += '<li class="'+control.key+'"><label>'+control.label+'</label><input type="number" name="idcard_'+control.key+'" value="'+control.value+'" class="input" />';
			}
			if(control.type == 'text'){
				idcard_builder_html += '<li class="'+control.key+'"><label>'+control.label+'</label><input type="text" name="idcard_'+control.key+'" value="'+control.value+'" class="input" />';
			}
		});			
		idcard_builder_html += '</ul>\
				</div>\
				<div class="idcard_elements">\
					<div class="idcard_element text_element">\
						'+idcard_builder.text+'\
					</div>\
					<div class="idcard_element image_element">\
						'+idcard_builder.image+'\
					</div>\
					<div class="idcard_element user_controls">\
						'+idcard_builder.user_controls+'\
					</div>\
					<div class="idcard_element save_element button-primary">\
						'+idcard_builder.save+'\
					</div>\
				</div>\
				<div class="idcard_builder_main">\
				</div>\
			</div></div>';

		$('body').append(idcard_builder_html);
		$('body').trigger('idcard_loaded');

		$('.close').on('click',function(){
			$('.idcard_builder_wrapper').remove();
		});
	});
	

	$('body').on('idcard_loaded',function(){
		let left = $('.idcard_builder_main').offset().left;
		let top = $('.idcard_builder_main').offset().top -  $(window).scrollTop();
		jQuery(window).scroll(function(){
			left = $('.idcard_builder_main').offset().left;
			top = $('.idcard_builder_main').offset().top -  $(window).scrollTop();
		});
		
		$('.idcard_builder_main').append('<div class="idcard_builder_x" style="height:1px;background:red;width:100%;top:0px;left:0;position:absolute;"></div><div class="idcard_builder_y" style="width:1px;background:red;height:100%;top:0;left:0px;position:absolute;"></div>');
		$('.idcard_builder_main').on('mousemove',function(event){

			let x = event.clientY - top;
			let y = event.clientX - left;
			$('.idcard_builder_main .idcard_builder_x').css('top',x+'px');
			$('.idcard_builder_main .idcard_builder_y').css('left',y+'px');
		});
	


		var max_width = $('.idcard_builder_main').width();
		var max_height = $('.idcard_builder_main').height();

		var font_list = [
			{'value':'times','label':'Times New Roman'},
			{'value':'timesB','label':'Times New Roman Bold'},
			{'value':'courier','label':'Courier'},
			{'value':'courierB','label':'Courier Bold'},
			{'value':'helvetica','label':'Helvetica'},
			{'value':'helveticaB','label':'Helvetica Bold'},
		];
		if(typeof  window.idcard_builder.fonts !== 'undefined' && window.idcard_builder.fonts.length){
			idcard_builder.fonts.map(function (font){
				font_list.push({'label':font.name,'value':font.path})
				return font;
			});
		}
		var idcard_json =[];
		if(typeof  window.idcard_builder.idcard_json !== 'undefined' && window.idcard_builder.idcard_json.length){
			idcard_json = window.idcard_builder.idcard_json;
		}

		let width = $('li.width input').val();
		let height = $('li.height input').val();

		if(parseInt(width,10) <= 0){
			width = 768;
		} 
		if(parseInt(height,10) <= 0){
			height = 460;
		} 

		let saved_idcard = localStorage.getItem('saved_idcard');
		if(saved_idcard !== null){
			if( saved_idcard !== JSON.stringify(idcard_json)){

				new Promise(function(resolve){
					$('.idcard_elements').append('<div class="idcard_element restore_element button">'+idcard_builder.restore+'</div>');
					resolve();	
				}).then(function(){

					$('.idcard_builder').trigger('init');
				});
			}else{
				setTimeout(function(){
					$('.idcard_builder').trigger('init');	
				},300);
				
			}
		}else{
			setTimeout(function(){
				$('.idcard_builder').trigger('init');	
			},300);
		}

		$('.save_element').on('click',function(){
			let defText = $('.save_element').text();

			var idcard_size_settings = {'width': $('li.width input').val(), 'height': $('li.height input').val(),'background':$('li.background input').val()};
			var $this = $(this);

			if(!$this.hasClass('loading')){
				$this.text(window.idcard_builder.saving);
				$this.addClass('loading');
				$.ajax({
		          	type: "POST",
		          	url: ajaxurl,
		          	data: { action: 'save_idcard_builder',
		                  security:window.idcard_builder.security,
		                  id:window.idcard_builder.id,
		                  idcard_json: JSON.stringify(idcard_json),
		                  idcard_size_settings: JSON.stringify(idcard_size_settings)
		                },
		          	cache: false,
		          	success: function (html) {
		            	$this.text(html);
		            	setTimeout(function(){
		            		$this.text(defText);
		            		$this.removeClass('loading');
		            	},3000);
		          	}
		        });
			}
		});
		

		$('.idcard_builder_main').width(width);
		$('.idcard_builder_main').height(height);

		

		$("input[name='idcard_width']").keyup(function() {
			$('.idcard_builder_main').width($("input[name='idcard_width']").val());
		})

		$("input[name='idcard_height']").keyup(function() {
			$('.idcard_builder_main').height($("input[name='idcard_height']").val());
		})
		

		$('input[name="idcard_background"]').keyup(function(){
			let val = $(this).val();
			if(typeof val != 'undefined' && val.length){
				if(val.indexOf('#') !== false){
					$('.idcard_builder_main').css('background',val);
				}else{
					$('.idcard_builder_main').css('background','url("'+val+'") no-repeat left top');
					$('.idcard_builder_main').css('background-size','cover');
				}
			};

		});
			
		

		$('#idcard_builder').css('min-width',(parseInt(width,10)+30)+'px');


		if(typeof $('li.background input').val() != 'undefined' && $('li.background input').val().length){

			let str = $('li.background input').val();
			if(str.indexOf('#') !== false){
				$('.idcard_builder_main').css('background',str);
			}else{
				$('.idcard_builder_main').css('background','url("'+str+'") no-repeat left top');
				$('.idcard_builder_main').css('background-size','cover');
			}
		};

		

		$('.text_element').on('click',function(){
			max_width = $('.idcard_builder_main').width();
			max_height = $('.idcard_builder_main').height();

			$('.popup_element_wrapper').remove();
			let element = '<div class="popup_element_wrapper"><div class="popup_element new">\
				<div class="left_block"><textarea>'+idcard_builder.default_text+'</textarea></div>\
				<div class="right_block"><input class="top" placeholder="'+idcard_builder.top_margin+'" />\
				<input class="left" placeholder="'+idcard_builder.left_margin+'" />\
				<div><label>'+idcard_builder.width+'</label><input type="text" value="0" class="width slider_input" /><div class="font_size_slider" min="1" max="'+max_width+'" value="0"></div></div>\
				<div><label>'+idcard_builder.height+'</label><input type="text" value="0" class="height slider_input" /><div class="font_size_slider" min="1" max="'+max_height+'" value="0"></div></div>\
				</div>\
				<div class="controls"><ul>';
			element += '<li><label>'+idcard_builder.font_size+'</label><input type="text" value="14" class="font_size slider_input"><div class="font_size_slider" min="1" max="100" value="14"></div></li>';
			element += '<li><label>'+idcard_builder.font_color+'</label><input type="text" value="#222222" class="font_color"></li>';
			element += '<li><label>'+idcard_builder.font_style+'</label><select class="font_style"><option value="none">None</option><option value="underline">Underline</option><option value="italics">Italics</option></select></li>';
			element += '<li><label>'+idcard_builder.font_family+'</label><select class="font_family">';
			font_list.map(function(font){
				element += '<option value="'+font.value+'">'+font.label+'</option>';
			});
			element += '</select></li>';
			element +='</ul></div><a class="button-primary add_text">'+idcard_builder.add_text+'</a><div class="close_element dashicons dashicons-no"></div></div></div></div>';
			$('.idcard_builder').append(element);
			$('.idcard_builder').trigger('adding');
		});

		$('.image_element').on('click',function(){
			$('.popup_element_wrapper').remove();
			max_width = $('.idcard_builder_main').width();
			max_height = $('.idcard_builder_main').height();
			let element = '<div class="popup_element_wrapper"><div class="popup_element new">\
				<div class="left_block"><img src="'+idcard_builder.default_image_url+'" /><a class="upload_image">'+idcard_builder.upload_image+'</a><input type="hidden" value="'+idcard_builder.default_image_url+'" class="image_path" /></div>\
				<div class="right_block"><input class="top" placeholder="'+idcard_builder.top_margin+'" />\
				<input class="left" placeholder="'+idcard_builder.left_margin+'" />\
				<div><label>'+idcard_builder.width+'</label><input type="text" value="0" class="width slider_input" /><div class="font_size_slider" min="1" max="'+max_width+'" value="0"></div></div>\
				<div><label>'+idcard_builder.height+'</label><input type="text" value="0" class="height slider_input" /><div class="font_size_slider" min="1" max="'+max_height+'" value="0"></div></div>\
				</div>\
				<div class="controls"><ul>';

			
			element += '<li><label>'+idcard_builder.border_radius+'</label><input type="text" value="0" class="border_radius slider_input"><div class="font_size_slider" min="1" max="100" value="0"></div></li>';
			element +='</ul></div><a class="button-primary add_image">'+idcard_builder.add_image+'</a><div class="close_element dashicons dashicons-no"></div>\
				</div></div></div>';
	 		
	 		$('.idcard_builder').append(element);

			$('.idcard_builder').trigger('adding');
		});

		$('.user_image').on('click',function(){
			$('.popup_element_wrapper').remove();
			max_width = $('.idcard_builder_main').width();
			max_height = $('.idcard_builder_main').height();
			let element = '<div class="popup_element_wrapper"><div class="popup_element new">\
				<div class="left_block"><img src="'+idcard_builder.default_image_url+'" /></div>\
				<div class="right_block"><input class="top" placeholder="'+idcard_builder.top_margin+'" />\
				<input class="left" placeholder="'+idcard_builder.left_margin+'" />\
				<div><label>'+idcard_builder.width+'</label><input type="text" value="0" class="width slider_input" /><div class="font_size_slider" min="1" max="'+max_width+'" value="0"></div></div>\
				<div><label>'+idcard_builder.height+'</label><input type="text" value="0" class="height slider_input" /><div class="font_size_slider" min="1" max="'+max_height+'" value="0"></div></div>\
				</div>\
				<div class="controls"><ul>';

			
			element += '<li><label>'+idcard_builder.border_radius+'</label><input type="text" value="0" class="border_radius slider_input"><div class="font_size_slider" min="1" max="100" value="0"></div></li>';
			element +='</ul></div><a class="button-primary add_userimage">'+idcard_builder.add_image+'</a><div class="close_element dashicons dashicons-no"></div>\
				</div></div></div>';
	 		
	 		$('.idcard_builder').append(element);

			$('.idcard_builder').trigger('adding');
		});

		$('.user_controls').on('click',function(){
			max_width = $('.idcard_builder_main').width();
			max_height = $('.idcard_builder_main').height();

			$('.popup_element_wrapper').remove();
			let element = '<div class="popup_element_wrapper"><div class="popup_element new">\
				<div class="left_block"><select><option value="[display_name]">'+window.idcard_builder.display_name+'</option><option value="[email_id]">'+window.idcard_builder.email_id+'</option><option value="[profile_image]">'+window.idcard_builder.profile_image+'</option><option value="[bar_code]">'+window.idcard_builder.bar_code+'</option>';
				window.idcard_builder.user_fields.map(function(field){
					element +='<option value="[field_'+field.id+']">'+field.name+'</option>';
				});
				element +='</select></div>\
				<div class="right_block"><input class="top" placeholder="'+idcard_builder.top_margin+'" />\
				<input class="left" placeholder="'+idcard_builder.left_margin+'" />\
				<div><label>'+idcard_builder.width+'</label><input type="text" value="0" class="width slider_input" /><div class="font_size_slider" min="1" max="'+max_width+'" value="0"></div></div>\
				<div><label>'+idcard_builder.height+'</label><input type="text" value="0" class="height slider_input" /><div class="font_size_slider" min="1" max="'+max_height+'" value="0"></div></div>\
				</div>\
				<div class="controls"><ul>';
			element += '<li><label>'+idcard_builder.font_size+'</label><input type="text" value="14" class="font_size slider_input"><div class="font_size_slider" min="1" max="100" value="14"></div></li>';
			element += '<li><label>'+idcard_builder.font_color+'</label><input type="text" value="#222222" class="font_color"></li>';
			element += '<li><label>'+idcard_builder.font_style+'</label><select class="font_style"><option value="none">None</option><option value="underline">Underline</option><option value="italics">Italics</option></select></li>';
			element += '<li><label>'+idcard_builder.font_family+'</label><select class="font_family">';
			font_list.map(function(font){
				element += '<option value="'+font.value+'">'+font.label+'</option>';
			});
			element += '</select></li>';
			element +='</ul></div><a class="button-primary add_field">'+idcard_builder.add_text+'</a><div class="close_element dashicons dashicons-no"></div></div></div></div>';
			$('.idcard_builder').append(element);
			$('.idcard_builder').trigger('adding');
		});
		$('.idcard_builder').on('adding',function(){
			
			startFunctions();
			

			$('.add_text').on('click',function(){
				let value = $(this).parent().find('textarea').val();
				let top = $(this).parent().find('.top').val();
				let left = $(this).parent().find('.left').val();
				let w = $(this).parent().find('.width').val();
				let h = $(this).parent().find('.height').val();
				let size = $(this).parent().find('.font_size').val();
				let color = $(this).parent().find('.font_color').val();
				let style = $(this).parent().find('.font_style').val();
				let family = $(this).parent().find('.font_family').val();
				let html = '<div class="inline_text_element" data-id="'+idcard_json.length+'" style="position:absolute;top:'+top+'px;left:'+left+'px;width:'+w+'px;height:'+h+'px;font-size:'+size+'px;color:'+color+';font-family:'+getFamily(family)+';text-decoration:'+style+';">'+value+'</div>';
				idcard_json.push({
					'type':'text',
					'top':top,
					'left':left,
					'width':w,
					'height':h,
					'size':size,
					'color':color,
					'family':family,
					'style':style,
					'value':value
				});
				localStorage.setItem('saved_idcard',JSON.stringify(idcard_json));
				$('.idcard_builder_main').append(html);
				$('.popup_element_wrapper').remove();

				$('.idcard_builder').trigger('ready');
			});

			$('.add_field').on('click',function(){
				let value = $(this).parent().find('select').val();
				let top = $(this).parent().find('.top').val();
				let left = $(this).parent().find('.left').val();
				let w = $(this).parent().find('.width').val();
				let h = $(this).parent().find('.height').val();
				let size = $(this).parent().find('.font_size').val();
				let color = $(this).parent().find('.font_color').val();
				let style = $(this).parent().find('.font_style').val();
				let family = $(this).parent().find('.font_family').val();
				let html = '<div class="inline_text_element '+value.replace(/[^\w ]/g, '')+'" data-id="'+idcard_json.length+'" style="position:absolute;top:'+top+'px;left:'+left+'px;width:'+w+'px;height:'+h+'px;font-size:'+size+'px;color:'+color+';font-family:'+getFamily(family)+';text-decoration:'+style+';">'+value+'</div>';
				idcard_json.push({
					'type':'text',
					'top':top,
					'left':left,
					'width':w,
					'height':h,
					'size':size,
					'color':color,
					'family':family,
					'style':style,
					'value':value
				});
				localStorage.setItem('saved_idcard',JSON.stringify(idcard_json));
				$('.idcard_builder_main').append(html);
				$('.popup_element_wrapper').remove();

				$('.idcard_builder').trigger('ready');
			});
			$('.add_image').on('click',function(){
				let value = $(this).parent().find('.image_path').val();
				let top = $(this).parent().find('.top').val();
				let left = $(this).parent().find('.left').val();
				let w = $(this).parent().find('.width').val();
				let h = $(this).parent().find('.height').val();
				let radius = $(this).parent().find('.border_radius').val();
				let html = '<div class="inline_image_element" data-id="'+idcard_json.length+'" style="position:absolute;top:'+top+'px;left:'+left+'px;'+((parseInt(w))?'width:'+w+'px':'')+';'+(parseInt(h)?'height:'+h+'px':'')+';border-radius:'+radius+'px;"><img src="'+value+'" /></div>';
				idcard_json.push({
					'type':'image',
					'top':top,
					'left':left,
					'width':w,
					'height':h,
					'radius':radius,
					'value':value
				});
				localStorage.setItem('saved_idcard',JSON.stringify(idcard_json));
				$('.idcard_builder_main').append(html);
				$('.popup_element_wrapper').remove();
				$('.idcard_builder').trigger('ready');
			});


		});

		$('.idcard_builder').on('editing',function(){

			startFunctions();			

			$('.edit_text').on('click',function(){

				let value = $(this).parent().find('textarea').val();
				let top = $(this).parent().find('.top').val();
				let left = $(this).parent().find('.left').val();
				let w = $(this).parent().find('.width').val();
				let h = $(this).parent().find('.height').val();

				let size = $(this).parent().find('.font_size').val();
				let color = $(this).parent().find('.font_color').val();
				let style = $(this).parent().find('.font_style').val();
				let family = $(this).parent().find('.font_family').val();

				let id = $(this).parent().attr('data-id');

				$('.inline_text_element[data-id="'+id+'"]').css('top',top+'px');
				$('.inline_text_element[data-id="'+id+'"]').css('left',left+'px');
				$('.inline_text_element[data-id="'+id+'"]').css('width',w+'px');
				$('.inline_text_element[data-id="'+id+'"]').css('height',h+'px');

				$('.inline_text_element[data-id="'+id+'"]').css('font-size',size+'px');
				$('.inline_text_element[data-id="'+id+'"]').css('color',color);
				$('.inline_text_element[data-id="'+id+'"]').css('text-decoration',style);
				$('.inline_text_element[data-id="'+id+'"]').css('font-family',getFamily(family));

				$('.inline_text_element[data-id="'+id+'"]').html(value);
				idcard_json[parseInt(id,10)]={
					'type':'text',
					'top':top,
					'left':left,
					'width':w,
					'height':h,
					'size':size,
					'color':color,
					'family':family,
					'style':style,
					'value':value
				};

				localStorage.setItem('saved_idcard',JSON.stringify(idcard_json));
				$('.popup_element_wrapper').remove();

				$('.idcard_builder').trigger('ready');
			});

			$('.edit_image').on('click',function(){
				let value = $(this).parent().find('.image_path').val();
				let top = $(this).parent().find('.top').val();
				let left = $(this).parent().find('.left').val();
				let w = $(this).parent().find('.width').val();
				let h = $(this).parent().find('.height').val();

				let radius = $(this).parent().find('.border_radius').val();
				

				let id = $(this).parent().attr('data-id');

				$('.inline_image_element[data-id="'+id+'"]').css('top',top+'px');
				$('.inline_image_element[data-id="'+id+'"]').css('left',left+'px');
				if(w){
					$('.inline_image_element[data-id="'+id+'"]').css('width',w+'px');	
				}
				if(h){
					$('.inline_image_element[data-id="'+id+'"]').css('height',h+'px');
				}
				
				

				$('.inline_image_element[data-id="'+id+'"]').find('img').attr('src',value);
				idcard_json[parseInt(id,10)]={
					'type':'image',
					'top':top,
					'left':left,
					'width':w,
					'height':h,
					'radius':radius,
					'value':value
				};
				localStorage.setItem('saved_idcard',JSON.stringify(idcard_json));
				$('.popup_element_wrapper').remove();

				$('.idcard_builder').trigger('ready');
			});

			$('.remove_image,.remove_text').on('click',function(){
				let id = parseInt($(this).parent().attr('data-id'),10);
				idcard_json.splice(id,1);
				localStorage.setItem('saved_idcard',JSON.stringify(idcard_json));
				$('.inline_text_element[data-id="'+id+'"]').remove();
				$('.inline_image_element[data-id="'+id+'"]').remove();
				$('.popup_element_wrapper').remove();
			});
		});



		$('.idcard_builder').on('init',function(){
			$('.restore_element').on('click',function(){
				idcard_json = JSON.parse(localStorage.getItem('saved_idcard'));
				sync_idcard_json();
			});

			sync_idcard_json();
		});

		$('.idcard_builder').on('ready',function(){

			$( ".inline_text_element,.inline_image_element" ).draggable({ 
				containment: ".idcard_builder_main", 
				scroll: false ,
				drag: function() {
					var offset = $(this).position({within:'.idcard_builder_main'});
			        var xPos = offset.left;
			        var yPos = offset.top;
			        $(this).css('left',offset.left);
			        $(this).css('top',offset.top);
			        idcard_json[parseInt($(this).attr('data-id'))].left=offset.left;
			        idcard_json[parseInt($(this).attr('data-id'))].top=offset.top;
			        $('.popup_element[data-id="'+parseInt($(this).attr('data-id'))+'"] .top').val(offset.top);
			        $('.popup_element[data-id="'+parseInt($(this).attr('data-id'))+'"] .left').val(offset.left);
				}
			});


			$('.inline_text_element').on('click',function(){
				$('.popup_element_wrapper').remove();
				let id = parseInt($(this).attr('data-id'));
				console.log(id);
				let element = '<div class="popup_element_wrapper">\
				<div class="popup_element" data-id="'+id+'">\
				<div class="left_block"><textarea>'+idcard_json[id].value+'</textarea></div>\
				<div class="right_block"><input class="top" placeholder="'+idcard_builder.top_margin+'" value="'+idcard_json[id].top+'" />\
				<input class="left" placeholder="'+idcard_builder.left_margin+'" value="'+idcard_json[id].left+'" />\
				<div><label>'+idcard_builder.width+'</label><input type="text" value="'+idcard_json[id].width+'" class="width slider_input"><div class="font_size_slider" min="1" max="800" value="'+idcard_json[id].width+'"></div></div>\
				<div><label>'+idcard_builder.height+'</label><input type="text" value="'+idcard_json[id].height+'" class="height slider_input"><div class="font_size_slider" min="1" max="800" value="'+idcard_json[id].height+'"></div></div>\
				</div>\
				<div class="controls"><ul>';

				element += '<li><label>'+idcard_builder.font_size+'</label><input type="text" value="'+idcard_json[id].size+'" class="font_size slider_input"><div class="font_size_slider" min="1" max="100" value="'+idcard_json[id].size+'"></div></li>';
				element += '<li><label>'+idcard_builder.font_color+'</label><input type="text" value="'+idcard_json[id].color+'" class="font_color"></li>';
				element += '<li><label>'+idcard_builder.font_style+'</label><select class="font_style"><option value="none">None</option><option value="underline" '+((idcard_json[id].style === 'underline')?'selected':'')+'>Underline</option><option value="italics" '+((idcard_json[id].style === 'italics')?'selected':'')+'>Italics</option></select></li>';
				element += '<li><label>'+idcard_builder.font_family+'</label><select class="font_family">';
				font_list.map(function(font){
					element += '<option value="'+font.value+'" '+((idcard_json[id].family === font.value)?'selected':'')+'>'+font.label+'</option>';
				});
				element += '</select></li>';

				element +='</ul></div><a class="button-primary edit_text">'+idcard_builder.edit_text+'</a><a class="button remove_text">'+idcard_builder.remove+'</a><div class="close_element dashicons dashicons-no"></div></div></div></div>';
			
				$('.idcard_builder').append(element);
				$('.idcard_builder').trigger('editing');
			});

			$('.inline_image_element').on('click',function(){
				$('.popup_element_wrapper').remove();
				let id = $(this).attr('data-id');

				let element = '<div class="popup_element_wrapper"><div class="popup_element" data-id="'+id+'">\
				<div class="left_block"><img src="'+idcard_json[id].value+'" /><a class="upload_image">'+idcard_builder.upload_image+'</a><input type="hidden" value="'+idcard_json[id].value+'" class="image_path" /></div>\
				<div class="right_block"><input class="top" placeholder="'+idcard_builder.top_margin+'" value="'+idcard_json[id].top+'" />\
					<input class="left" placeholder="'+idcard_builder.left_margin+'" value="'+idcard_json[id].left+'" />\
					<div><label>'+idcard_builder.width+'</label><input type="text" value="'+idcard_json[id].width+'" class="width slider_input"><div class="font_size_slider" min="1" max="800" value="'+idcard_json[id].width+'"></div></div>\
					<div><label>'+idcard_builder.height+'</label><input type="text" value="'+idcard_json[id].height+'" class="height slider_input"><div class="font_size_slider" min="1" max="800" value="'+idcard_json[id].height+'"></div></div>\
				</div>\
				<div class="controls"><ul>';

				element += '<li><label>'+idcard_builder.border_radius+'</label><input type="text" value="'+idcard_json[id].radius+'" class="border_radius slider_input"><div class="font_size_slider" min="1" max="100" value="'+idcard_json[id].radius+'"></div></li>';
				element +='</ul></div><a class="button-primary edit_image">'+idcard_builder.edit_image+'</a><a class="button remove_image">'+idcard_builder.remove+'</a><div class="close_element dashicons dashicons-no"></div>\
					</div></div></div>';

				
				$('.idcard_builder').append(element);
				$('.idcard_builder').trigger('editing');
			});
		});
});



var sync_idcard_json = function(){
	
	if(typeof window.idcard_builder.idcard_json !== "undefined" && window.idcard_builder.idcard_json.length){
		
		let x =  new Promise(function(resolve){

				window.idcard_builder.idcard_json.map(function(item,index){

					if(item.type == "text"){
						
						if($('.inline_text_element[data-id="'+index+'"]').length){
							$('.inline_text_element[data-id="'+index+'"]').css('top',item.top+'px');
							$('.inline_text_element[data-id="'+index+'"]').css('left',item.left+'px');
							$('.inline_text_element[data-id="'+index+'"]').css('width',item.width+'px');
							$('.inline_text_element[data-id="'+index+'"]').css('height',item.height+'px');

							$('.inline_text_element[data-id="'+index+'"]').css('font-size',item.size+'px');
							$('.inline_text_element[data-id="'+index+'"]').css('color',item.color);
							$('.inline_text_element[data-id="'+index+'"]').css('text-decoration',item.style);
							$('.inline_text_element[data-id="'+index+'"]').css('font-family',item.family);

							$('.inline_text_element[data-id="'+index+'"]').html(item.value);
							console.log(item.value +' <==> '+ item.value.indexOf('['));
							if(item.value.indexOf('[') !== false){
								$('.inline_text_element[data-id="'+index+'"]').addClass(value);
							}
							
						}else{
							let html = '<div class="inline_text_element" data-id="'+index+'" style="position:absolute;top:'+item.top+'px;left:'+item.left+'px;width:'+item.width+'px;height:'+item.height+'px;font-size:'+item.size+'px;color:'+item.color+';text-decoration:'+item.style+';font-family:'+item.family+'">'+item.value+'</div>';
							$('.idcard_builder_main').append(html);

							console.log(item.value +' <==> '+ item.value.indexOf('['));
							if(item.value.indexOf('[') !== false){
								$('.inline_text_element[data-id="'+index+'"]').addClass(item.value.replace(/[^\w ]/g, ''));
							}
						}
					}


					if(item.type == "image"){
						if($('.inline_image_element[data-id="'+index+'"]').length){
							
							$('.inline_image_element[data-id="'+index+'"]').css('top',item.top+'px');
							$('.inline_image_element[data-id="'+index+'"]').css('left',item.left+'px');
							$('.inline_image_element[data-id="'+index+'"]').css('width',item.width+'px');
							$('.inline_image_element[data-id="'+index+'"]').css('height',item.height+'px');
							$('.inline_image_element[data-id="'+index+'"]').css('border-radius',item.radius+'px');
							$('.inline_image_element[data-id="'+index+'"]').find('img').attr('src',item.value);
						}else{
							let html = '<div class="inline_image_element" data-id="'+index+'" style="position:absolute;top:'+item.top+'px;left:'+item.left+'px;width:'+item.width+'px;height:'+item.height+'px;"><img src="'+item.value+'" /></div>';
							$('.idcard_builder_main').append(html);
						}
					}

					if((index +1) === window.idcard_builder.idcard_json.length){
						resolve();
					}
				});
			}).then(function(){
				setTimeout(function(){
					$('.idcard_builder').trigger('ready');	
				},300);
				
			});
	}
};

var getFamily = function(family){

	switch(family){
		case 'helvetica':
		case 'helveticaB':
			return 'Helvetica, sans-serif';
		break;
		case 'courieB':
		case 'courier':
			return 'Courier monospace';
		break;
		default:
			return '"Times New Roman", Times, serif';
		break;
	}
}

var uploadImage = function(){
	var media_uploader;
	$('.upload_image').on('click',function(){
		var button = jQuery( this );
	    if ( media_uploader ) {
	      media_uploader.open();
	      return;
	    }
	    // Create the media uploader.
	    media_uploader = wp.media.frames.media_uploader = wp.media({
	        // Tell the modal to show only images.
	        library: {
	            type: 'image',
	            query: false
	        },
	        multiple: false,
	        frame:    'post',
	        state: 'insert',
	    });

	    // Create a callback when the uploader is called
	    media_uploader.on( 'insert', function(selection) {
	        	
        	

            var state = media_uploader.state();
		    selection = selection || state.get('selection');

		    if (! selection) return;

		    var attachment = selection.first();
    		var display = state.display(attachment).toJSON(); 
    		var imgurl = attachment.attributes.sizes[display.size].url;

            button.parent().find('img').attr('src',imgurl);
           	button.parent().find('input.image_path').val(imgurl);
           	$('.inline_image_element[data-id="'+button.parent().parent().attr('data-id')+'"] img').attr('src',imgurl);

	    });
	    // Open the uploader
	    media_uploader.open();
	});
};


var startFunctions = function(){
	uploadImage();

	let object = null;
	if(!$('.popup_element').hasClass('new')){
		object = $('.inline_text_element[data-id="'+parseInt($('.popup_element').attr('data-id'),10)+'"]');
		if(!object.length){
			object = $('.inline_image_element[data-id="'+parseInt($('.popup_element').attr('data-id'),10)+'"]');
		}
	}

	$('textarea').on('input propertychange',function(){
		if(object){
			object.html($(this).val());
		}
	});
	$('input[type="hidden"]').on('change',function(){
		if(object){
			object.find(image).attr('src',$(this).val());
		}
	});
	$('.font_size_slider').each(function(){
		let $this = $(this);

		$(this).slider({
			value:$this.parent().find('.slider_input').val(),
			step:1,
			min:parseInt($this.attr('min'),10),
			max:parseInt($this.attr('max'),10),
			slide: function(event, ui) {
		        $this.parent().find('.slider_input').val(ui.value);
		        
		        if(object){
		        	if($this.parent().find('.font_size').length){
		        		object.css('font-size',ui.value+'px');
		        	}
		        	if($this.parent().find('.width').length){
		        		console.log('width');
		        		object.css('width',ui.value+'px');
		        	}
		        	if($this.parent().find('.height').length){
		        		object.css('height',ui.value+'px');
		        	}
		        	if($this.parent().find('.border_radius').length){
		        		object.css('border-radius',ui.value+'px');
		        	}
		        }
		    }
		});
	});

	$('.font_color').iris({
        width: 178,
        hide: true,
        change: function(event, ui) {
        	if(object){
        		object.css( 'color', ui.color.toString());
        	}
	    }
    });

	$('.font_style').on('change',function(){
		if(object){
			object.css('text-decoration',$(this).val());
		}
	});
	$('.font_family').on('change',function(){
		if(object){
			object.css('font-family',$(this).val());
		}
	});
    $('.font_color').on('click',function(){
    	if($(this).hasClass('active')){
    		$(this).removeClass('active');
    		$(this).iris('hide');	
    	}else{
    		$(this).addClass('active');
    		$(this).iris('show');	
    	}
    	
    });

	$('.close_element').on('click',function(){
		$('.popup_element_wrapper').remove();
	});
}

});