<?php
/**
 * WPLMS Attendance Init
 *
 * @author 		VibeThemes
 * @category 	Admin
 * @package 	Wplms-attendace/Includes
 * @version     1.0
 */


function wplms_attendance_get_instructor_records($args,$count=false){

    global $wpdb,$bp;
	//args
	/*
	$args = array(
		'course_ids'=>array(), // Fetch records from these course ids
		'user_ids'=>array(), //fetch records of these stuent ids,
		'offset'=>0,
		'per_page'=>20
	);
	*/

	extract($args);

	if(!apply_filters('wplms_attendance_get_instructor_records_access',current_user_can('edit_posts')))
		return;

	$course_attendance_query_string = '';
	if(empty($course_ids)){

        
        $query = apply_filters('wplms_dashboard_courses_instructors',$wpdb->prepare("
                  SELECT DISTINCT posts.ID as course_id
                    FROM {$wpdb->posts} AS posts
                    WHERE   posts.post_type   = 'course'
                    AND   posts.post_author   = %d
                    ORDER BY posts.post_modified_gmt DESC
                    LIMIT 0,%d
                ",$user_id,$max),$user_id,$instance);

        $instructor_courses=$wpdb->get_results($query,ARRAY_A);
        $course_ids = array();
        if(!empty($instructor_courses)){

            foreach($instructor_courses as $course_id){
            	$course_ids[]=$course_id->course_id;
            }
        }
    }


    if(!empty($course_ids) && count($course_ids) > 1){

        foreach($course_ids as $course_id){
        	if(!empty($course_attendance_query_string)){
        		$course_attendance_query_string .= ' || m1.meta_key = ';
        	}
            $course_attendance_query_string  .= 'wplms_course_attendance_'.$course_id;
        }
    }else{
        $course_attendance_query_string = 'wplms_course_attendance_'.$course_ids[0];
    }

    $user_ids_query_string ='';
	if(!empty($user_ids)){
		$user_ids_query_string = ' AND a.user_id IN ('.implode(',', $user_ids).')';
	}

    $fields = 'm.activity_id as activity_id,a.user_id as user_id,a.item_id as course_id, m.meta_value as present,  m1.meta_value as attendance_timestamp';
    if($count){
        $fields = 'count(*)';
    }

	$query = "
        SELECT $fields
        FROM {$bp->activity->table_name_meta} as m 
        INNER JOIN {$bp->activity->table_name_meta} as m1 
        ON m.activity_id = m1.activity_id
        INNER JOIN {$bp->activity->table_name} as a
        ON m.activity_id = a.id
        WHERE m.meta_key = 'present'
        AND m1.meta_key = $course_attendance_query_string
        AND a.type = 'wplms_attendance'
        $user_ids_query_string
        LIMIT $offset,$per_page
    ";


    $attendances = $wpdb->get_results($query,ARRAY_A);


	return $attendances;
}


function wplms_attendance_get_student_records($args,$count=false){
    global $wpdb,$bp;
	//args
	/*
	$args = array(
		'course_ids'=>array(), // Fetch records from these course ids
		'user_id'=>integer, //fetch records of these stuent ids,
        'date_start'=>0,
        'date_end'=>0,
		'offset'=>0,
		'per_page'=>20,
        'activity_id_not_in'=>array(),
	);
	*/

	extract($args);

	if(!apply_filters('wplms_attendance_get_student_records_access',current_user_can('read')))
		return;


	if(empty($course_ids)){
        $course_ids = bp_course_get_user_courses($user_id);
        $course_ids = array_unique($course_ids);
    }

    if(!empty($course_ids) && count($course_ids) > 1){

        foreach($course_ids as $course_id){
        	if(!empty($course_attendance_query_string)){
        		$course_attendance_query_string .= ',';
        	}
            $course_attendance_query_string  .= "'wplms_course_attendance_".$course_id."'";

        }
    }else{
        $course_attendance_query_string .= "'wplms_course_attendance_".$course_ids[0]."'";
    }

    $user_ids_query_string ='';
	if(!empty($user_id)){
		$user_ids_query_string = 'AND a.user_id = '.$user_id;
	}

    if(!empty($activity_id_not_in)){
        $activity_id_not_in = 'AND m.activity_id NOT IN ('.implode(',', $activity_id_not_in).')';
    }else{
       $activity_id_not_in = ''; 
    }
    
    
    $fields = ' m.activity_id as activity_id,a.user_id as user_id,a.item_id as course_id, m.meta_value as present,  m1.meta_value as attendance_timestamp';
    if($count){
        $fields = 'count(*)';
    }

    $date_string = '';
    if(!empty($date_start) && !empty($date_end)){
        $date_string = 'AND m1.meta_value >= '.$date_start.' AND m1.meta_value <= '.$date_end;
    }

	$query = "
        SELECT $fields
        FROM {$bp->activity->table_name_meta} as m 
        LEFT JOIN {$bp->activity->table_name_meta} as m1 
        ON m.activity_id = m1.activity_id
        LEFT JOIN {$bp->activity->table_name} as a
        ON m.activity_id = a.id
        WHERE m.meta_key = 'present'
        $activity_id_not_in
        AND m1.meta_key IN ($course_attendance_query_string)
        $date_string
        AND a.type = 'wplms_attendance'
        $user_ids_query_string
        ORDER BY m1.meta_value DESC, a.id DESC
        LIMIT $offset,$per_page
    ";
    //echo $query; die;
   
    if($count){
        $attendances = $wpdb->get_var($query);

    }else{
        $attendances = $wpdb->get_results($query,ARRAY_A);
    }


	    //[activity_id,present,attendance_timestamp,user_id,course_id];



	return $attendances;
}
    
function wplms_attendance_widget_enqueue_scripts($type){

    // wp_enqueue_script( 'wplms-attendance-js', 'http://localhost:3000/static/js/bundle.js',array(),2,true);
    // wp_enqueue_script( 'wplms-attendance-student-js1', 'http://localhost:3000/static/js/0.chunk.js',array(),2,true);
    // wp_enqueue_script( 'wplms-attendance-student-js2', 'http://localhost:3000/static/js/1.chunk.js',array(),2,true);
    // wp_enqueue_script( 'wplms-attendance-student-js3', 'http://localhost:3000/static/js/main.0367dd32cf890a55d9f2.hot-update.js',array(),2,true);
    // wp_enqueue_script( 'wplms-attendance-student-js4', 'http://localhost:3000/static/js/main.chunk.js',array(),2,true);
    
    wp_enqueue_style( 'wplms-attendance-css', plugins_url('../assets/css/datepicker.css',__FILE__),array(),WPLMS_ATTENDANCE_DB_VERSION);
    wp_enqueue_script( 'wplms-attendance-js', plugins_url('../assets/js/attendance_widget.js',__FILE__),array(),WPLMS_ATTENDANCE_DB_VERSION,true);
    $wplms_attendance_student = array(
        'api_url'=> get_rest_url(null,BP_COURSE_API_NAMESPACE.'/attendance/'),
        'user_id'=>apply_filters('wplms_dashboard_student_id',get_current_user_id()),    
        'type'=> $type,
        'security'=> urlencode(vibe_get_option('security_key')),
        'timestamp'=>time(),
        'per_page'=>10,
        'date_format'=>get_option('date_format'),
        'time_format'=>get_option('time_format'),
        'translations'=>array(
            'date'=>_x('Date','api call','wplms-attendance'),
            'course'=>_x('Course','api call','wplms-attendance'),
            'attendance'=>_x('Attendance','api call','wplms-attendance'),
            'present'=>_x('Present','api call','wplms-attendance'),
            'absent'=>_x('Absent','api call','wplms-attendance'),
            'showing'=>_x('Showing','api call','wplms-attendance'),
            'of'=>_x('of','api call','wplms-attendance'),
            'go'=>_x('Go','api call','wplms-attendance'),
            'student'=>_x('Student','api call','wplms-attendance'),
            'select_course'=>_x('Select a course','api call','wplms-attendance'),
            'no_records'=>_x('No records found','api call','wplms-attendance'),
            'select_student'=>_x('Select a student','api call','wplms-attendance'),
            'search_student'=>_x('Search student','api call','wplms-attendance'),
        ),
    );
    wp_localize_script( 'wplms-attendance-js', 'wplms_attendance', $wplms_attendance_student );
}

    /* === Ripul === */
