<?php
/**
 * WPLMS Attendance Card Init
 *
 * @author 		VibeThemes
 * @category 	Admin
 * @package 	Wplms-Attendance/Includes
 * @version     1.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

if ( ! defined( 'IDCARD_OPTION' ) ) {
	define( 'IDCARD_OPTION','wplms_attendance_idcard' );
}
if ( ! defined( 'IDCARD_SIZE_OPTION' ) ) {
	define( 'IDCARD_SIZE_OPTION','wplms_attendance_idcard_size' );
}

class Wplms_Attendance_card_Init{

	public static $instance;
    public static function init(){

        if ( is_null( self::$instance ) )
            self::$instance = new Wplms_Attendance_card_Init();
        return self::$instance;
        
    }

	private function __construct(){
        
		add_action('lms_general_settings',array($this,'student_id_card_settings'),20);
		add_action( 'admin_enqueue_scripts', array($this,'pdf_builder_scripts'), 10, 1 );
		add_action('wp_ajax_save_idcard_builder',array($this,'save_idcard_builder'));
        add_Action('wp_ajax_remove_idcard_builder',array($this,'remove_idcard_builder'));
        add_filter('wplms_attendance_idcard_vars',array($this,'resolve_params'));
    }

    function resolve_params($text){

        

        return $text;
    }

	function certificate_builder(){

		?>
		<div class="pdf_builder">
			<div class="pdf_elements">
				<div class="pdf_element text_element">
					<?php _e('Raw Text','wplms-attendance'); ?>
				</div>
				<div class="pdf_element image_element">
					<?php _e('Image','wplms-attendance'); ?>
				</div>
				<div class="pdf_element save_element button-primary">
					<?php _e('Save','wplms-attendance'); ?>
				</div>
			</div>
			<?php wp_nonce_field('save_pdf_builder','save_pdf_builder'); ?>
			<div class="pdf_builder_main">
			</div>
		</div>
		<?php

		global $post;
		$certificate_json = get_post_meta($post->ID,'certificate_json',true);
		if(!empty($certificate_json)){
			$cj = json_decode($certificate_json);
			if(!empty($cj)){
			?>
			<script>
				var certificate_json = <?php print_r($certificate_json); ?>;
			</script>
			<?php
			}
		}
		?>
		<style>
			.pdf_builder{font-size:<?php echo vibe_get_customizer('body_font_size'); ?>px !important;}
			.pdf_builder h1{font-size:<?php echo vibe_get_customizer('h1_size'); ?>px !important;padding:0 !important;}.pdf_builder h2{font-size:<?php echo vibe_get_customizer('h1_size'); ?>px !important;padding:0 !important;}
			.pdf_builder h3{font-size:<?php echo vibe_get_customizer('h3_size'); ?>px !important;padding:0 !important;}.pdf_builder h4{font-size:<?php echo vibe_get_customizer('h4_size'); ?>px !important;padding:0 !important;}
			.pdf_builder h5{font-size:<?php echo vibe_get_customizer('h5_size'); ?>px !important;}.pdf_builder h6{font-size:<?php echo vibe_get_customizer('h6_size'); ?>px !important;padding:0 !important;}
			</style>
			<script>
				
				jQuery(document).ready(function($){
					let left = $('.pdf_builder_main').offset().left;
					let top = $('.pdf_builder_main').offset().top -  $(window).scrollTop();
					jQuery(window).scroll(function(){
						left = $('.pdf_builder_main').offset().left;
						top = $('.pdf_builder_main').offset().top -  $(window).scrollTop();
					});
					$('.pdf_builder_main').append('<div class="pdf_builder_x" style="height:1px;background:red;width:100%;top:0px;left:0;position:absolute;"></div><div class="pdf_builder_y" style="width:1px;background:red;height:100%;top:0;left:0px;position:absolute;"></div>');
					$('.pdf_builder_main').on('mousemove',function(event){

						let x = event.clientY - top;
						let y = event.clientX - left;
						$('.pdf_builder_main .pdf_builder_x').css('top',x+'px');
						$('.pdf_builder_main .pdf_builder_y').css('left',y+'px');
					});
				});
			</script>
		<?php
	}

	function pdf_builder_scripts($hook){

        if ( in_array( $hook, array( 'lms_page_lms-settings' ) ) ){


                wp_enqueue_style( 'idcard_builder_css', plugins_url( '../assets/css/idcard_builder.css' , __FILE__ ),array(),rand(1,999));
                wp_enqueue_script( 'idcard_builder_script', plugins_url( '../assets/js/idcard_builder.js' , __FILE__ ),array('jquery','jquery-ui-core','jquery-ui-draggable','jquery-ui-slider'),rand(1,9999));

                $idcard = get_option(IDCARD_OPTION);
                $idcard_size = get_option(IDCARD_SIZE_OPTION);
                //print_r($idcard_size); die;
                $idcard_size = json_decode($idcard_size,true);
                if(empty($idcard_size)){
                	$idcard_size = array(
                		'width'=>768,
                		'height'=>460,
                        'background'=>'#fff'
                	);
                }
                global $post;
                $translations = array(
                	'controls'=>array(
                		array(
                			'label'=>_x('IdCard Width','idcard builder','wplms-attendance'),
                			'key'=>'width',
                			'type'=>'number',
                			'value'=>$idcard_size['width']
                		),
                		array(
                			'label'=>_x('IdCard Height','idcard builder','wplms-attendance'),
                			'key'=>'height',
                			'type'=>'number',
                			'value'=>$idcard_size['height']
                		),
                		array(
                			'label'=>_x('IdCard Bg Color/Image','idcard builder','wplms-attendance'),
                			'key'=>'background',
                			'type'=>'text',
                			'value'=>$idcard_size['background']
                		),
                	),
                	'security'=>wp_create_nonce('security'),
                	'idcard_json' => $idcard,
                	'idcard_size_settings' => $idcard_size,
                	'text'=>_x('Text','idcard builder','wplms-attendance'),
                	'image'=>_x('Image','idcard builder','wplms-attendance'),
                	'save'=>_x('Save','idcard builder','wplms-attendance'),
                	'default_text'=>_x('Default Text','idcard builder','wplms-attendance'),
                	'top_margin'=>_x('Top Margin','idcard builder','wplms-attendance'),
                	'left_margin'=>_x('Left Margin','idcard builder','wplms-attendance'),
                	'width'=>_x('Width','idcard builder','wplms-attendance'),
                	'height'=>_x('Height','idcard builder','wplms-attendance'),
                	'add_text'=>_x('Add Text','idcard builder','wplms-attendance'),
                	'edit_text'=>_x('Edit text','idcard builder','wplms-attendance'),
                	'default_image_url'=> plugins_url('../assets/images/default.png',__FILE__),
                	'add_image'=>_x('Add Image','idcard builder','wplms-attendance'),
                	'edit_image'=>_x('Edit Image','idcard builder','wplms-attendance'),
                	'remove'=>_x('Remove','idcard builder','wplms-attendance'),
                	'restore'=>_x('Restore','idcard builder','wplms-attendance'),
                	'saving'=>_x('...saving','idcard builder','wplms-attendance'),
                	'font_size'=>_x('Font Size','idcard builder','wplms-attendance'),
                	'font_color'=>_x('Font Color','idcard builder','wplms-attendance'),
                	'font_family'=>_x('Font Family','idcard builder','wplms-attendance'),
                	'font_style'=>_x('Font Style','idcard builder','wplms-attendance'),
                	'upload_image'=>_x('Upload Image','idcard builder','wplms-attendance'),
                	'border_radius'=>_x('Border Radius','idcard builder','wplms-attendance'),
                	'border_width'=>_x('Border Width','idcard builder','wplms-attendance'),
                	'user_image'=>_x('User Controls','idcard builder','wplms-attendance'),
                	'user_controls'=>_x('User Controls','idcard builder','wplms-attendance'),
                    'display_name'=>__('Display Name','wplms-attendance'),
                    'email_id'=>__('Email Id','wplms-attendance'),
                    'profile_image'=>__('Profile Image','wplms-attendance'),
                    'bar_code'=>__('Bar code','wplms-attendance')
                );

                if(function_exists('bp_is_active') && bp_is_active('xprofile')){

                	global $wpdb,$bp;
                	$fields =$wpdb->get_results("Select * FROM {$bp->profile->table_name_fields}",ARRAY_A);
                    $new_fields = array();
                	if(!empty($fields)){

                        foreach($fields as $key => $field){
                            if(!in_array($field['type'],array('url','option'))){
                               $new_fields[]= $field;
                            }
                        }
                        

                		$translations['user_fields']=apply_filters('wplms_attendance_idcard_fields',(Array)$new_fields);	
                	}
                	
                }

                wp_localize_script( 'idcard_builder_script', 'idcard_builder', $translations );
            }
    
	}


    function remove_idcard_builder(){
        if ( !isset($_POST['security']) || !wp_verify_nonce($_POST['security'],'security') || !is_user_logged_in()){
         _e('Security check Failed. Contact Administrator.','wplms-attendance');
         die();
        }
        delete_option(IDCARD_OPTION);
        delete_option(IDCARD_SIZE_OPTION);

        die();
    }

	function save_idcard_builder(){
		if ( !isset($_POST['security']) || !wp_verify_nonce($_POST['security'],'security') || !is_user_logged_in()){
         _e('Security check Failed. Contact Administrator.','wplms-attendance');
         die();
      	}
      	update_option(IDCARD_OPTION,stripslashes($_POST['idcard_json']));
      	update_option(IDCARD_SIZE_OPTION,stripslashes($_POST['idcard_size_settings']));

      	die();
	}

	
	function student_id_card_settings ($settings){
		$settings[] = array(
								'label'=>__('Student Attendance Settings','wplms-attendance' ),
								'type'=> 'heading',
							);
		$settings[]	= array(
						'label' => __('Student ID Card','wplms-attendance'),
						'name' =>'student_id_card',
						'type' => 'checkbox',
						'desc' => sprintf(__('Set Student ID Card, %s Generate ID Card %s','wplms-attendance'),'<a class="generate_id_card button" id="idcard">','</a>'),
					);
		return $settings;
	}

    function attendance_generate_idcard($student_id){

        global $wpdb;
        $name = 'idcard_'.$student_id;
        $attachment_id = $wpdb->get_var("SELECT ID FROM {$wpdb->posts} WHERE post_type = 'attachment' AND post_author = $student_id AND post_name='$name'");

        if(!empty($attachment_id)){
            return wp_get_attachment_url($attachment_id);
        }

        $upload_dir = wp_upload_dir();
        $pdf_path = $upload_dir['path'].'/'.$name.'.pdf';

        
        $idcard = json_decode(get_option(IDCARD_OPTION),true);
        $this->idcard_size = json_decode(get_option(IDCARD_SIZE_OPTION),true);

        $orientation = apply_filters('wplms_attendance_idcard_orientation',PDF_PAGE_ORIENTATION);
        $pdf_unit = apply_filters('wplms_attendance_idcard_unit',PDF_UNIT);
        $pdf_page_format = apply_filters('wplms_attendance_idcard_format',PDF_PAGE_FORMAT);
        

                 
        if($this->idcard_size['width'] > $this->idcard_size['height'] ){
            $orientation = 'L';
        }

        if(!empty($this->idcard_size['background'])){
            // create new PDF document
            $pdf = new MYPDF($orientation, 'px', $pdf_page_format, true, 'UTF-8', false);
        }else{
            $pdf = new TCPDF($orientation, 'px', $pdf_page_format, true, 'UTF-8', false);
        }
        // set document information
        $pdf->SetCreator(get_bloginfo('name'));
        $pdf->SetAuthor(get_bloginfo('name'));
        $pdf->SetTitle($name);
        $pdf->SetDisplayMode('fullpage', 'SinglePage', 'UseNone');

        $pdf_args = apply_filters('wplms_attendance_idcard_args',array(
            'margin_left'=>0,
            'margin_top'=>0,
            'margin_right'=>0,
            'margin_bottom'=>0
        ));

        $pdf->setCellHeightRatio(1);
        // set margins
        $pdf->SetMargins($pdf_args['margin_left'],$pdf_args['margin_top'], $pdf_args['margin_right'],true);
        // add a page

        $pdf->AddPage($orientation, $pdf_unit);

        
        foreach($idcard as $eky=>$item){
            
            if($item['type'] == 'text'){
                
                if($item['color']){
                    list($r, $g, $b) = sscanf($item['color'], "#%02x%02x%02x");
                    $pdf->SetTextColor($r,$g,$b);
                }
                if($item['size']){
                    
                    if(strpos($item['family'], '.ttf') !== false){
                        //$fontfile, $type, $enc, $flags, $outpath, $platid, $encid, $addcbbox, $link
                        $font_args = apply_filters('wplms_attendance_idcard_font_args',array(
                            'type'=>'TrueType',
                            'enc'=>'ansi',
                            'flags'=>32
                        ),$item['family']);
                        $fontname = TCPDF_FONTS::addTTFfont($item['family'], $font_args['type'], $font_args['end'], $font_args['flags']);   
                        if($fontname != false){
                            $item['family']=$fontname;
                        }
                    }
                    
                    if(!$item['family']){
                        $item['family']='helvetica';
                    }

                    $pdf->SetFont ($item['family'], '', $item['size'] , '', 'default', true );  
                }
                

                $align = 'L';
                if(!empty($item['align'])){
                    if($item['align'] == 'right'){
                        $align= 'R';
                    }
                    if($item['align'] == 'center'){
                        $align= 'C';
                    }
                }
                
                
                if(strpos($item['value'], '[') !== false){
                    
                    if($item['value'] === '[profile_image]'){
                        $item['value'] = bp_core_fetch_avatar(array(
                                        'item_id' => $student_id,
                                        'object'  => 'user',
                                        'type'=>'full',
                                        'html'    => false
                                    ));
                    }
                    if($item['value'] === '[display_name]'){
                        $item['value'] = bp_core_get_user_displayname($student_id);
                    }
                }

                $item['value'] = apply_filters('wplms_attendance_idcard_vars',$item['value']);


                if(strpos($item['value'], 'http') !== false){
                    
                    if(strpos($item['value'], home_url()) !== false){
                        $item['value'] = str_replace(home_url().'/wp-content', WP_CONTENT_DIR, $item['value']);
                    }

                    $pdf->Image($item['value'], $item['left'], $item['top'], $item['width'], $item['height'], '', '', '', true, 300);

                }else{
                    $pdf->setXY($item['left'],$item['top']) ;
                    if($item['value'] == '[bar_code]'){
                        $style = array(
                            'position' => 'S',
                            'align' => 'C',
                            'stretch' => false,
                            'fitwidth' => true,
                            'cellfitalign' => '',
                            'border' => false,
                            'hpadding' => 'auto',
                            'vpadding' => 'auto',
                            'fgcolor' => hex2rgb($item['color']),
                            'bgcolor' => false, //array(255,255,255),
                            'text' => true,
                            'font' => 'helvetica',
                            'fontsize' => $item['size'],
                            'stretchtext' => 8
                        );
                        
                        $pdf->write1DBarcode('ID '.$student_id, 'C39', '', '', '', $item['height'], 0.4, $style, 'N');
                    }else{
                        $pdf->Cell($item['width'],$item['height'],$item['value'], 0, 1, $align, 0, '', 0, false, 'M', 'M');        
                    }
                }
            }

            if($item['type'] == 'image'){
                if($item['radius']){
                    $pdf->StartTransform();
                    $pdf->Circle($item['left'], $item['top'], $item['width'], $item['height'], 3, 0, 1, 'CNZ');
                }
                if(strpos($item['value'], home_url()) !== false){
                    $item['value'] = str_replace(home_url().'/wp-content', WP_CONTENT_DIR, $item['value']);
                }

                $pdf->Image($item['value'], $item['left'], $item['top'], $item['width'], $item['height'], '', '', '', true, 300);
                if($item['radius']){
                    $pdf->StopTransform();
                }
            }
        }



        global $wpdb;
        $old_attachment_id = $wpdb->get_var("SELECT ID FROM {$wpdb->posts} WHERE post_name LIKE '%sample_".get_post_field('post_name',$this->template_id)."%' AND post_type = 'attachment' ORDER BY ID DESC limit 0,1");

        if(is_numeric($old_attachment_id)){
            wp_delete_attachment( $old_attachment_id, true );
        }
        // add a page

        ob_start();
        $pdf->Output($pdf_path, 'F');
        ob_end_clean();
        global $wpdb;
        
        if(file_exists($pdf_path)){
            $filetype = wp_check_filetype( basename( $pdf_path ), null );

            $attachment = apply_filters('wplms_certificate_pdf_attachment',array(
                'guid'           => $wp_upload_dir['url'] . '/' . basename( $pdf_path ), 
                'post_mime_type' => $filetype['type'],
                'post_title'     => preg_replace( '/\.[^.]+$/', '', _x('Certificate for ','certificate title','wplms-certificates').'-'.$name ),
                'post_name'=>sanitize_title($name),
                'post_content'   => '',
                'post_author'=>$student_id,
                'post_status'    => 'inherit'
            ));

            $attachment_id = wp_insert_attachment($attachment,$pdf_path);
                        
            return wp_get_attachment_url($attachment_id);
        }
    }

}
Wplms_Attendance_card_Init::init();




function wplms_attendance_generate_idcard($student_id){

    require_once( trailingslashit( plugin_dir_path( __FILE__ ) ) . '../tcpdf/tcpdf.php' );

    class MYPDF extends TCPDF {

        //Page header
        public function Header() {
            // get the current page break margin
            $bMargin = $this->getBreakMargin();
            // get current auto-page-break mode
            $auto_page_break = $this->AutoPageBreak;
            // disable auto-page-break
            $this->SetAutoPageBreak(false, 0);
            // set bacground image
            $init = Wplms_Attendance_card_Init::init();
            
            

            if(strpos($init->idcard_size['background'], '#') !== false){
                $rgb = hex2rgb($init->idcard_size['background']);
                
                $this->Rect(0, 0, $init->idcard_size['width'], $init->idcard_size['height'], 
           'DF', "",  $rgb); 
            }else{
                $this->Image($init->idcard_size['background'], 0, 0, $init->idcard_size['width'], $init->idcard_size['height'], '', '', '', false, 300, '', false, false, 0);
            }

            // restore auto-page-break status
            $this->SetAutoPageBreak(0, 0);
            // set the starting point for the page content
            $this->setPageMark();
        }
    }
    $init = Wplms_Attendance_card_Init::init();
    return $init->attendance_generate_idcard($student_id);
}

if(!function_exists('hex2rgb')){
    function hex2rgb( $colour ) {
        if ( $colour[0] == '#' ) {
                $colour = substr( $colour, 1 );
        }
        if ( strlen( $colour ) == 6 ) {
                list( $r, $g, $b ) = array( $colour[0] . $colour[1], $colour[2] . $colour[3], $colour[4] . $colour[5] );
        } elseif ( strlen( $colour ) == 3 ) {
                list( $r, $g, $b ) = array( $colour[0] . $colour[0], $colour[1] . $colour[1], $colour[2] . $colour[2] );
        } else {
                return false;
        }
        $r = hexdec( $r );
        $g = hexdec( $g );
        $b = hexdec( $b );
        return array($r,$g,$b);
    }
}
