<?php 


/* To CHECK :
        DATE FORMAT
        To check unique entry created variable -- $check_last_recorded_date
        Need to add a action in attendance activity  -- attendance removed to make absent


*/

add_action( 'widgets_init', 'wplms_student_attendance_widget' );
function wplms_student_attendance_widget() {
    register_widget('wplms_student_attendance');
}

class wplms_student_attendance extends WP_Widget {

    protected static $did_script = false;
    /** constructor -- name this the same as the class above */
    function __construct() {
        $widget_ops = array( 'classname' => 'wplms_student_attendance', 'description' => __('Attendance for students', 'wplms-attendance') );
        $control_ops = array( 'width' => 300, 'height' => 350, 'id_base' => 'wplms_student_attendance' );
        parent::__construct( 'wplms_student_attendance', __(' DASHBOARD : My Attendance', 'wplms-attendance'), $widget_ops, $control_ops );

        add_action('wp_ajax_download_attendance',array($this,'wplms_download_attendance'));
        add_action('wp_ajax_get_student_data',array($this,'wplms_get_student_data'));
        add_action('wp_ajax_attendance_get_max_pages',array($this,'wplms_attendance_get_max_pages'));

        add_action('wp_enqueue_scripts',array($this,'enqueue_scripts'));
    
        add_filter('vibebp_member_dashboard_widgets',array($this,'add_custom_script'));


    }

    function add_custom_script($x){
        $x[] = 'wplms_student_attendance';
        return $x;
    }

    function enqueue_scripts(){

        if(!self::$did_script && is_active_widget(false, false, 'wplms_student_attendance', true)){
          
          $components = apply_filters('wplms_dashboard_widget_scripts',array('dashboard'));
            if(in_array($bp->current_component,$components)){ 
                wplms_attendance_widget_enqueue_scripts('student');
            }
        
          self::$did_script = true;
        } 

        

        
    }


    function widget( $args, $instance ) {

        extract( $args );

        wplms_attendance_widget_enqueue_scripts('student');

        $title = apply_filters('widget_title', $instance['title'] );
        $width = $instance['width'];
        
        if(empty($width)){
            $width = 'col-md-6';
        }

        global $bp;

        echo '<div class="'.$width.'">
        <div class="dash-widget">'.$before_widget;

        // Display the widget title 
        if ( $title )
            echo '<h4 class="dash_widget_title">'.$title.'</h4>'; 
            
        echo '<div id="wplms_student_attendance"></div>';

        echo '<style>#wplms_student_attendance .record.recordHeader strong:nth-child(3){display:none;}.wplms_student_attendance .record{grid-template-columns:1fr 1fr 1fr;}.attendanceloader svg {
            display: inline-block;
            width: 50px;
            margin-left: calc(50% - 25px);
        }.record.recordHeader { border-top: 1px solid rgba(0,0,0,0.08); background: rgba(0,0,0,0.08); }.record {
            display: grid;
            grid-template-columns: 1fr 1fr 1fr;
            grid-gap: 5px;border-bottom: 1px solid rgba(0,0,0,0.08); padding: 6px; border-left: 1px solid rgba(0,0,0,0.08); border-right: 1px solid rgba(0,0,0,0.08);
        }.selectdate{height: 35px;
    border: 1px solid rgba(0,0,0,0.1);}.selectdate input{border:none;}.selectCourses select{margin-bottom:0;}.attendanceSorter{padding: 10px 0;display: grid; grid-template-columns: 1fr 1fr 1fr; align-items: center; grid-gap: 10px;}.attendanceSorter button{margin:0}</style>';
            echo $after_widget.'</div></div>';
    }

    /** @see WP_Widget::update -- do not rename this */
    function update($new_instance, $old_instance) {   
        $instance = $old_instance;
        $instance['title'] = strip_tags($new_instance['title']);
        $instance['width'] = $new_instance['width'];
        return $instance;
    }
   
      /** @see WP_Widget::form -- do not rename this */
    function form($args) {  
        $defaults = array( 
                        'title'  => __('Attendance','wplms-attendance'),
                        'width' => 'col-md-6 col-sm-12'
                    );
        $args = wp_parse_args( $args, $defaults );
        extract($args);

        ?>
        <p>
            <label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:','wplms-attendance'); ?></label> 
            <input class="regular_text" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" />
        </p>
        <p>
            <label for="<?php echo $this->get_field_id('width'); ?>"><?php _e('Select Width','wplms-attendance'); ?></label> 
            <select id="<?php echo $this->get_field_id('width'); ?>" name="<?php echo $this->get_field_name('width'); ?>">
                <option value="col-md-3 col-sm-6" <?php selected('col-md-3 col-sm-6',$width); ?>><?php _e('One Fourth','wplms-attendance'); ?></option>
                <option value="col-md-4 col-sm-6" <?php selected('col-md-4 col-sm-6',$width); ?>><?php _e('One Third','wplms-attendance'); ?></option>
                <option value="col-md-6 col-sm-12" <?php selected('col-md-6 col-sm-12',$width); ?>><?php _e('One Half','wplms-attendance'); ?></option>
              <option value="col-md-8 col-sm-12" <?php selected('col-md-8 col-sm-12',$width); ?>><?php _e('Two Third','wplms-attendance'); ?></option>
               <option value="col-md-8 col-sm-12" <?php selected('col-md-9 col-sm-12',$width); ?>><?php _e('Three Fourth','wplms-attendance'); ?></option>
                <option value="col-md-12" <?php selected('col-md-12',$width); ?>><?php _e('Full','wplms-attendance'); ?></option>
            </select>
        </p>
        <?php 
    }

    function wplms_download_attendance(){

        if (!current_user_can('edit_posts')){
            echo __('User does not have capability to download stats !','vibe');
            die();
        }

        if ( !isset($_POST['security']) || !wp_verify_nonce($_POST['security'],'wplms-attendance'.$_POST['user_id']) ){
            echo 'Security check failed !';
            die();
        }


        $csv = array();
        $csv_title=array();
        global $wpdb,$bp;

        $csv_title[1]= __("Course", "wplms-attendance");
        $csv_title[2]= __("Date", "wplms-attendance");
        $csv_title[3]= __("Present/Absent", "wplms-attendance");

        $user_id = $_POST['user_id'];


        $student_data = Array();
        $present = __("Present", "wplms-attendance");
        $absent = __("Absent", "wplms-attendance");

        $i=0;
        $args = array(
            'course_ids'=>array(), // Fetch records from these course ids
            'user_id'=>$_POST['user_id'], //fetch records of these stuent ids,
            'offset'=>0,
            'per_page'=>20
        );
        $student_datas = wplms_attendance_get_student_records($args);

        foreach($student_datas as $key => $studentData) {
            $course_id = $studentData['course_id'];
            $user_id = $studentData['user_id'];
            $date = date('M d, Y',$studentData['attendance_timestamp']);


            $csv[0][] = get_the_title($course_id);
            $csv[1][] = $date;
            
            if($studentData['present']) {
                $csv[2][] = $present;
            } else {
                $csv[2][] = $absent;
            }
        } 

        if(!count($csv) || !is_array($csv[1])){
            echo '#';
            die();
        }
        $dir = wp_upload_dir();
        $user_id = get_current_user_id();
        $file_name = 'download_'.$course_id.'_'.$user_id.'.csv';
        $filepath = $dir['basedir'] . '/stats/';
        if(!file_exists($filepath))
            mkdir($filepath,0755);

        $file = $filepath.$file_name;
        if(file_exists($file))
            unlink($file);

        if (($handle = fopen($file, "w")) !== FALSE) {
            fputcsv($handle,$csv_title);
            $rows = count($csv[0]);
            for($i=0;$i<$rows;$i++){
                $arr=array(); 
                foreach ($csv as $key=>$f) {
                    $arr[]=$f[$i];
                }
                fputcsv($handle, $arr);  
            }
        }
        fclose($handle);

        $file_url = $dir['baseurl']. '/stats/'.$file_name;
        echo $file_url;

        die();
    }
} 