<?php

add_action( 'widgets_init', 'wplms_attendance_id_card' );

function wplms_attendance_id_card() {
    register_widget('wplms_attendance_id_card');
}

class wplms_attendance_id_card extends WP_Widget {
 
    /** constructor -- name this the same as the class above */
    function __construct() {
        $widget_ops = array( 'classname' => 'wplms_attendance_id_card', 'description' => __('Student ID Card', 'wplms-attendance') );
        $control_ops = array( 'width' => 300, 'height' => 350, 'id_base' => 'wplms_attendance_id_card' );
        parent::__construct( 'wplms_attendance_id_card', __(' DASHBOARD : Student ID Card', 'wplms-dashboard'), $widget_ops, $control_ops );
    }

    /** @see WP_Widget::widget -- do not rename this */
    function widget( $args, $instance ) {
        extract( $args );

        //Our variables from the widget settings.
        $title = apply_filters('widget_title', $instance['title'] );
        $width = $instance['width'];
        $minheight =$instance['minheight'];
        
        if(empty($minheight)){
            $minheight = 360;
        }
        $user_id= apply_filters('wplms_dashboard_student_id',get_current_user_id());  


        if(empty($width)){
            $width = 'col-md-6';
        }
        echo '<div class="'.$width.'">
            <div class="dash-widget">'.$before_widget;
        if ( $title )
            echo $before_title . $title . $after_title;

        $url = wplms_attendance_generate_idcard($user_id);
        
        ?>
        
        <div id="wplms_student_card">
            <embed src="<?php echo $url; ?>" width="100%" height="<?php $minheight; ?>" type="application/pdf">
            <a href="<?php echo $url; ?>" class="link right"><?php _e('View Full','wplms-attendance'); ?></a>
        </div>        

        <?php echo $after_widget.'</div></div>';
    }

    /** @see WP_Widget::update -- do not rename this */
    function update($new_instance, $old_instance) {   
        $instance = $old_instance;
        $instance['title'] = strip_tags($new_instance['title']);
        $instance['width'] = $new_instance['width'];
        $instance['minheight'] = $new_instance['minheight'];
        
        return $instance;
    }

    
    /** @see WP_Widget::form -- do not rename this */
    function form($args){

        $defaults = array( 
                        'title'  => __("Student's ID Card",'wplms-dashboard'),
                        'minheight'=> 360,
                        'width' => 'col-md-6 col-sm-12'
                    );
        $args = wp_parse_args( $args, $defaults );
        extract($args);

        ?>
        <p>
            <label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:','wplms-dashboard'); ?></label> 
            <input class="regular_text" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" />
        </p>
        <p>
            <label for="<?php echo $this->get_field_id('minheight'); ?>"><?php _e('Minimum Height:','wplms-dashboard'); ?></label> 
            <input class="regular_text" id="<?php echo $this->get_field_id('minheight'); ?>" name="<?php echo $this->get_field_name('minheight'); ?>" type="text" value="<?php echo $minheight; ?>" />
        </p>
        <p>
            <label for="<?php echo $this->get_field_id('width'); ?>"><?php _e('Select Width','wplms-dashboard'); ?></label> 
            <select id="<?php echo $this->get_field_id('width'); ?>" name="<?php echo $this->get_field_name('width'); ?>">
                <option value="col-md-3 col-sm-6" <?php selected('col-md-3 col-sm-6',$width); ?>><?php _e('One Fourth','wplms-dashboard'); ?></option>
                <option value="col-md-4 col-sm-6" <?php selected('col-md-4 col-sm-6',$width); ?>><?php _e('One Third','wplms-dashboard'); ?></option>
                <option value="col-md-6 col-sm-12" <?php selected('col-md-6 col-sm-12',$width); ?>><?php _e('One Half','wplms-dashboard'); ?></option>
                <option value="col-md-8 col-sm-12" <?php selected('col-md-8 col-sm-12',$width); ?>><?php _e('Two Third','wplms-dashboard'); ?></option>
                <option value="col-md-8 col-sm-12" <?php selected('col-md-9 col-sm-12',$width); ?>><?php _e('Three Fourth','wplms-dashboard'); ?></option>
                <option value="col-md-12" <?php selected('col-md-12',$width); ?>><?php _e('Full','wplms-dashboard'); ?></option>
            </select>
        </p>
        <?php 
    }
} 

?>