<?php
/**
 * Initialise WPLMS Batches
 *
 * @class       Bp_Wplms_Attendance_Filters
 * @author      wplms-attendanceThemes
 * @category    Admin
 * @package     WPLMS-Batches/includes
 * @version     1.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}
class Bp_Wplms_Attendance_Filters{


	public static $instance;
	
	public static function init(){

        if ( is_null( self::$instance ) )
            self::$instance = new Bp_Wplms_Attendance_Filters();
        return self::$instance;
    }

	private function __construct(){
        add_filter('bp_course_api_get_instructor_tabs',array($this,'instructor_tabs'),10,2);
        add_filter('wplms_course_stats_list',array($this,'add_attendance_download_stats'));
		//add_action( 'bp_setup_nav', array($this,'add_earnings_tab'), 101 );
        
	}

    function add_attendance_download_stats($stats){
        if(!defined('WPLMS_PLUGIN_VERSION'))
            return $stats;
        $stats[] = array(
            'label'=>_x('Attendance','','wplms-attendance'),
            'id'=>'wplms_attendance',
            'type'=>'wplms_attendance'
        );
        return $stats;
    }

    function instructor_tabs($tabs,$course_id){
        $tabs[] = array(
                            'key'=>'wplms_attendance',
                            'type'=> 'tab',
                            'label'=>_x('Attendance','api','vibe'),
                        );
        return $tabs;
    }

	
}

add_action('plugins_loaded',function(){
	
	if(defined('WPLMS_PLUGIN_VERSION')){
		Bp_Wplms_Attendance_Filters::init();
	}
});
