<?php
/**
 * Initialise WPLMS Batches
 *
 * @class       Bp_Wplms_Attendance_Init
 * @author      wplms-attendanceThemes
 * @category    Admin
 * @package     WPLMS-Batches/includes
 * @version     1.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}
class Bp_Wplms_Attendance_Init{


	public static $instance;
	
	public static function init(){

        if ( is_null( self::$instance ) )
            self::$instance = new Bp_Wplms_Attendance_Init();
        return self::$instance;
    }

	private function __construct(){

		//add_action( 'bp_setup_nav', array($this,'add_earnings_tab'), 101 );
        add_action('init',array($this,'remove_custom_front_end_div'));
        add_action('wplms_course_stats_process',array($this,'process_attendance_stat'),10,8);

		add_action('wp_enqueue_scripts',array($this,'enqueue_script'));
	}

    function process_attendance_stat(&$csv_title, &$csv,&$i,&$course_id,&$user_id,&$field,&$ccsv,&$k){
    

         if( !is_array($field) || strpos($field[0], '/')===false)
            return;
         // Custom Stat Calculation //
        $dates = $field;
        $start_date = $dates[0];
        $end_date = $dates[1];
        $start_date_timestamp =strtotime($start_date);
        $end_date_timestamp =strtotime($end_date);
        $user_dates = get_user_meta($user_id,'wplms_course_attendance_'.$course_id,true);
        $incrementer = $start_date_timestamp;
        $gmt_offset = get_option('gmt_offset');
        $user_dates_array = array();

        if(!empty($user_dates)){
          foreach ($user_dates as $key => $user_date) {
            $user_dates_array[$user_date] = trim(date('m/d/Y', $user_date+($gmt_offset*60*60)));
          }
        }
        
        while($incrementer <= $end_date_timestamp){
            $title=date('m/d/Y', $incrementer);
            if(!in_array($title,$csv_title))
                //$csv_title[$i]=$title; // ----> This is Title of the CSV Column
                $csv_title[$k]=array('title'=>$title,'field'=>strval($incrementer));
            $searched_date_index = array_search($title, $user_dates_array);
            if(!empty($user_dates_array) && !empty($searched_date_index)){
               $csv[$i][] = strval(date('m/d/Y H:i:s',($searched_date_index+($gmt_offset*60*60)) ));
               $ccsv[$i][strval($incrementer)] =date('m/d/Y H:i:s',($searched_date_index+($gmt_offset*60*60)) );
            }else{
               $csv[$i][]= _x('NA','attendance','wplms-attendance');
               $ccsv[$i][strval($incrementer)] = __('N.A','vibe');
            }
            $incrementer = $incrementer + 24*60*60;
            $k++;
        }
    }

    function remove_custom_front_end_div(){
        if(!defined('WPLMS_PLUGIN_VERSION'))
            return;
        $att = Wplms_Attendance_Init::init();
        remove_action('wplms_front_end_generate_fields_default',array($att,'wplms_front_end_generate_field_default_customdiv'),10,2);
        remove_action('wplms_course_stats_list',array($att,'add_attendance_stat'));
        remove_action('wplms_course_stats_process',array($att,'process_attendance_stat'),10,6);
    }

	function enqueue_script(){
        if(!defined('WPLMS_PLUGIN_VERSION'))
            return;
		$blog_id = '';
        if(function_exists('get_current_blog_id')){
            $blog_id = get_current_blog_id();
        }

            
		$kb=apply_filters('wplms_attendance_script_args',array(
			'api_url'=> get_rest_url($blog_id,WPLMS_API_NAMESPACE),
            'settings'=>array(
            	
            ),
            'client_id' => (function_exists('vibebp_get_setting')?vibebp_get_setting('client_id'):''),
            'per_page' => apply_filters('wplms_attendance_per_page',10),
            'timestamp'=>time(),

            'date_format'=>get_option('date_format'),
            'time_format'=>get_option('time_format'),
            'translations'=>array(
                'show_calendar' =>_x('Show Calendar','','wplms-attendance'),
                'hide_calendar' =>_x('Hide Calendar','','wplms-attendance'),
                'date'=>_x('Date','','wplms-attendance'),
                'attendance'=>_x('Attendance','','wplms-attendance'),
                'showing'=>_x('Showing','api call','wplms-attendance'),
                'of'=>_x('of','api call','wplms-attendance'),
                'go'=>_x('Go','api call','wplms-attendance'),
                'student'=>_x('Student','api call','wplms-attendance'),
                'select_course'=>_x('Select a course','api call','wplms-attendance'),
                'no_records'=>_x('No records found','api call','wplms-attendance'),
                'select_student'=>_x('Select a student','api call','wplms-attendance'),
                'search_student'=>_x('Search student','api call','wplms-attendance'),
                'mark_attendance'=>_x('Mark Attendance','','wplms-attendance'),
                'no_records'=>_x('No records','','wplms-attendance'),
                'present'=>_x('Present','','wplms-attendance'),
                'absent'=>_x('Absent','','wplms-attendance'),
                'select_course' => _x('Select course to load stats','','wplms-attendance'),
                'leaderboard' => _x('Leaderboard','','wplms-attendance'),
                 'recalculate' => _x('Recalculate','','wplms-attendance'),
                 'recalculated' => _x('Recalculated','','wplms-attendance'),
                'settings_saved' => _x('Settings saved','','wplms-attendance'),
                'course_specific_stats' => _x('COURSE SPECIFIC STATISTICS','','wplms-attendance'),
                'loaded' => _x('Loaded','','wplms-attendance'),
                'date'=>_x('Date','api call','wplms-attendance'),
                'course'=>_x('Course','api call','wplms-attendance'),
                'commissions'=>_x('Commissions','api call','wplms-attendance'),
                'of'=>_x('of','api call','wplms-attendance'),
                'go'=>_x('Go','api call','wplms-attendance'),
                'student'=>_x('Student','api call','wplms-attendance'),
                'select_date'=>_x('Select a date','api call','wplms-attendance'),
                'start_date'=>_x('Select start date','api call','wplms-attendance'),
                'end_date'=>_x('Select end date','api call','wplms-attendance'),
                'select_course'=>_x('Select a course','api call','wplms-attendance'),
                'no_records'=>_x('No records found','api call','wplms-attendance'),
                'select_student'=>_x('Select a student','api call','wplms-attendance'),
                'search_student'=>_x('Search student','api call','wplms-attendance'),
                
                'request_payouts'=>_x('Request Payouts','api call','wplms-attendance'),
                'requested_payouts'=>_x('Payout Requested','api call','wplms-attendance'),
                'last_requested'=>_x('Last requested on','api call','wplms-attendance'),
                'add_new' => _x('Add New','','wplms-attendance'),
                'course_batches' => _x('Course Batches','','wplms-attendance'),
                'create_batch' =>_x('Create Batch','','wplms-attendance'),
                'select_batch' =>_x('Select Batch','','wplms-attendance'),
                'hidden' => _x('Hidden','','wplms-attendance'),
                'private'=>_x('Private','','wplms-attendance'),
                'public'=>_x('Public','','wplms-attendance'),
                'save' => _x('Save','','wplms-attendance'),
                'start_time' => _x('Start time','','wplms-attendance'),
                'end_time'=>_x('End time','','wplms-attendance'),
                'every' => _x('Every','','wplms-attendance'),
            ),
        ));

        global $post;
        if((function_exists('bp_is_user') && bp_is_user()) || has_shortcode($post->post_content,'vibebp_profile')){
            
            wp_enqueue_script('wplms-attendance-create-js',plugins_url('../assets/js/wplms-attendance.js',__FILE__),array('wp-element','wp-data'),WPLMS_ATTENDANCE_DB_VERSION);
            wp_localize_script('wplms-attendance-create-js','wplms_attendance_data',$kb);
            wp_enqueue_style('wplms-attendance-create-css',plugins_url('../assets/css/wplms-attendance.css',__FILE__),array(),WPLMS_ATTENDANCE_DB_VERSION);



            //group tab 
            //wp_enqueue_script('wplms-batch-js',plugins_url('../assets/js/wplms-batch.js',__FILE__),array('wp-element','wp-data'),WPLMS_ATTENDANCE_DB_VERSION);
            //wp_localize_script('wplms-batch-js','wplms_batch_data',$kb);
            //wp_enqueue_style('wplms-batch-css',plugins_url('../assets/css/wplms-batch.css',__FILE__),array(),WPLMS_ATTENDANCE_DB_VERSION);
        }
	}
	
}

add_action('plugins_loaded',function(){
	
	if(defined('WPLMS_PLUGIN_VERSION')){
		Bp_Wplms_Attendance_Init::init();
	}
});
