<?php
/*
Plugin Name: WPLMS Attendance
Plugin URI: https://wplms.io
Description: Attendance Module for WPLMS
Version: 1.6
Author: VibeThemes
Author URI: http://www.wplms.io
Text Domain: wplms-attendance
Domain Path: /languages/
*/
if ( !defined( 'ABSPATH' ) ) exit; 
/*  Copyright 2013 VibeThemes  (email: vibethemes@gmail.com) */

if ( !defined( 'WPLMS_ATTENDANCE_DB_VERSION' ) ){
    define('WPLMS_ATTENDANCE_DB_VERSION','1.6');

}
if ( !defined( 'WPLMS_UPDATES_URL' ) ){
    define('WPLMS_UPDATES_URL','https://wplms.io');

}

include_once 'includes/class.updater.php';
include_once 'includes/class.config.php';
include_once 'includes/class.init.php';
include_once 'includes/class.import.php';
include_once 'includes/class.functions.php';

add_action('plugins_loaded',function(){
    if(defined('WPLMS_PLUGIN_VERSION')){
       
        include_once 'vibebp/includes/class.api.php';
    }else{
        include_once 'includes/class.api.php';
    }
});

include_once 'includes/widgets/student/attendance.php';
include_once 'includes/widgets/instructor/my-students-attendance.php';
include_once 'includes/class.idcard.php';
include_once 'includes/widgets/student/idcard.php';
include_once 'vibebp/includes/class.filters.php';
include_once 'vibebp/includes/class.init.php';


add_action('plugins_loaded','wplms_attendance_translations');
function wplms_attendance_translations(){
    $locale = apply_filters("plugin_locale", get_locale(), 'wplms-attendance');
    $lang_dir = dirname( __FILE__ ) . '/languages/';
    $mofile        = sprintf( '%1$s-%2$s.mo', 'wplms-attendance', $locale );
    $mofile_local  = $lang_dir . $mofile;
    $mofile_global = WP_LANG_DIR . '/plugins/' . $mofile;

    if ( file_exists( $mofile_global ) ) {
        load_textdomain( 'wplms-attendance', $mofile_global );
    } else {
        load_textdomain( 'wplms-attendance', $mofile_local );
    }  
}


function Wplms_Attendance_Plugin_updater() {
    $license_key = trim( get_option( 'wplms_attendance_license_key' ) );
    $edd_updater = new Wplms_Attendance_Plugin_Updater( WPLMS_UPDATES_URL, __FILE__, array(
            'version'   => WPLMS_ATTENDANCE_DB_VERSION,               
            'license'   => $license_key,        
            'item_name' => 'WPLMS Attendance',    
            'author'    => 'VibeThemes' 
        )
    );
}
add_action( 'admin_init', 'Wplms_Attendance_Plugin_updater', 0 );
