jQuery(document).ready(function($){
                    
    $('#wplms_course_batch_curriculum').select2({
        minimumInputLength: 4,
        placeholder: $(this).attr('data-placeholder'),
        closeOnSelect: true,
        allowClear: true,
        ajax: {
            url: ajaxurl,
            type: "POST",
            dataType: 'json',
            delay: 250,
            data: function(term){ 
                    return  {   action: 'get_course_batches', 
                                security: $('#security').val(),
                                course_id:$('#course_id').val(),
                                q: term,
                            }
            },
            processResults: function (data) {
                return {
                    results: data
                };
            },       
            cache:true  
        },
    });
    

    $('#load_batch_curriculum').on('click',function(){
        var $this = $(this);
        var course_id=$('#course_id').val();
        var defaulttxt = $this.html();
        var batch_id = $('#wplms_course_batch_curriculum').val();
        if($this.hasClass('loading'))
            return;
        $this.addClass('loading');
        var default_curriculum = $('ul.curriculum').html();
        $('ul.curriculum li').hide(200).remove();
        $.ajax({
            type: "POST",
            url: ajaxurl,
            data: { action: 'load_course_batch_curriculum', 
                    security: $('#security').val(),
                    batch_id: batch_id,
                    course_id: course_id,
                  },
            cache: false,
            success: function (html) {
                $this.removeClass('loading');
                if($.isNumeric(html)){
                   $('ul.curriculum').html('<div class="message">There was some error in loading the batch curriculum ! Loading default course curriculum ...</div>');
                   setTimeout(function(){$('ul.curriculum').html(default_curriculum);}, 2000);
                   $('#course_curriculum').trigger('active');
                }else{
                    $('ul.curriculum').html(html);
                    $('#course_curriculum').trigger('active');
                }
            }
        });
    });
    $('#save_batch_curriculum').on('click',function(){
        var $this = $(this);
        var course_id=$('#course_id').val();
        var defaulttxt = $this.html();
        var curriculum = [];
        var batch_id = $('#wplms_course_batch_curriculum').val();
        if($this.hasClass('loading'))
            return;
        $this.addClass('loading');
        $('ul.curriculum li').each(function() {
            if($(this).hasClass('new_section')){
                if($(this).find('input.section').length){
                    var val = $(this).find('input.section').val();
                }else{
                    var val = $(this).find('strong').text();
                }
                
            }else{
               var val =  $(this).find('strong.title').attr('data-id');
            }
            if(typeof val != 'undefined'){
                var data = { id: val };  
                curriculum.push(data);                 
            } 
        });
        $.ajax({
            type: "POST",
            url: ajaxurl,
            data: { action: 'save_course_batch_curriculum', 
                    security: $('#security').val(),
                    batch_id: batch_id,
                    course_id: course_id,
                    curriculum: JSON.stringify(curriculum),
                  },
            cache: false,
            success: function (html) {
                $this.removeClass('loading');
                if($.isNumeric(html)){
                    $this.text(vibe_course_module_strings.saved_quiz_progress);
                    setTimeout(function(){
                        $this.html(defaulttxt);
                    },2000);
                }else{
                    $this.html(html);
                    setTimeout(function(){$this.html(defaulttxt);}, 2000);
                }
            }
        });
    });

    $('ul.course_batches').sortable({
        revert: true,
        cursor: 'move',
        refreshPositions: true, 
        opacity: 0.6,
        scroll:true,
        containment: 'parent',
        placeholder: 'placeholder',
        tolerance: 'pointer',
        update: function(event, ui) {
            var order = [];
            $(this).find('li').each(function(){
                var id = $(this).attr('data-id');
                if(typeof(id) != 'undefined'){
                    order.push(id);
                }
            });
            $('.batch_order').val(order);
        }
    });
    
});