<?php
/**
 * Initialise WPLMS v4 Batches
 *
 * @class       WPLMS v4 Batches
 * @author      VibeThemes
 * @category    Admin
 * @package     WPLMS-Batches/includes
 * @version     1.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}


class Wplms_Batches_v4_Init{


	public static $instance;
	
	public static function init(){

        if ( is_null( self::$instance ) )
            self::$instance = new Wplms_Batches_v4_Init();
        return self::$instance;
    }

	private function __construct(){
		
		add_action('wp_ajax_nopriv_get_enrolled_batches',array($this,'get_enrolled_batches'));
		add_action('wp_ajax_get_enrolled_batches',array($this,'get_enrolled_batches'));
		add_action('wp_ajax_nopriv_enrol_in_batch',array($this,'enrol_in_batch'));
		add_action('wp_ajax_enrol_in_batch',array($this,'enrol_in_batch'));

		add_action('wplms_vibe_grid',array($this,'batch_grid'));
        add_action('wplms_vibe_grid_settings',array($this,'check_batch_grid'),1);
        add_filter('wplms_grid_course_filters',array($this,'filter_grid'));
	}

	function get_enrolled_batches(){
		if(!empty($_POST['token'])){
			$user = vibebp_expand_token($_POST['token']);
			$batches = json_decode(stripslashes($_POST['batches']));
			
			if(!empty($batches)){

				$user_id = $user['data']->data->user->id;
				$return = array(
					'status'=>1,
					'enrolled'=>array(),
					'can_enrol'=>0
				);
				if(function_exists('bp_course_is_member') && bp_course_is_member($_POST['course_id'],$user_id)){
					$return['can_enrol']=1;
				}
				foreach($batches as $batch_id){
					
					if(wplms_batch_is_user_member( $user_id, $batch_id )){
						$return['enrolled'][]=$batch_id;
					}
				}
				
				echo json_encode($return);
				die();
			}
		}
		die();
	}

	function enrol_in_batch(){
		$return = array(
			'status'=>0
		);
		if(!empty($_POST['token'])){
			$user = vibebp_expand_token($_POST['token']);
			$batch_id = json_decode(stripslashes($_POST['batch_id']));
			$course_id = json_decode(stripslashes($_POST['course_id']));
			
			if(!empty($course_id) && !empty($batch_id)){

				$user_id = $user['data']->data->user->id;
				
				if(bp_course_is_member($course_id,$user_id) && wplms_course_batch_verify($course_id,$batch_id)){
		      		groups_join_group($batch_id, $user_id ); 
		      		$return['status']=1;
		      	}
			}
		}
		echo json_encode($return);
		die();
	}

	function batch_grid($elementor){
        global $post;
        

        if($post->type == 'group-layout'){
            
            $elementor->add_control(
                'show_batch',
                [
                    'label' =>__('Batch Courses', 'wplms'),
                    'type' => \Elementor\Controls_Manager::CHOOSE,
                    'options' => [
                        1 => [
                            'title' => __( 'Show', 'wplms' ),
                            'icon' => 'vicon vicon-check',
                        ],
                        0 => [
                            'title' => __( 'No', 'wplms' ),
                            'icon' => 'vicon vicon-x',
                        ],
                    ],
                ]
            );
        }
    }

    function check_batch_grid($settings){
        if(!empty($settings['show_batch'])){
            $this->show_batch = 1;
        }
    }

    function filter_grid($args){
           
        if(!empty($this->show_batch)){
            if(bp_current_component() == 'groups'){
                $args['post__in'] = get_group_courses(bp_get_current_group_id());
            }
        }
        
        return $args;
    }
}

Wplms_Batches_v4_Init::init();