<?php
/**
 * Initialise WPLMS Batches
 *
 * @class       Bp_Wplms_Batches_Init
 * @author      wplms-batchesThemes
 * @category    Admin
 * @package     WPLMS-Batches/includes
 * @version     1.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

class Bp_Wplms_Batches_Init{


	public static $instance;
	
	public static function init(){

        if ( is_null( self::$instance ) )
            self::$instance = new Bp_Wplms_Batches_Init();
        return self::$instance;
    }

	private function __construct(){

		//add_action( 'bp_setup_nav', array($this,'add_earnings_tab'), 101 );
		add_action('wp_enqueue_scripts',array($this,'enqueue_script'));

        add_action('init',array($this,'batch_filters_remove'));
        add_action('wplms_front_end_field_save',array($this,'savefield'),10,2);
	}

    function savefield($course_id,$field){

        if($field['meta_key']=='vibe_batches') {
            $batches = wplms_get_course_batches($course_id);
            if(!empty($field['meta_value'])){
                if(!empty($batches)){
                    foreach ($batches as $key => $batch_id) {
                        $cidss = groups_get_groupmeta($batch_id,'batch_course',false);
                        if(is_array($cidss) && in_array($course_id,$cidss)){
                            groups_delete_groupmeta($batch_id,'batch_course',$course_id);
                        }
                    }
                }
                foreach ($field['meta_value'] as $k => $batch_id) {
                    $course_ids = array($course_id);
                    $cids = groups_get_groupmeta($batch_id,'batch_course',false);

                    //groups_delete_groupmeta($batch_id,'batch_course',false);
                    foreach($course_ids as $course){
                        if(is_array($cids) && !in_array($course,$cids)){
                            groups_add_groupmeta($batch_id,'batch_course',$course);
                        }
                    }
                    
                }
            }else{
                
                if(!empty($batches)){
                    foreach ($batches as $key => $batch_id) {
                        $cids = groups_get_groupmeta($batch_id,'batch_course',false);
                        if(is_array($cids) && in_array($course_id,$cids)){
                            groups_delete_groupmeta($batch_id,'batch_course',$course_id);
                        }
                    }
                }
            }
            
        }
    }

    function batch_filters_remove(){
        if(function_exists('is_wplms_4_0') && is_wplms_4_0()){
            $create = Wplms_Batches_Create::init();
            remove_action('wplms_front_end_generate_fields_default',array($create,'create_batches'),10,2);

            $init = Wplms_Batches_Init::init();
            remove_action('wplms_after_course_description',array($init,'wplms_batches'));
            //add_action('wplms_after_course_description',array($this,'wplms_batches'));
            remove_action('wp_enqueue_scripts',array($init,'register_scripts')); 
            
        }


    }

    function wplms_batches(){
        $course_id = get_the_ID();
        $batches = wplms_get_course_batches($course_id);
    
        if(empty($batches))
            return;

        $create_batch = $this->get_data();
        wp_enqueue_script('wplms-course-batches-js',plugins_url('../assets/js/course-batch.js',__FILE__),array('wp-element','wp-data'),WPLMS_BATCHES_VERSION);
        wp_localize_script('wplms-course-batches-js','wplms_batches_data',$create_batch);
        wp_enqueue_style('wplms-batches-create-css',plugins_url('../assets/css/wplms-batches.css',__FILE__),array(),WPLMS_BATCHES_VERSION);

        echo '<div class="course_batches"></div>';
        ?>

        <script>
            document.addEventListener('userLoaded', (event) => {
                var ppev = new CustomEvent('fullcourse_external_tab', { "detail":{'tab':'course_batches','course':{id:<?php echo $course_id;?>}}});
                document.dispatchEvent(ppev);
            });
        </script>
        <?php

        

        
       
    }

	function enqueue_script(){
		
        global $post;
        if((function_exists('bp_is_user') && bp_is_user()) || has_shortcode($post->post_content,'vibebp_profile')){
            $create_batch = $this->get_data();

            wp_enqueue_script('wplms-batches-create-js',plugins_url('../assets/js/wplms-batches.js',__FILE__),array('wp-element','wp-data'),WPLMS_BATCHES_VERSION);
            wp_localize_script('wplms-batches-create-js','wplms_batches_data',$create_batch);

            wp_enqueue_style('wplms-batches-create-css',plugins_url('../assets/css/wplms-batches.css',__FILE__),array(),WPLMS_BATCHES_VERSION);
            wp_enqueue_script('wplms-course-batches-js',plugins_url('../assets/js/course-batch.js',__FILE__),array('wp-element','wp-data'),WPLMS_BATCHES_VERSION);

            if(class_exists('WPLMS_tips')){
                $tips = WPLMS_tips::init();
                if(isset($tips) && isset($tips->settings) && !empty($tips->settings['enable_batch_curriculums'])){
                    //Batch curriculum
                    wp_enqueue_script('wplms-batch-curriclums-js',plugins_url('../assets/js/batch_curriculums.js',__FILE__),array('wp-element','wp-data'),WPLMS_BATCHES_VERSION);
                }
            }

            

            //group tab 
            wp_enqueue_script('wplms-batch-js',plugins_url('../assets/js/wplms-batch.js',__FILE__),array('wp-element','wp-data'),WPLMS_BATCHES_VERSION);
            wp_localize_script('wplms-batch-js','wplms_batch_data',$create_batch);
            wp_enqueue_style('wplms-batch-css',plugins_url('../assets/css/wplms-batch.css',__FILE__),array(),WPLMS_BATCHES_VERSION);
        }

        
	}
	

    function get_data(){
        $blog_id = '';
        if(function_exists('get_current_blog_id')){
            $blog_id = get_current_blog_id();
        }
        $this->show_enroll_button = false;
        if(class_exists('WPLMS_tips')){
            $tips = WPLMS_tips::init();
            if(isset($tips) && isset($tips->settings) && !empty($tips->settings['enable_enroll_now_in_batch'])){
                $this->show_enroll_button = true;
            }
        }
            
        $create_batch=apply_filters('wplms_batches_script_args',array(
            'api_url'=> get_rest_url($blog_id,WPLMS_API_NAMESPACE),

            'settings'=>array(
                'icon'=>'<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 50 50"><path d="M 2.8125 8 C 2.335938 8.089844 1.992188 8.511719 2 9 L 2 38 L 1 38 C 0.96875 38 0.9375 38 0.90625 38 C 0.390625 38.046875 -0.00390625 38.480469 0 39 L 0 44 C 0 44.550781 0.449219 45 1 45 L 49 45 C 49.550781 45 50 44.550781 50 44 L 50 39 C 50 38.449219 49.550781 38 49 38 L 48 38 L 48 9 C 48 8.449219 47.550781 8 47 8 L 3 8 C 2.96875 8 2.9375 8 2.90625 8 C 2.875 8 2.84375 8 2.8125 8 Z M 4 10 L 46 10 L 46 38 L 21.90625 38 L 23 36 L 21.90625 34 L 11 34 L 11 38 L 4 38 Z M 39 14.96875 C 38.945313 14.976563 38.894531 14.984375 38.84375 15 C 38.683594 15.027344 38.535156 15.089844 38.40625 15.1875 L 25.03125 24.71875 L 19.625 20.21875 C 19.273438 19.933594 18.773438 19.921875 18.40625 20.1875 L 10.40625 26.1875 C 9.957031 26.515625 9.859375 27.144531 10.1875 27.59375 C 10.515625 28.042969 11.144531 28.140625 11.59375 27.8125 L 18.96875 22.28125 L 24.375 26.78125 C 24.726563 27.066406 25.226563 27.078125 25.59375 26.8125 L 39.59375 16.8125 C 39.980469 16.570313 40.152344 16.09375 40.011719 15.660156 C 39.871094 15.226563 39.457031 14.941406 39 14.96875 Z M 2 40 L 48 40 L 48 43 L 2 43 Z"></path></svg>',
                'show_enroll_button' => $this->show_enroll_button,
            ),
            
            'timestamp'=>(time()*1000),
            'per_page'=>10,
            'date_format'=>get_option('date_format'),
            'time_format'=>get_option('time_format'),
            'translations'=>array(
                'enrolled' => _x('Enrolled','','wplms-batches'),
                'enrol'=> _x('Enroll','','wplms-batches'),
                'seats' =>  _x('Seats','','wplms-batches'),
                'seats_full' =>  _x('Seats Full','','wplms-batches'),
                'select_course' => _x('Select course to load stats','','wplms-batches'),
                'leaderboard' => _x('Leaderboard','','wplms-batches'),
                 'recalculate' => _x('Recalculate','','wplms-batches'),
                 'recalculated' => _x('Recalculated','','wplms-batches'),
                'settings_saved' => _x('Settings saved','','wplms-batches'),
                'course_specific_stats' => _x('COURSE SPECIFIC STATISTICS','','wplms-batches'),
                'loaded' => _x('Loaded','','wplms-batches'),
                'date'=>_x('Date','api call','wplms-batches'),
                'course'=>_x('Course','api call','wplms-batches'),
                'commissions'=>_x('Commissions','api call','wplms-batches'),
                'of'=>_x('of','api call','wplms-batches'),
                'go'=>_x('Go','api call','wplms-batches'),
                'student'=>_x('Student','api call','wplms-batches'),
                'select_date'=>_x('Select a date','api call','wplms-batches'),
                'start_date'=>_x('Select start date','api call','wplms-batches'),
                'end_date'=>_x('Select end date','api call','wplms-batches'),
                'select_course'=>_x('Select a course','api call','wplms-batches'),
                'no_records'=>_x('No records found','api call','wplms-batches'),
                'no_batches_found'=>_x('No batches found','api call','wplms-batches'),
                'select_student'=>_x('Select a student','api call','wplms-batches'),
                'search_student'=>_x('Search student','api call','wplms-batches'),
                'cancel'=>_x('Cancel','api call','wplms-batches'),
                'request_payouts'=>_x('Request Payouts','api call','wplms-batches'),
                'requested_payouts'=>_x('Payout Requested','api call','wplms-batches'),
                'last_requested'=>_x('Last requested on','api call','wplms-batches'),
                'add_new' => _x('Add New','','wplms-batches'),
                'course_batches' => _x('Course Batches','','wplms-batches'),
                'create_batch' =>_x('Create Batch','','wplms-batches'),
                'edit_batch'=>_x('Edit Batch','','wplms-batches'),
                'select_batch' =>_x('Select Batch','','wplms-batches'),
                'hidden' => _x('Hidden','','wplms-batches'),
                'private'=>_x('Private','','wplms-batches'),
                'public'=>_x('Public','','wplms-batches'),
                'save' => _x('Save','','wplms-batches'),
                'start_time' => _x('Start time','','wplms-batches'),
                'end_time'=>_x('End time','','wplms-batches'),
                'every' => _x('Every','','wplms-batches'),
                'add_batch' => _x('Add new batch','','wplms-batches'),
                'batch_title'=>_x('Batch Title','batches','wplms-batches'),
                'load_batch_curriculum'=>_x('Load batch curriculum','batches','wplms-batches'),
                'save_batch_curriculum'=>_x('Save batch curriculum','batches','wplms-batches'),
            ),
        ));
        return $create_batch;
    }
}

add_action('plugins_loaded',function(){
	
	if(defined('WPLMS_PLUGIN_VERSION')){
		Bp_Wplms_Batches_Init::init();
	}
});
