<?php

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}

 class WPLMS_Gift_Course_Shortcode extends \Elementor\Widget_Base  // We'll use this just to avoid function name conflicts 
{


    public function get_name() {
		return 'gift_course_widget';
	}

	public function get_title() {
		return __( 'Gift Course Widget', 'wplms-gift' );
	}

	public function get_icon() {
		return 'vicon vicon-gift';
	}

	public function get_categories() {
		return [ 'wplms-gift' ];
	}

	protected function _register_controls() {
		$this->start_controls_section(
			'section_title',
			[
				'label' =>  __( 'Controls', 'wplms-gift' ),
			]
		);
			
		$this->add_control(
			'to',
            [
                'label' => __( 'to', 'wplms-gift' ),
                'type' => \Elementor\Controls_Manager::TEXT,
                'placeholder' => __('Enter Gift User Email', 'wplms-gift'),
            ]
			
		);

		$this->add_control(
			'from',
            [
                'label' => __( 'from', 'wplms-gift' ),
                'type' => \Elementor\Controls_Manager::TEXT,
                'placeholder' => __('Enter Your Email', 'wplms-gift'),
            ]
			
		);

		$this->add_control(
			'Message',
			[
				'label' => __( 'Message', 'wplms-gift' ),
				'type' => \Elementor\Controls_Manager::TEXT,
				'placeholder' => __('Enter Message', 'wplms-gift'),
			]
		);

		$this->add_control(
			'content',
			[
				'label' => __( 'Button Text', 'wplms-gift' ),
				'type' => \Elementor\Controls_Manager::TEXT,
				'placeholder' => __( 'Send As Gift', 'wplms-gift' ),
			]
		);
			
		
	}

	protected function render() {

		$settings = $this->get_settings_for_display();
		/* 
		localforage.getItem(‘bp_login_token’)
		Not added the above condition because even non logged in users can gift courses to someone
		 */
		if(is_singular('course')){
			$course_id = get_queried_object_id();
		}

		if(is_user_logged_in()){
                $current_user = wp_get_current_user();
            ?><script>
                document.addEventListener('DOMContentLoaded',function(){ 
                    
                    localforage.getItem('bp_login_token').then(function(token){
                    	//console.log(token);
                        
                        if(!token){
                            var xhr = new XMLHttpRequest();
                            xhr.open('POST', ajaxurl);
                            xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
                            xhr.onload = function() {
                                if (xhr.status === 200) {
                                    let check = JSON.parse(xhr.responseText);
                                    if(check.status){
                                        localforage.setItem('bp_login_token',check.token).then(function(){
                                        	console.log('triggerred');
                                        	var event = new CustomEvent("tokenGenerated");
											document.dispatchEvent(event);	
                                        });
                                        //
                                    }else{
                                        localforage.removeItem('bp_login_token');
                                    }
                                }
                            };

                            xhr.send(encodeURI('action=generate_token&client_id=<?php echo vibebp_get_setting('client_id'); ?>&security=<?php echo wp_create_nonce('security'); ?>&email=<?php echo $current_user->user_email; ?>'));
                        }
                    });
                });
            </script>
            <?php

            //echo '<pre>';print_R($current_user);
            do_action('show_element_gift_course_widget',$settings);
            /*
            echo '<form class="gift_course_form" method="get" action="'.wc_get_cart_url().'">
			<input type="hidden" name="add-to-cart" value="'.wc_get_page_id( 'cart' ).'">
			<input type="email" name="gift_email" class="form_field" value="'.$settings['to'].'" required="">
			<input type="email" class="gift_from form_field" name="gift_from" value="'.$current_user->user_email.'" required="">
			<textarea name="gift_message" class="form_field">'.$settings['message'].'</textarea>
			<input type="submit" id="send_gift_form" class="button" value="'.$settings['content'].'">
			</form>';
			*/
		
            }
        
	}
}