<?php
/**
 * WPLMS GIFT COURSE Actions hooks React
 *
 * @author 		VibeThemes
 * @category 	Init
 * @package 	giftcourse/Includes
 * @version     4.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

class WPLMS_GIFT_COURSE_COMPONENT{

	public static $instance;
    
    public static function init(){

        if ( is_null( self::$instance ) )
            self::$instance = new WPLMS_GIFT_COURSE_COMPONENT();
        return self::$instance;
    }

	private function __construct(){
        add_action( 'bp_setup_nav', array($this,'add_wplms_gift_course_tab'), 100 );
		add_action('wp_enqueue_scripts',array($this,'scripts'));
		add_filter('vibebp_component_icon',array($this,'set_icon'),10,2);
		add_filter('vibebp_vars',array($this,'add_profile_setting'));

		//Create gift course email
		add_filter('bp_course_all_mails',array($this,'add_gift_course_email'));

		//Add gift button in course details widget.
		add_filter('wplms_course_details_widget',array($this,'display_gift_course_button'),99);

		add_action('show_element_gift_course_widget',array($this,'show_element_gift_course_widget'),999);

		  
	}

	function set_icon($icon,$component_name){

        if($component_name == WPLMS_GIFT_COURSE_SLUG ){
            return '<svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24"><path d="M11 24h-9v-12h9v12zm0-18h-11v4h11v-4zm2 18h9v-12h-9v12zm0-18v4h11v-4h-11zm4.369-6c-2.947 0-4.671 3.477-5.369 5h5.345c3.493 0 3.53-5 .024-5zm-.796 3.621h-2.043c.739-1.121 1.439-1.966 2.342-1.966 1.172 0 1.228 1.966-.299 1.966zm-9.918 1.379h5.345c-.698-1.523-2.422-5-5.369-5-3.506 0-3.469 5 .024 5zm.473-3.345c.903 0 1.603.845 2.342 1.966h-2.043c-1.527 0-1.471-1.966-.299-1.966z"/></svg>';
        }
        return $icon;
    }

    function add_profile_setting($settings){
    	//echo'<pre>';print_r($settings);
    	$settings['settings']['profile_settings'][]= array('key'=>'wplms-gift-course-key','label'=>__('WPLMS Gift Course','wplms-gift'));
    	return $settings;
    }

	function add_wplms_gift_course_tab(){
		global $bp;
	    bp_core_new_nav_item( array( 
	        'name' => __('Gift Course','wplms-gift'),
	        'slug' => WPLMS_GIFT_COURSE_SLUG, 
	        'item_css_id' => 'gift-course',
	        'screen_function' => array($this,'show_details'),
	        'default_subnav_slug' => 'home', 
	        'position' => 20
        ) );
        
    }
    
    function show_details(){
  

    }

    function show_element_gift_course_widget($settings){
    	//print_r('Yeahhhhh');
    	$wplms_woo_active = 0;
        $active_plugins =get_option( 'active_plugins' );
        if ( (in_array( 'wplms-woocommerce/wplms-woocommerce.php', apply_filters( 'active_plugins', $active_plugins ) )) || (function_exists('is_plugin_active_for_network') && is_plugin_active_for_network( 'wplms-woocommerce/wplms-woocommerce.php'))){
        	$wplms_woo_active = 1;
        }

        if(is_singular('course')){
			$course_id = get_queried_object_id();
			$product_id = get_post_meta($course_id,'vibe_product',true);
			if(empty($product_id) || !is_numeric($product_id)){

			// Check if course is free
				$free = get_post_meta($course_id,'vibe_course_free',true);
				if(function_exists('vibe_validate') && vibe_validate($free)){

					// Check LMS settings for free courses
					if(class_exists('WPLMS_tips')){
					$tips = WPLMS_tips::init();
					if(!empty($tips->settings['enable_gift_button_for_free_courses'])){
						echo '<li class="gift_this_course"><input type="hidden" class="gift_course_id" value="'.$course_id.'"/><a class="gift_course_button"  class="full button" data-from="'.__('Enter your email','wplms-gift').'" data-to="'.__('Enter gift email','wplms-gift').'" data-message="'.__('Enter message','wplms-gift').'" data-free="1" data-button="'.__('Send as Gift','wplms-gift').'">'.__('Gift this course','wplms-gift').'</a></li>';
					
						}
					}
				
				}

				
			}

			global $woocommerce;
			$cart_url = $woocommerce->cart->get_cart_url();
			echo '<div id="move_field_c"><input type="hidden" name="add-to-cart" value="'.$product_id.'" /></div>';

			// Check if product is variable
			$product = wc_get_product($product_id);


		if(!empty($product) ){
			if( $product->is_type( 'variable' )){
				if(!$wplms_woo_active)
				return $course_details;
				$cartUrl = $woocommerce->cart->get_cart_url();
				$variations = $product->get_available_variations();
				$cart_url_array = [];
				foreach($variations as $variation){
					$cart_url = $cartUrl.'?add-to-cart='.$product_id.'&variation_id='.$variation['variation_id'];
					foreach($variation['attributes'] as $key => $value){
					$cart_url = $cart_url.'&'.$key.'='.$value;
					}
					$cart_url_array[$variation['variation_id']] = $cart_url;
				}


				// Display Gift Course button for variable product
				echo '<input type="hidden" class="gift_course_cart_url" value="'.$cart_url.'"/>
				<a class="gift_course_button"  class="full button" data-from="'.__('Enter your email','wplms-gift').'" data-to="'.__('Enter gift email','wplms-gift').'" data-message="'.__('Enter message','wplms-gift').'" data-variation="'.__('Select Variation','wplms-gift').'" data-button="'.__('Send as Gift','wplms-gift').'" data-wooactive="'.$wplms_woo_active.'" data-course="'.$course_id.'" data-variation-cart-urls="'.$json_cart_url_array.'">'.__('Gift this course','wplms-gift').'</a>
				<script>

				var variation_cart_urls_json_'.$course_id.' = '.json_encode($cart_url_array).'
				</script>


				';

				//return $course_details;
			}
		}

			// Display Gift Course button for normal product
			echo '<input type="hidden" class="gift_course_cart_url" value="'.$cart_url.'"/>
			<a class="gift_course_button"  class="full button" data-from="'.__('Enter your email','wplms-gift').'" data-to="'.__('Enter gift email','wplms-gift').'" data-message="'.__('Enter message','wplms-gift').'" data-button="'.__('Send as Gift','wplms-gift').'">'.__('Gift this course','wplms-gift').'</a>';

			//return $course_details;
			}
    }

    function display_gift_course_button($course_details){
		$wplms_woo_active = 0;
        $active_plugins =get_option( 'active_plugins' );
        if ( (in_array( 'wplms-woocommerce/wplms-woocommerce.php', apply_filters( 'active_plugins', $active_plugins ) )) || (function_exists('is_plugin_active_for_network') && is_plugin_active_for_network( 'wplms-woocommerce/wplms-woocommerce.php'))){
        	$wplms_woo_active = 1;
        }
        /* We don't have this setting
		// Check LMS setting for non logged in users
		if(class_exists('WPLMS_tips')){
			$tips = WPLMS_tips::init();
			if(isset($tips) && isset($tips->settings) && !isset($tips->settings['enable_gift_button_for_non_loggedin_users'])){
				if(!is_user_logged_in()){
					return $course_details;
				}
			}
		}
		*/
		// Check if product is connected to the course
		global $post;
		if($post->post_type != 'course'){
            return $course_details;
        }

		$course_id = $post->ID;
		$product_id = get_post_meta($course_id,'vibe_product',true);
		if(empty($product_id) || !is_numeric($product_id)){

			// Check if course is free
			$free = get_post_meta($course_id,'vibe_course_free',true);
			if(function_exists('vibe_validate') && vibe_validate($free)){
				
				// Check LMS settings for free courses
				if(class_exists('WPLMS_tips')){
					$tips = WPLMS_tips::init();
					if(isset($tips) && isset($tips->settings) && !isset($tips->settings['enable_gift_button_for_free_courses'])){
						
						return $course_details;
					}
				}
				// Display Gift Course button for free course
				$course_details['gift_course'] = '<li class="gift_this_course"><input type="hidden" class="gift_course_id" value="'.$course_id.'"/><a class="gift_course_button"  class="full button" data-from="'.__('Enter your email','wplms-gift').'" data-to="'.__('Enter gift email','wplms-gift').'" data-message="'.__('Enter message','wplms-gift').'" data-free="1" data-button="'.__('Send as Gift','wplms-gift').'">'.__('Gift this course','wplms-gift').'</a></li>';

				return $course_details;
			}

			return $course_details;
		}

		global $woocommerce;
    	$cart_url = $woocommerce->cart->get_cart_url();
		echo '<div id="move_field_c"><input type="hidden" name="add-to-cart" value="'.$product_id.'" /></div>';

		// Check if product is variable
		$product = wc_get_product($product_id);
		if( empty($product) ){
			return $course_details;
		}

		if( $product->is_type( 'variable' )){
			if(!$wplms_woo_active)
				return $course_details;
			$cartUrl = $woocommerce->cart->get_cart_url();
            $variations = $product->get_available_variations();
            $cart_url_array = [];
            foreach($variations as $variation){
	            $cart_url = $cartUrl.'?add-to-cart='.$product_id.'&variation_id='.$variation['variation_id'];
	            foreach($variation['attributes'] as $key => $value){
	                $cart_url = $cart_url.'&'.$key.'='.$value;
	            }
	            $cart_url_array[$variation['variation_id']] = $cart_url;
	        }
	        

			// Display Gift Course button for variable product
			$course_details['gift_course'] = '<input type="hidden" class="gift_course_cart_url" value="'.$cart_url.'"/>
			<a class="gift_course_button"  class="full button" data-from="'.__('Enter your email','wplms-gift').'" data-to="'.__('Enter gift email','wplms-gift').'" data-message="'.__('Enter message','wplms-gift').'" data-variation="'.__('Select Variation','wplms-gift').'" data-button="'.__('Send as Gift','wplms-gift').'" data-wooactive="'.$wplms_woo_active.'" data-course="'.$course_id.'" data-variation-cart-urls="'.$json_cart_url_array.'">'.__('Gift this course','wplms-gift').'</a>
			<script>

			var variation_cart_urls_json_'.$course_id.' = '.json_encode($cart_url_array).'
			</script>


			';

			return $course_details;
		}

		// Display Gift Course button for normal product
		$course_details['gift_course'] = '<input type="hidden" class="gift_course_cart_url" value="'.$cart_url.'"/>
		<a class="gift_course_button"  class="full button" data-from="'.__('Enter your email','wplms-gift').'" data-to="'.__('Enter gift email','wplms-gift').'" data-message="'.__('Enter message','wplms-gift').'" data-button="'.__('Send as Gift','wplms-gift').'">'.__('Gift this course','wplms-gift').'</a>';

		return $course_details;
	}


    function add_gift_course_email($bp_course_mails){

		// Gift Course email and tokens added
		$bp_course_mails['wplms_gift_mail'] = array(
            'description'=> __('This course is a gift ','wplms-gift'),
            'subject' =>  sprintf(__('A gift from %s ','wplms-gift'),'{{gift_sender.name}}'),
            'message' =>  sprintf(__('I am gifting you course: %s Please click here: %s to go to the course and start the course. %s','wplms-gift'),'{{gift_course.name}}','{{{gift_course.giftlink}}}','{{gift_course.giftmessage}}')
        );

		$bp_course_mails['wplms_gift_received_mail'] = array(
			'description'=> __('The gifted course has been recieved by the user ','wplms-gift'),
            'subject' =>  sprintf(__('Gift course recevied by %s ','wplms-gift'),'{{gift_receiver.email}}'),
            'message' =>  sprintf(__('The %s course gifted to %s has been received','wplms-gift'),'{{gift_receiver.coursename}}','{{{gift_receiver.email}}}')
		);

		return $bp_course_mails;
	}



	function scripts(){

		$enqueue_script = false;
		if(function_exists('bp_is_user') && bp_is_user()){$enqueue_script = true;}
		if(apply_filters('vibebp_enqueue_profile_script',$enqueue_script)){

			$blog_id = '';
	        if(function_exists('get_current_blog_id')){
	            $blog_id = get_current_blog_id();
	        }

            
			$vibe_settings=apply_filters('vibeforms_gift_course_script_args',array(
				'label'=>__('Gift-Course','wplms-gift'),
				'parent_sidebar_id' => 'gift_sidebar',
				'settings'=>array(
	                'gifts_per_page'=>5,
	            ),
				'api'=>array(
	                'url'=>get_rest_url($blog_id,WPLMS_GIFT_COURSE_API_NAMESPACE),
	            ),
				'translations'=>array(
					'gift_course_label'=>__('Gift Course','wplms-gift'),
					'gifts_sent'=>__('Gifts Sent','wplms-gift'),
					'gifts_accepted'=>__('Gifts Accepted','wplms-gift'),
					'no_gifts_sent'=>__('No Gifts Sent','wplms-gift'),
					'no_gifts_accepted'=>__('No Gifts Accepted','wplms-gift'),
					'settings'=>__('Settings','wplms-gift'),
					'gifted_course'=>__('Gifted Course','wplms-gift'),
					'gift_user'=>__('Gift User','wplms-gift'),
					'order_status'=>__('Order Status','wplms-gift'),
					'gift_from'=>__('Gift From','wplms-gift'),
				)
			));


            /***********************Live**********************/
            
			wp_enqueue_script('wplmsgiftcoursejs',plugins_url('../assets/js/wplms-gift-course.js',__FILE__),array('wp-element','wp-data'),WPLMS_GIFT_COURSE_SCRIPT_VERSION,true);
			//wp_enqueue_script('wplmsgiftcoursejs-setting',plugins_url('../assets/js/wplms-gift-course-setting.js',__FILE__),array('wp-element','wp-data'),WPLMS_GIFT_COURSE_SCRIPT_VERSION,true);
            wp_localize_script('wplmsgiftcoursejs','wplmsgiftcoursejs',$vibe_settings);
            wp_enqueue_style('wplmsgiftcourse_css',plugins_url('../assets/css/wplms-gift-course.css',__FILE__),array(),WPLMS_GIFT_COURSE_SCRIPT_VERSION);
		}
	}
}

WPLMS_GIFT_COURSE_COMPONENT::init();