jQuery(document).ready(function($){

	//Widget Search
	$('#search_grade_book input').on('keyup',function(event){
		var $this = $(this);
		var value = $this.val();
		if( value.length >= 4 ){
			var post_type = $this.parent().parent().parent().find('li.active a').attr('data-post_type');

			//Add loading class on the table
			if( post_type == 'course' ){
				$('#tab-course').find('.grade_book_table').addClass('loading');
			}else if( post_type == 'wplms-assignment' ){
				$('#tab-assignment').find('.grade_book_table').addClass('loading');
			}else if( post_type == 'quiz' ){
				$('#tab-quiz').find('.grade_book_table').addClass('loading');
			}

			//Ajax Call
			$.ajax({
				type: "POST",
				url: ajaxurl,
				data: {
					action: 'wplms_grade_book_search',
					security: $('#search_security').val(),
					search: $this.val(),
					post_type: post_type,
				},
				cache: false,
				success: function (html) {
					if( post_type == 'course' ){
						$('#tab-course').find('.grade_book_table').html(html);
						$('#tab-course').find('.grade_book_table').removeClass('loading');
						$('#tab-course').find('.pagination').addClass('hide');
					}else if( post_type == 'wplms-assignment' ){
						$('#tab-assignment').find('.grade_book_table').html(html);
						$('#tab-assignment').find('.grade_book_table').removeClass('loading');
						$('#tab-assignment').find('.pagination').addClass('hide');
					}else if( post_type == 'quiz' ){
						$('#tab-quiz').find('.grade_book_table').html(html);
						$('#tab-quiz').find('.grade_book_table').removeClass('loading');
						$('#tab-quiz').find('.pagination').addClass('hide');
					}
					$('body').trigger('grade_book_search_results');
				}
			});
		}
	});

	$('#search_grade_book input').on('blur',function(event){
		var $this = $(this);
		var value = $this.val();
		if( value.length != 0 ){
			return;
		}
		var post_type = $this.parent().parent().parent().find('li.active a').attr('data-post_type');

		//Add loading class on the table
		if( post_type == 'course' ){
			$('#tab-course').find('.grade_book_table').addClass('loading');
		}else if( post_type == 'wplms-assignment' ){
			$('#tab-assignment').find('.grade_book_table').addClass('loading');
		}else if( post_type == 'quiz' ){
			$('#tab-quiz').find('.grade_book_table').addClass('loading');
		}

		//Ajax Call
		$.ajax({
			type: "POST",
			url: ajaxurl,
			data: {
				action: 'wplms_grade_book_search',
				security: $('#search_security').val(),
				search: '',
				post_type: post_type,
			},
			cache: false,
			success: function (html) {
				if( post_type == 'course' ){
					$('#tab-course').find('.grade_book_table').html(html);
					$('#tab-course').find('.grade_book_table').removeClass('loading');
					$('#tab-course').find('.pagination').removeClass('hide');
					$('#tab-course').find('.pagination').find('.grade_book_paged.current').removeClass('current');
					$('#tab-course').find('.pagination').find('.grade_book_paged[data-page="1"]').addClass('current');
				}else if( post_type == 'wplms-assignment' ){
					$('#tab-assignment').find('.grade_book_table').html(html);
					$('#tab-assignment').find('.grade_book_table').removeClass('loading');
					$('#tab-assignment').find('.pagination').removeClass('hide');
					$('#tab-assignment').find('.pagination').find('.grade_book_paged.current').removeClass('current');
					$('#tab-assignment').find('.pagination').find('.grade_book_paged[data-page="1"]').addClass('current');
				}else if( post_type == 'quiz' ){
					$('#tab-quiz').find('.grade_book_table').html(html);
					$('#tab-quiz').find('.grade_book_table').removeClass('loading');
					$('#tab-quiz').find('.pagination').removeClass('hide');
					$('#tab-quiz').find('.pagination').find('.grade_book_paged.current').removeClass('current');
					$('#tab-quiz').find('.pagination').find('.grade_book_paged[data-page="1"]').addClass('current');
				}
				$('body').trigger('grade_book_search_results');
			}
		});
	});

	//Pagination
	$('.grade_book_paged').on('click',function(event){
		event.preventDefault();
		var $this = $(this);
		var page = $this.attr('data-page');
		var post_type = $('#vibe-tabs-grade-book .nav-tabs').find('li.active a').attr('data-post_type');

		//Add loading class on the table
		if( post_type == 'course' ){
			$('#tab-course').find('.grade_book_table').addClass('loading');
		}else if( post_type == 'wplms-assignment' ){
			$('#tab-assignment').find('.grade_book_table').addClass('loading');
		}else if( post_type == 'quiz' ){
			$('#tab-quiz').find('.grade_book_table').addClass('loading');
		}

		//Ajax Call
		$.ajax({
			type: "POST",
			url: ajaxurl,
			data: {
				action: 'wplms_grade_book_search',
				security: $('#search_security').val(),
				search: '',
				post_type: post_type,
				page: page,
			},
			cache: false,
			success: function (html) {
				if( post_type == 'course' ){
					$('#tab-course').find('.grade_book_table').html(html);
					$('#tab-course').find('.grade_book_table').removeClass('loading');
					$('#tab-course').find('.pagination').removeClass('hide');
				}else if( post_type == 'wplms-assignment' ){
					$('#tab-assignment').find('.grade_book_table').html(html);
					$('#tab-assignment').find('.grade_book_table').removeClass('loading');
					$('#tab-assignment').find('.pagination').removeClass('hide');
				}else if( post_type == 'quiz' ){
					$('#tab-quiz').find('.grade_book_table').html(html);
					$('#tab-quiz').find('.grade_book_table').removeClass('loading');
					$('#tab-quiz').find('.pagination').removeClass('hide');
				}
				$this.parent().find('.current').removeClass('current');
				$this.addClass('current');
				$('body').trigger('grade_book_search_results');
			}
		});
	});

	//Update marks from the widget itself
	$('body').on('grade_book_search_results',function(){
		$('.marks').on('click',function(){
			var $this = $(this);
			if( $this.hasClass('hide') ){
				return;
			}
			var post_id = $this.attr('data-id');
			var user_id = $this.attr('data-user');
			var update_text = $this.attr('data-update');
			var cancle_text = $this.attr('data-cancle');
			var default_value = $this.text();
			default_value = parseInt(default_value);
			if( typeof(post_id) === 'undefined' || typeof(user_id) === 'undefined' ){
				return;
			}
			$this.after('<input type="number" class="user_marks_from_grade_book" value="'+default_value+'" /><a href="#" class="update_user_marks_from_grade_book button" data-id="'+post_id+'" data-user="'+user_id+'">'+update_text+'</a><a href="#" class="cancle_user_marks_from_grade_book button">'+cancle_text+'</a>');
			$this.addClass('hide');
			$('body').trigger('update_user_marks_from_grade_book');
		});
	});

	$('.marks').on('click',function(){
		var $this = $(this);
		if( $this.hasClass('hide') ){
			return;
		}
		var post_id = $this.attr('data-id');
		var user_id = $this.attr('data-user');
		var update_text = $this.attr('data-update');
		var cancle_text = $this.attr('data-cancle');
		var default_value = $this.text();
		default_value = parseInt(default_value);
		if( typeof(post_id) === 'undefined' || typeof(user_id) === 'undefined' ){
			return;
		}
		$this.after('<input type="number" class="user_marks_from_grade_book" value="'+default_value+'" /><a href="#" class="update_user_marks_from_grade_book button" data-id="'+post_id+'" data-user="'+user_id+'">'+update_text+'</a><a href="#" class="cancle_user_marks_from_grade_book button">'+cancle_text+'</a>');
		$this.addClass('hide');
		$('body').trigger('update_user_marks_from_grade_book');
	});

	$('body').on('update_user_marks_from_grade_book',function(){
		$('.update_user_marks_from_grade_book').on('click',function(event){
			event.preventDefault();
			var $this = $(this);
			if( $this.hasClass('loading') ){
				return;
			}
			$this.addClass('loading');
			var marks = $this.parent().find('.user_marks_from_grade_book').val();
			var post_id = $this.attr('data-id');
			var user_id = $this.attr('data-user');

			//Ajax Call
			$.ajax({
				type: "POST",
				url: ajaxurl,
				data: {
					action: 'wplms_update_user_marks_from_grade_book',
					security: $('#search_security').val(),
					marks: marks,
					post_id: post_id,
					user_id: user_id,
				},
				cache: false,
				success: function (html) {
					$this.removeClass('loading');
					$this.parent().find('.marks').text(marks);
					$this.parent().find('.marks').removeClass('hide');
					$this.parent().find('.marks').siblings().remove();
				}
			});
		});
		$('.cancle_user_marks_from_grade_book').on('click',function(event){
			event.preventDefault();
			var $this = $(this);
			$this.parent().find('.marks').removeClass('hide');
			$this.parent().find('.marks').siblings().remove();
		});
	});
});
