<?php

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

add_action( 'widgets_init', 'wplms_grade_book_instructor_widget' );

function wplms_grade_book_instructor_widget() {
  register_widget('wplms_instructor_grade_book_stats');
}

class wplms_instructor_grade_book_stats extends WP_Widget {

    /** constructor -- name this the same as the class above */
    function __construct() {
    $widget_ops = array( 'classname' => 'wplms_instructor_grade_book_stats', 'description' => __('Instructor Grade Book', 'wplms-gb') );
    $control_ops = array( 'width' => 300, 'height' => 350, 'id_base' => 'wplms_instructor_grade_book_stats' );
    parent::__construct( 'wplms_instructor_grade_book_stats', __(' DASHBOARD : Instructor Grade Book Widget', 'wplms-gb'), $widget_ops, $control_ops );
  }

    /** @see WP_Widget::widget -- do not rename this */
    function widget( $args, $instance ) {
    extract( $args );

    $title              = apply_filters('widget_title', $instance['title'] );
    $course             = $instance['course'];
    $assignment         = $instance['assignment'];
    $quiz               = $instance['quiz'];
    $width              = $instance['width'];
    $current_user_id    = get_current_user_id();
    $all_courses        = array();
    $all_users          = array();
    $all_courses_string = array();

    echo '<div class="'.$width.'">
            <div class="dash-widget">'.$before_widget;

    if ( $title )
      echo $before_title . $title . $after_title;

    // Pagination
    $limit = vibe_get_option('loop_number');
    if(empty($limit)) $limit = 5;
    $paged = $_POST['page'];
    
    if( empty($paged) ){
      $paged  = 1;
      $offset = 0;
    }else{
       $offset = ( $paged - 1 ) * $limit;
    }

    global $wpdb;
    $courses = $wpdb->get_results("SELECT ID FROM {$wpdb->posts} WHERE post_author = $current_user_id AND post_type = 'course'");

    if( !empty($courses) ){

      foreach ($courses as $c) {
        $all_courses[] = $c->ID;
        $all_courses_string[] = '"course_status'.$c->ID.'"';
      }

      $sql_ready_implode = implode(',', $all_courses_string);
      $sql_ready = '('.$sql_ready_implode.')';
      $total_query = "SELECT COUNT(DISTINCT user_id) FROM {$wpdb->usermeta} WHERE meta_key IN {$sql_ready} ";
      $user_query = "SELECT DISTINCT user_id FROM {$wpdb->usermeta} WHERE meta_key IN {$sql_ready} LIMIT $offset,$limit";

      $users = $wpdb->get_results($user_query);
      if ( !empty($users) ){
        foreach ($users as $user){
          $all_users[] = $user->user_id;
        }
      }
    }

    $max_page = $wpdb->get_var($total_query);
    if(empty($max_page)){$max_page = 1;}else{$max_page = ceil($max_page/$limit);}

    echo '<div id="vibe-tabs-grade-book" class="tabs tabbable">
            <ul class="nav nav-tabs clearfix">';

    // Tabs
    if(isset($course) && $course ){
      echo '<li><a href="#tab-course" data-toggle="tab" data-post_type="course">'.__('Courses','wplms-gb').'</a></li>';
    }
    if(isset($assignment) && $assignment ){
      echo '<li><a href="#tab-assignment" data-toggle="tab" data-post_type="wplms-assignment">'.__('Assignments','wplms-gb').'</a></li>';
    }
    if(isset($quiz) && $quiz ){
      echo '<li><a href="#tab-quiz" data-toggle="tab" data-post_type="quiz">'.__('Quizzes','wplms-gb').'</a></li>';
    }
    echo '<li class="search_widget">';
    echo '<span id="search_grade_book"><input type="text" name="search" placeholder="'.__('Enter Student Username/Email','wplms-gb').'" /></span>';
    echo '</li>';
    wp_nonce_field('wplms_grade_book_search_security','search_security');
    echo '</ul><div class="tab-content">';

    // Tabs Contents

    // Courses Content
    if(isset($course) && $course ){
      echo '<div id="tab-course" class="tab-pane">';

      //Create table for the all courses data.
      echo '<div class="grade_book_table">';
      echo '<table class="all_courses_grade_book_table">';
      echo '<tr>';
      echo '<th>'.__('Students','wplms-gb').'</th>';
      if( !empty($all_courses) ){
        foreach ($all_courses as $course_id) {
          echo '<th>'.get_the_title($course_id).'</th>';
        }
      }
      echo '</tr>';
      if( !empty($all_users) ){
        foreach ($all_users as $user_id) {
          echo '<tr>';
          echo '<td>'.bp_core_get_user_displayname( $user_id ).'</td>';
          if( !empty($all_courses) ){
            foreach ($all_courses as $course_id) {
              $marks = get_post_meta( $course_id,$user_id,true );
              if( empty($marks) ){
                echo '<td><span class="marks" data-id="'.$course_id.'" data-user="'.$user_id.'" data-update="'.__('Update','wplms-gb').'" data-cancle="'.__('Cancle','wplms-gb').'">'.__('N.A.','wplms-gb').'</span></td>';
              }else{
                echo '<td><span class="marks" data-id="'.$course_id.'" data-user="'.$user_id.'" data-update="'.__('Update','wplms-gb').'" data-cancle="'.__('Cancle','wplms-gb').'">'.$marks.'</span></td>';
              }
            }
          }
          echo '</tr>';
        }
      }
      echo '</table>';
      echo '</div>';

      //Pagination
      echo '<div class="pagination"><div><span id="grade_book_students" style="float:right;">'.__('Pages','wplms-gb').'</span>';

      echo '<div class="pagination-links">';
      $f = 1;
      if($max_page > 1){
          for($i=1;$i<=$max_page;$i++ ){
              if($i == $paged){
                  echo '<a class="page-numbers grade_book_paged current" data-page="'.$paged.'">'.$paged.'</a>';
              }else if(in_array($i,array($paged-1,$paged+1,1,$max_page))){
                  echo '<a class="page-numbers grade_book_paged" data-page="'.$i.'">'.$i.'</a>';
              }else if($f && ( $i > ($paged+1) || $i < ($paged-1))){
                  echo '<a class="page-numbers">...</a>'; 
                  $f=0;
              }
          }
      }
      echo '</div></div></div>';

      echo '</div>';
    }

    // Assignments Content
    if(isset($assignment) && $assignment ){

      // Get all assignments
      $assignments = $wpdb->get_results("SELECT ID FROM {$wpdb->posts} WHERE post_author = $current_user_id AND post_type = 'wplms-assignment'");

      // Tab content
      echo '<div id="tab-assignment" class="tab-pane">';

      //Create table for the all assignments data.
      echo '<div class="grade_book_table">';
      echo '<table class="all_assignments_grade_book_table">';
      echo '<tr>';
      echo '<th>'.__('Students','wplms-gb').'</th>';
      if( !empty($assignments) ){
        foreach ($assignments as $assignment) {
          echo '<th>'.get_the_title($assignment->ID).'</th>';
        }
      }
      echo '</tr>';
      if( !empty($all_users) ){
        foreach ($all_users as $user_id) {
          echo '<tr>';
          echo '<td>'.bp_core_get_user_displayname( $user_id ).'</td>';
          if( !empty($assignments) ){
            foreach ($assignments as $assignment) {
              $marks = get_post_meta( $assignment->ID,$user_id,true );
              if( empty($marks) ){
                echo '<td><span class="marks" data-id="'.$assignment->ID.'" data-user="'.$user_id.'" data-update="'.__('Update','wplms-gb').'" data-cancle="'.__('Cancle','wplms-gb').'">'.__('N.A.','wplms-gb').'</span></td>';
              }else{
                echo '<td><span class="marks" data-id="'.$assignment->ID.'" data-user="'.$user_id.'" data-update="'.__('Update','wplms-gb').'" data-cancle="'.__('Cancle','wplms-gb').'">'.$marks.'</span></td>';
              }
            }
          }
          echo '</tr>';
        }
      }
      echo '</table>';
      echo '</div>';

      //Pagination
      echo '<div class="pagination"><div><span id="grade_book_students" style="float:right;">'.__('Pages','wplms-gb').'</span>';

      echo '<div class="pagination-links">';
      $f = 1;
      if($max_page > 1){
          for($i=1;$i<=$max_page;$i++ ){
              if($i == $paged){
                  echo '<a class="page-numbers grade_book_paged current" data-page="'.$paged.'">'.$paged.'</a>';
              }else if(in_array($i,array($paged-1,$paged+1,1,$max_page))){
                  echo '<a class="page-numbers grade_book_paged" data-page="'.$i.'">'.$i.'</a>';
              }else if($f && ( $i > ($paged+1) || $i < ($paged-1))){
                  echo '<a class="page-numbers">...</a>'; 
                  $f=0;
              }
          }
      }
      echo '</div></div></div>';

      echo '</div>';
    }

    // Quizzes Content
    if(isset($quiz) && $quiz ){

      // Get all quizzes
      $quizzes = $wpdb->get_results("SELECT ID FROM {$wpdb->posts} WHERE post_author = $current_user_id AND post_type = 'quiz'");

      // Tab content
      echo '<div id="tab-quiz" class="tab-pane">';

      //Create table for the all quizzes data.
      echo '<div class="grade_book_table">';
      echo '<table class="all_quizzes_grade_book_table">';
      echo '<tr>';
      echo '<th>'.__('Students','wplms-gb').'</th>';
      if( !empty($quizzes) ){
        foreach ($quizzes as $quiz) {
          echo '<th>'.get_the_title($quiz->ID).'</th>';
        }
      }
      echo '</tr>';
      if( !empty($all_users) ){
        foreach ($all_users as $user_id) {
          echo '<tr>';
          echo '<td>'.bp_core_get_user_displayname( $user_id ).'</td>';
          if( !empty($quizzes) ){
            foreach ($quizzes as $quiz) {
              $marks = get_post_meta( $quiz->ID,$user_id,true );
              if( empty($marks) ){
                echo '<td><span class="marks" data-id="'.$quiz->ID.'" data-user="'.$user_id.'" data-update="'.__('Update','wplms-gb').'" data-cancle="'.__('Cancle','wplms-gb').'">'.__('N.A.','wplms-gb').'</span></td>';
              }else{
                echo '<td><span class="marks" data-id="'.$quiz->ID.'" data-user="'.$user_id.'" data-update="'.__('Update','wplms-gb').'" data-cancle="'.__('Cancle','wplms-gb').'">'.$marks.'</span></td>';
              }
            }
          }
          echo '</tr>';
        }
      }
      echo '</table>';
      echo '</div>';

      //Pagination
      echo '<div class="pagination"><div><span id="grade_book_students" style="float:right;">'.__('Pages','wplms-gb').'</span>';

      echo '<div class="pagination-links">';
      $f = 1;
      if($max_page > 1){
          for($i=1;$i<=$max_page;$i++ ){
              if($i == $paged){
                  echo '<a class="page-numbers grade_book_paged current" data-page="'.$paged.'">'.$paged.'</a>';
              }else if(in_array($i,array($paged-1,$paged+1,1,$max_page))){
                  echo '<a class="page-numbers grade_book_paged" data-page="'.$i.'">'.$i.'</a>';
              }else if($f && ( $i > ($paged+1) || $i < ($paged-1))){
                  echo '<a class="page-numbers">...</a>'; 
                  $f=0;
              }
          }
      }
      echo '</div></div></div>';

      echo '</div>';
    }

    echo '</div></div>';
    echo '</div></div>';
  }

    /** @see WP_Widget::update -- do not rename this */
    function update($new_instance, $old_instance) {   
      $instance               = $old_instance;
      $instance['title']      = strip_tags($new_instance['title']);
      $instance['course']     = strip_tags($new_instance['course']);
      $instance['assignment'] = strip_tags($new_instance['assignment']);
      $instance['quiz']       = strip_tags($new_instance['quiz']);
      $instance['width']      = $new_instance['width'];
      return $instance;
    }

    /** @see WP_Widget::form -- do not rename this */
    function form($instance) {  
        $defaults = array( 
                        'title'      => __('Grade Book','wplms-gb'),
                        'course'     => 1,
                        'assignment' => 1,
                        'quiz'       => 1,
                        'width'      => 'col-md-12'
                    );
        $instance   = wp_parse_args( (array) $instance, $defaults );
        $title      = esc_attr($instance['title']);
        $course     = esc_attr($instance['course']);
        $assignment = esc_attr($instance['assignment']);
        $quiz       = esc_attr($instance['quiz']);
        $width      = esc_attr($instance['width']);
        ?>
        <p>
          <label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:','wplms-gb'); ?></label> 
          <input class="regular_text" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" />
        </p>
        <p>
          <label for="all-courses-grade-book"><?php _e('Courses','wplms-gb'); ?> <input class="checkbox" id="<?php echo $this->get_field_id( 'course' ); ?>" name="<?php echo $this->get_field_name( 'course' ); ?>" type="checkbox" value="1"  <?php checked($course,1,true) ?>/></label>
        </p>
        <p>
          <label for="all-assignments-grade-book"><?php _e('Assignments','wplms-gb'); ?> <input class="checkbox" id="<?php echo $this->get_field_id( 'assignment' ); ?>" name="<?php echo $this->get_field_name( 'assignment' ); ?>" type="checkbox" value="1"  <?php checked($assignment,1,true) ?>/></label>
        </p>
        <p>
          <label for="all-quizzes-grade-book"><?php _e('Quizzes','wplms-gb'); ?> <input class="checkbox" id="<?php echo $this->get_field_id( 'quiz' ); ?>" name="<?php echo $this->get_field_name( 'quiz' ); ?>" type="checkbox" value="1"  <?php checked($quiz,1,true) ?>/></label>
        </p>
        <p>
          <label for="<?php echo $this->get_field_id('width'); ?>"><?php _e('Select Width','wplms-gb'); ?></label> 
          <select id="<?php echo $this->get_field_id('width'); ?>" name="<?php echo $this->get_field_name('width'); ?>">
            <option value="col-md-3 col-sm-6" <?php selected('col-md-3 col-sm-6',$width); ?>><?php _e('One Fourth','wplms-gb'); ?></option>
            <option value="col-md-4 col-sm-6" <?php selected('col-md-4 col-sm-6',$width); ?>><?php _e('One Third','wplms-gb'); ?></option>
            <option value="col-md-6 col-sm-12" <?php selected('col-md-6 col-sm-12',$width); ?>><?php _e('One Half','wplms-gb'); ?></option>
            <option value="col-md-8 col-sm-12" <?php selected('col-md-8 col-sm-12',$width); ?>><?php _e('Two Third','wplms-gb'); ?></option>
             <option value="col-md-8 col-sm-12" <?php selected('col-md-9 col-sm-12',$width); ?>><?php _e('Three Fourth','wplms-gb'); ?></option>
            <option value="col-md-12" <?php selected('col-md-12',$width); ?>><?php _e('Full','wplms-gb'); ?></option>
          </select>
        </p>
        <?php 
    }
} 
