<?php
/*
Plugin Name: Wplms Grade Book
Plugin URI: https://www.wplms.io
Description: An addon to enhance the wplms theme.
Version: 1.1
Author: Vibethemes
Author URI: http://www.vibethemes.com
Text Domain: wplms-gb
*/
/*
Copyright 2018  VibeThemes  (email : vibethemes@gmail.com)
*/

if ( ! defined( 'ABSPATH' ) ) {
    exit;
}

include_once 'includes/class.updater.php';
include_once 'includes/class.config.php';
include_once 'includes/class.init.php';
include_once 'includes/instructor_dashboard_widget.php';
include_once 'includes/grade_book_statistics.php';
if(!defined('WPLMS_GRADEBOOK_VERSION')){
    define('WPLMS_GRADEBOOK_VERSION','1.1');
}
// Add text domain
add_action('plugins_loaded','wplms_grade_book_translations');
function wplms_grade_book_translations(){
    $locale = apply_filters("plugin_locale", get_locale(), 'wplms-gb');
    $lang_dir = dirname( __FILE__ ) . '/languages/';
    $mofile        = sprintf( '%1$s-%2$s.mo', 'wplms-gb', $locale );
    $mofile_local  = $lang_dir . $mofile;
    $mofile_global = WP_LANG_DIR . '/plugins/' . $mofile;

    if ( file_exists( $mofile_global ) ) {
        load_textdomain( 'wplms-gb', $mofile_global );
    } else {
        load_textdomain( 'wplms-gb', $mofile_local );
    }  
}

function Wplms_Grade_Book_Plugin_updater() {
    $license_key = trim( get_option( 'wplms_grade_book_license_key' ) );
    $edd_updater = new Wplms_Grade_Book_Plugin_updater( 'https://wplms.io', __FILE__, array(
            'version'   => WPLMS_GRADEBOOK_VERSION,               
            'license'   => $license_key,        
            'item_name' => 'WPLMS GRADE BOOK',    
            'author'    => 'VibeThemes' 
        )
    );
}
add_action( 'admin_init', 'Wplms_Grade_Book_Plugin_updater', 0 );