<?php
/*
Plugin Name: Wplms SMS Notifications
Plugin URI: http://www.vibethemes.com
Description: Enable SMS notification feature
Version: 1.0
Author: VibeThemes
Author URI: http://www.VibeThemes.com/
License : GPLv2 or Later
*/


if ( ! defined( 'ABSPATH' ) ) exit;

if( !defined('WPLMS_SMS_NOTIFICATION_VERSION')){
    define('WPLMS_SMS_NOTIFICATION_VERSION','1.0');
}

if( !defined('WPLMS_SMS_NOTIFICATION_OPTION')){
    define('WPLMS_SMS_NOTIFICATION_OPTION','wplms-sms-notifications');
}

include_once('includes/class.settings.php');
include_once('includes/class.init.php');
include_once('includes/class.twilioapi.php');

add_action('plugins_loaded','wplms_sms_notifications_translations');
function wplms_sms_notifications_translations(){
    $locale = apply_filters("plugin_locale", get_locale(), 'wplms-sms-notifications');
    $lang_dir = dirname( __FILE__ ) . '/languages/';
    $mofile        = sprintf( '%1$s-%2$s.mo', 'wplms-sms-notifications', $locale );
    $mofile_local  = $lang_dir . $mofile;
    $mofile_global = WP_LANG_DIR . '/plugins/' . $mofile;

    if ( file_exists( $mofile_global ) ) {
        load_textdomain( 'wplms-sms-notifications', $mofile_global );
    } else {
        load_textdomain( 'wplms-sms-notifications', $mofile_local );
    }   
}
